# coding: utf-8

"""
AccessibleController.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AccessibleController(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AccessibleController - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tray_id': 'int',  # (required parameter)
            'slot': 'int',  # (required parameter)
            'sa_id': 'SAIdentifier',  # (required parameter)
            'this_controller': 'str',  # (required parameter)
            'all_controllers': 'list[str]'
        }

        self.attribute_map = {
            'tray_id': 'trayId',  # (required parameter)
            'slot': 'slot',  # (required parameter)
            'sa_id': 'saId',  # (required parameter)
            'this_controller': 'thisController',  # (required parameter)
            'all_controllers': 'allControllers'
        }

        self._tray_id = None
        self._slot = None
        self._sa_id = None
        self._this_controller = None
        self._all_controllers = None

    @property
    def tray_id(self):
        """
        Gets the tray_id of this AccessibleController.
        The ID value of the tray in which this controller resides.

        :return: The tray_id of this AccessibleController.
        :rtype: int
        :required/optional: required
        """
        return self._tray_id

    @tray_id.setter
    def tray_id(self, tray_id):
        """
        Sets the tray_id of this AccessibleController.
        The ID value of the tray in which this controller resides.

        :param tray_id: The tray_id of this AccessibleController.
        :type: int
        """
        self._tray_id = tray_id

    @property
    def slot(self):
        """
        Gets the slot of this AccessibleController.
        The slot within its tray where this controller resides.

        :return: The slot of this AccessibleController.
        :rtype: int
        :required/optional: required
        """
        return self._slot

    @slot.setter
    def slot(self, slot):
        """
        Sets the slot of this AccessibleController.
        The slot within its tray where this controller resides.

        :param slot: The slot of this AccessibleController.
        :type: int
        """
        self._slot = slot

    @property
    def sa_id(self):
        """
        Gets the sa_id of this AccessibleController.
        The world-wide unique identifier of the storage array in which this controller resides.

        :return: The sa_id of this AccessibleController.
        :rtype: SAIdentifier
        :required/optional: required
        """
        return self._sa_id

    @sa_id.setter
    def sa_id(self, sa_id):
        """
        Sets the sa_id of this AccessibleController.
        The world-wide unique identifier of the storage array in which this controller resides.

        :param sa_id: The sa_id of this AccessibleController.
        :type: SAIdentifier
        """
        self._sa_id = sa_id

    @property
    def this_controller(self):
        """
        Gets the this_controller of this AccessibleController.
        The SYMbol reference value that uniquely identifies this controller.

        :return: The this_controller of this AccessibleController.
        :rtype: str
        :required/optional: required
        """
        return self._this_controller

    @this_controller.setter
    def this_controller(self, this_controller):
        """
        Sets the this_controller of this AccessibleController.
        The SYMbol reference value that uniquely identifies this controller.

        :param this_controller: The this_controller of this AccessibleController.
        :type: str
        """
        self._this_controller = this_controller

    @property
    def all_controllers(self):
        """
        Gets the all_controllers of this AccessibleController.
        An array of SYMbol reference values for all of the controllers that are present in the storage array where this controller resides.

        :return: The all_controllers of this AccessibleController.
        :rtype: list[str]
        :required/optional: required
        """
        return self._all_controllers

    @all_controllers.setter
    def all_controllers(self, all_controllers):
        """
        Sets the all_controllers of this AccessibleController.
        An array of SYMbol reference values for all of the controllers that are present in the storage array where this controller resides.

        :param all_controllers: The all_controllers of this AccessibleController.
        :type: list[str]
        """
        self._all_controllers = all_controllers

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

