# coding: utf-8

"""
Alarm.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Alarm(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Alarm - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'alarm_ref': 'str',  # (required parameter)
            'physical_location': 'Location',  # (required parameter)
            'status': 'str',  # (required parameter)
            'is_manageable': 'bool',  # (required parameter)
            'rtr_attributes': 'RTRAttributes',  # (required parameter)
            'repair_policy': 'RepairPolicy'
        }

        self.attribute_map = {
            'alarm_ref': 'alarmRef',  # (required parameter)
            'physical_location': 'physicalLocation',  # (required parameter)
            'status': 'status',  # (required parameter)
            'is_manageable': 'isManageable',  # (required parameter)
            'rtr_attributes': 'rtrAttributes',  # (required parameter)
            'repair_policy': 'repairPolicy'
        }

        self._alarm_ref = None
        self._physical_location = None
        self._status = None
        self._is_manageable = None
        self._rtr_attributes = None
        self._repair_policy = None

    @property
    def alarm_ref(self):
        """
        Gets the alarm_ref of this Alarm.
        The reference for this physical alarm.

        :return: The alarm_ref of this Alarm.
        :rtype: str
        :required/optional: required
        """
        return self._alarm_ref

    @alarm_ref.setter
    def alarm_ref(self, alarm_ref):
        """
        Sets the alarm_ref of this Alarm.
        The reference for this physical alarm.

        :param alarm_ref: The alarm_ref of this Alarm.
        :type: str
        """
        self._alarm_ref = alarm_ref

    @property
    def physical_location(self):
        """
        Gets the physical_location of this Alarm.
        The location of the alarm. The parent reference in Location identifies the tray containing the alarm, and the position field is set to 1.

        :return: The physical_location of this Alarm.
        :rtype: Location
        :required/optional: required
        """
        return self._physical_location

    @physical_location.setter
    def physical_location(self, physical_location):
        """
        Sets the physical_location of this Alarm.
        The location of the alarm. The parent reference in Location identifies the tray containing the alarm, and the position field is set to 1.

        :param physical_location: The physical_location of this Alarm.
        :type: Location
        """
        self._physical_location = physical_location

    @property
    def status(self):
        """
        Gets the status of this Alarm.
        The operational status of the alarm.

        :return: The status of this Alarm.
        :rtype: str
        :required/optional: required
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this Alarm.
        The operational status of the alarm.

        :param status: The status of this Alarm.
        :type: str
        """
        allowed_values = ["unknown", "enabled", "disabled", "sounding", "muted", "removed", "__UNDEFINED"]
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status`, must be one of {0}"
                .format(allowed_values)
            )
        self._status = status

    @property
    def is_manageable(self):
        """
        Gets the is_manageable of this Alarm.
        True if the alarm is manageable using the setAlarm procedure.

        :return: The is_manageable of this Alarm.
        :rtype: bool
        :required/optional: required
        """
        return self._is_manageable

    @is_manageable.setter
    def is_manageable(self, is_manageable):
        """
        Sets the is_manageable of this Alarm.
        True if the alarm is manageable using the setAlarm procedure.

        :param is_manageable: The is_manageable of this Alarm.
        :type: bool
        """
        self._is_manageable = is_manageable

    @property
    def rtr_attributes(self):
        """
        Gets the rtr_attributes of this Alarm.
        The CRU type of the alarm plus its ready-to-remove attributes, which are based on the CRU type

        :return: The rtr_attributes of this Alarm.
        :rtype: RTRAttributes
        :required/optional: required
        """
        return self._rtr_attributes

    @rtr_attributes.setter
    def rtr_attributes(self, rtr_attributes):
        """
        Sets the rtr_attributes of this Alarm.
        The CRU type of the alarm plus its ready-to-remove attributes, which are based on the CRU type

        :param rtr_attributes: The rtr_attributes of this Alarm.
        :type: RTRAttributes
        """
        self._rtr_attributes = rtr_attributes

    @property
    def repair_policy(self):
        """
        Gets the repair_policy of this Alarm.
        The repair policy for the alarm component.

        :return: The repair_policy of this Alarm.
        :rtype: RepairPolicy
        :required/optional: required
        """
        return self._repair_policy

    @repair_policy.setter
    def repair_policy(self, repair_policy):
        """
        Sets the repair_policy of this Alarm.
        The repair policy for the alarm component.

        :param repair_policy: The repair_policy of this Alarm.
        :type: RepairPolicy
        """
        self._repair_policy = repair_policy

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

