# coding: utf-8

"""
ApplicationAwarenessBundle.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ApplicationAwarenessBundle(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ApplicationAwarenessBundle - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'key_value_tag': 'list[KeyValueTag]',  # (required parameter)
            'key_value_tag_mapping': 'list[KeyValueTagMapping]',  # (required parameter)
            'workload': 'list[Workload]',  # (required parameter)
            'workload_volume_mapping': 'list[WorkloadVolumeMapping]'
        }

        self.attribute_map = {
            'key_value_tag': 'keyValueTag',  # (required parameter)
            'key_value_tag_mapping': 'keyValueTagMapping',  # (required parameter)
            'workload': 'workload',  # (required parameter)
            'workload_volume_mapping': 'workloadVolumeMapping'
        }

        self._key_value_tag = None
        self._key_value_tag_mapping = None
        self._workload = None
        self._workload_volume_mapping = None

    @property
    def key_value_tag(self):
        """
        Gets the key_value_tag of this ApplicationAwarenessBundle.
        This is an array of elements that report the a key-value tag and its reference.

        :return: The key_value_tag of this ApplicationAwarenessBundle.
        :rtype: list[KeyValueTag]
        :required/optional: required
        """
        return self._key_value_tag

    @key_value_tag.setter
    def key_value_tag(self, key_value_tag):
        """
        Sets the key_value_tag of this ApplicationAwarenessBundle.
        This is an array of elements that report the a key-value tag and its reference.

        :param key_value_tag: The key_value_tag of this ApplicationAwarenessBundle.
        :type: list[KeyValueTag]
        """
        self._key_value_tag = key_value_tag

    @property
    def key_value_tag_mapping(self):
        """
        Gets the key_value_tag_mapping of this ApplicationAwarenessBundle.
        This element is an array of the mappings (using references) between a key-value tag and a volume.

        :return: The key_value_tag_mapping of this ApplicationAwarenessBundle.
        :rtype: list[KeyValueTagMapping]
        :required/optional: required
        """
        return self._key_value_tag_mapping

    @key_value_tag_mapping.setter
    def key_value_tag_mapping(self, key_value_tag_mapping):
        """
        Sets the key_value_tag_mapping of this ApplicationAwarenessBundle.
        This element is an array of the mappings (using references) between a key-value tag and a volume.

        :param key_value_tag_mapping: The key_value_tag_mapping of this ApplicationAwarenessBundle.
        :type: list[KeyValueTagMapping]
        """
        self._key_value_tag_mapping = key_value_tag_mapping

    @property
    def workload(self):
        """
        Gets the workload of this ApplicationAwarenessBundle.
        This is an array of elements that reports Workload references.

        :return: The workload of this ApplicationAwarenessBundle.
        :rtype: list[Workload]
        :required/optional: required
        """
        return self._workload

    @workload.setter
    def workload(self, workload):
        """
        Sets the workload of this ApplicationAwarenessBundle.
        This is an array of elements that reports Workload references.

        :param workload: The workload of this ApplicationAwarenessBundle.
        :type: list[Workload]
        """
        self._workload = workload

    @property
    def workload_volume_mapping(self):
        """
        Gets the workload_volume_mapping of this ApplicationAwarenessBundle.
        This is an array of elements that report the mapping between workloads and volumes.

        :return: The workload_volume_mapping of this ApplicationAwarenessBundle.
        :rtype: list[WorkloadVolumeMapping]
        :required/optional: required
        """
        return self._workload_volume_mapping

    @workload_volume_mapping.setter
    def workload_volume_mapping(self, workload_volume_mapping):
        """
        Sets the workload_volume_mapping of this ApplicationAwarenessBundle.
        This is an array of elements that report the mapping between workloads and volumes.

        :param workload_volume_mapping: The workload_volume_mapping of this ApplicationAwarenessBundle.
        :type: list[WorkloadVolumeMapping]
        """
        self._workload_volume_mapping = workload_volume_mapping

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

