# coding: utf-8

"""
AsyncMirrorGroupInitialSyncOperation.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupInitialSyncOperation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupInitialSyncOperation - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'group_percent_complete': 'int',  # (required parameter)
            'group_time_to_completion': 'int',  # (required parameter)
            'group_sync_bytes': 'int',  # (required parameter)
            'group_ref': 'str',  # (required parameter)
            'member_progress': 'list[AsyncMirrorGroupMemberInitialSyncOperation]'
        }

        self.attribute_map = {
            'group_percent_complete': 'groupPercentComplete',  # (required parameter)
            'group_time_to_completion': 'groupTimeToCompletion',  # (required parameter)
            'group_sync_bytes': 'groupSyncBytes',  # (required parameter)
            'group_ref': 'groupRef',  # (required parameter)
            'member_progress': 'memberProgress'
        }

        self._group_percent_complete = None
        self._group_time_to_completion = None
        self._group_sync_bytes = None
        self._group_ref = None
        self._member_progress = None

    @property
    def group_percent_complete(self):
        """
        Gets the group_percent_complete of this AsyncMirrorGroupInitialSyncOperation.
        Completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING.

        :return: The group_percent_complete of this AsyncMirrorGroupInitialSyncOperation.
        :rtype: int
        :required/optional: required
        """
        return self._group_percent_complete

    @group_percent_complete.setter
    def group_percent_complete(self, group_percent_complete):
        """
        Sets the group_percent_complete of this AsyncMirrorGroupInitialSyncOperation.
        Completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING.

        :param group_percent_complete: The group_percent_complete of this AsyncMirrorGroupInitialSyncOperation.
        :type: int
        """
        self._group_percent_complete = group_percent_complete

    @property
    def group_time_to_completion(self):
        """
        Gets the group_time_to_completion of this AsyncMirrorGroupInitialSyncOperation.
        The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN.

        :return: The group_time_to_completion of this AsyncMirrorGroupInitialSyncOperation.
        :rtype: int
        :required/optional: required
        """
        return self._group_time_to_completion

    @group_time_to_completion.setter
    def group_time_to_completion(self, group_time_to_completion):
        """
        Sets the group_time_to_completion of this AsyncMirrorGroupInitialSyncOperation.
        The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN.

        :param group_time_to_completion: The group_time_to_completion of this AsyncMirrorGroupInitialSyncOperation.
        :type: int
        """
        self._group_time_to_completion = group_time_to_completion

    @property
    def group_sync_bytes(self):
        """
        Gets the group_sync_bytes of this AsyncMirrorGroupInitialSyncOperation.
        The amount of data that remains to be synchronized.

        :return: The group_sync_bytes of this AsyncMirrorGroupInitialSyncOperation.
        :rtype: int
        :required/optional: required
        """
        return self._group_sync_bytes

    @group_sync_bytes.setter
    def group_sync_bytes(self, group_sync_bytes):
        """
        Sets the group_sync_bytes of this AsyncMirrorGroupInitialSyncOperation.
        The amount of data that remains to be synchronized.

        :param group_sync_bytes: The group_sync_bytes of this AsyncMirrorGroupInitialSyncOperation.
        :type: int
        """
        self._group_sync_bytes = group_sync_bytes

    @property
    def group_ref(self):
        """
        Gets the group_ref of this AsyncMirrorGroupInitialSyncOperation.
        A reference to the async mirror group..

        :return: The group_ref of this AsyncMirrorGroupInitialSyncOperation.
        :rtype: str
        :required/optional: required
        """
        return self._group_ref

    @group_ref.setter
    def group_ref(self, group_ref):
        """
        Sets the group_ref of this AsyncMirrorGroupInitialSyncOperation.
        A reference to the async mirror group..

        :param group_ref: The group_ref of this AsyncMirrorGroupInitialSyncOperation.
        :type: str
        """
        self._group_ref = group_ref

    @property
    def member_progress(self):
        """
        Gets the member_progress of this AsyncMirrorGroupInitialSyncOperation.
        A list of members still in initial sync and the respective progress of each.

        :return: The member_progress of this AsyncMirrorGroupInitialSyncOperation.
        :rtype: list[AsyncMirrorGroupMemberInitialSyncOperation]
        :required/optional: required
        """
        return self._member_progress

    @member_progress.setter
    def member_progress(self, member_progress):
        """
        Sets the member_progress of this AsyncMirrorGroupInitialSyncOperation.
        A list of members still in initial sync and the respective progress of each.

        :param member_progress: The member_progress of this AsyncMirrorGroupInitialSyncOperation.
        :type: list[AsyncMirrorGroupMemberInitialSyncOperation]
        """
        self._member_progress = member_progress

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

