# coding: utf-8

"""
AsyncMirrorGroupMemberInitialSyncOperation.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupMemberInitialSyncOperation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupMemberInitialSyncOperation - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'percent_complete': 'int',  # (required parameter)
            'time_to_completion': 'int',  # (required parameter)
            'sync_bytes': 'int',  # (required parameter)
            'mirror_member_ref': 'str'
        }

        self.attribute_map = {
            'percent_complete': 'percentComplete',  # (required parameter)
            'time_to_completion': 'timeToCompletion',  # (required parameter)
            'sync_bytes': 'syncBytes',  # (required parameter)
            'mirror_member_ref': 'mirrorMemberRef'
        }

        self._percent_complete = None
        self._time_to_completion = None
        self._sync_bytes = None
        self._mirror_member_ref = None

    @property
    def percent_complete(self):
        """
        Gets the percent_complete of this AsyncMirrorGroupMemberInitialSyncOperation.
        The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING.

        :return: The percent_complete of this AsyncMirrorGroupMemberInitialSyncOperation.
        :rtype: int
        :required/optional: required
        """
        return self._percent_complete

    @percent_complete.setter
    def percent_complete(self, percent_complete):
        """
        Sets the percent_complete of this AsyncMirrorGroupMemberInitialSyncOperation.
        The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING.

        :param percent_complete: The percent_complete of this AsyncMirrorGroupMemberInitialSyncOperation.
        :type: int
        """
        self._percent_complete = percent_complete

    @property
    def time_to_completion(self):
        """
        Gets the time_to_completion of this AsyncMirrorGroupMemberInitialSyncOperation.
        The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN.

        :return: The time_to_completion of this AsyncMirrorGroupMemberInitialSyncOperation.
        :rtype: int
        :required/optional: required
        """
        return self._time_to_completion

    @time_to_completion.setter
    def time_to_completion(self, time_to_completion):
        """
        Sets the time_to_completion of this AsyncMirrorGroupMemberInitialSyncOperation.
        The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN.

        :param time_to_completion: The time_to_completion of this AsyncMirrorGroupMemberInitialSyncOperation.
        :type: int
        """
        self._time_to_completion = time_to_completion

    @property
    def sync_bytes(self):
        """
        Gets the sync_bytes of this AsyncMirrorGroupMemberInitialSyncOperation.
        The amount of data that remains to be synchronized.

        :return: The sync_bytes of this AsyncMirrorGroupMemberInitialSyncOperation.
        :rtype: int
        :required/optional: required
        """
        return self._sync_bytes

    @sync_bytes.setter
    def sync_bytes(self, sync_bytes):
        """
        Sets the sync_bytes of this AsyncMirrorGroupMemberInitialSyncOperation.
        The amount of data that remains to be synchronized.

        :param sync_bytes: The sync_bytes of this AsyncMirrorGroupMemberInitialSyncOperation.
        :type: int
        """
        self._sync_bytes = sync_bytes

    @property
    def mirror_member_ref(self):
        """
        Gets the mirror_member_ref of this AsyncMirrorGroupMemberInitialSyncOperation.
        A reference to the async mirror group.

        :return: The mirror_member_ref of this AsyncMirrorGroupMemberInitialSyncOperation.
        :rtype: str
        :required/optional: required
        """
        return self._mirror_member_ref

    @mirror_member_ref.setter
    def mirror_member_ref(self, mirror_member_ref):
        """
        Sets the mirror_member_ref of this AsyncMirrorGroupMemberInitialSyncOperation.
        A reference to the async mirror group.

        :param mirror_member_ref: The mirror_member_ref of this AsyncMirrorGroupMemberInitialSyncOperation.
        :type: str
        """
        self._mirror_member_ref = mirror_member_ref

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

