# coding: utf-8

"""
AsyncMirrorSyncStatisticsSample.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorSyncStatisticsSample(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorSyncStatisticsSample - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'sample_role': 'str',  # (required parameter)
            'primary_sample': 'AsyncMirrorPrimarySyncStatisticsSample'
        }

        self.attribute_map = {
            'sample_role': 'sampleRole',  # (required parameter)
            'primary_sample': 'primarySample'
        }

        self._sample_role = None
        self._primary_sample = None

    @property
    def sample_role(self):
        """
        Gets the sample_role of this AsyncMirrorSyncStatisticsSample.
        This enumeration is used to indicate mirror group roles.

        :return: The sample_role of this AsyncMirrorSyncStatisticsSample.
        :rtype: str
        :required/optional: required
        """
        return self._sample_role

    @sample_role.setter
    def sample_role(self, sample_role):
        """
        Sets the sample_role of this AsyncMirrorSyncStatisticsSample.
        This enumeration is used to indicate mirror group roles.

        :param sample_role: The sample_role of this AsyncMirrorSyncStatisticsSample.
        :type: str
        """
        allowed_values = ["unknown", "primary", "secondary", "__UNDEFINED"]
        if sample_role not in allowed_values:
            raise ValueError(
                "Invalid value for `sample_role`, must be one of {0}"
                .format(allowed_values)
            )
        self._sample_role = sample_role

    @property
    def primary_sample(self):
        """
        Gets the primary_sample of this AsyncMirrorSyncStatisticsSample.
        This field is returned if the value of sampleRole is equal to ASYNC_MIRROR_GROUP_ROLE_PRIMARY.

        :return: The primary_sample of this AsyncMirrorSyncStatisticsSample.
        :rtype: AsyncMirrorPrimarySyncStatisticsSample
        :required/optional: optional
        """
        return self._primary_sample

    @primary_sample.setter
    def primary_sample(self, primary_sample):
        """
        Sets the primary_sample of this AsyncMirrorSyncStatisticsSample.
        This field is returned if the value of sampleRole is equal to ASYNC_MIRROR_GROUP_ROLE_PRIMARY.

        :param primary_sample: The primary_sample of this AsyncMirrorSyncStatisticsSample.
        :type: AsyncMirrorPrimarySyncStatisticsSample
        """
        self._primary_sample = primary_sample

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

