# coding: utf-8

"""
AutoLoadBalanceStatsLogRetrieveChunkDetails.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AutoLoadBalanceStatsLogRetrieveChunkDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AutoLoadBalanceStatsLogRetrieveChunkDetails - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'data_start_time': 'int',  # (required parameter)
            'auto_load_balance_stats_log_data': 'str'
        }

        self.attribute_map = {
            'data_start_time': 'dataStartTime',  # (required parameter)
            'auto_load_balance_stats_log_data': 'autoLoadBalanceStatsLogData'
        }

        self._data_start_time = None
        self._auto_load_balance_stats_log_data = None

    @property
    def data_start_time(self):
        """
        Gets the data_start_time of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        Start time of the log statistics being returned in seconds since midnight 1/1/1970.

        :return: The data_start_time of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        :rtype: int
        :required/optional: required
        """
        return self._data_start_time

    @data_start_time.setter
    def data_start_time(self, data_start_time):
        """
        Sets the data_start_time of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        Start time of the log statistics being returned in seconds since midnight 1/1/1970.

        :param data_start_time: The data_start_time of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        :type: int
        """
        self._data_start_time = data_start_time

    @property
    def auto_load_balance_stats_log_data(self):
        """
        Gets the auto_load_balance_stats_log_data of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        Statistics log raw data to be returned.

        :return: The auto_load_balance_stats_log_data of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        :rtype: str
        :required/optional: required
        """
        return self._auto_load_balance_stats_log_data

    @auto_load_balance_stats_log_data.setter
    def auto_load_balance_stats_log_data(self, auto_load_balance_stats_log_data):
        """
        Sets the auto_load_balance_stats_log_data of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        Statistics log raw data to be returned.

        :param auto_load_balance_stats_log_data: The auto_load_balance_stats_log_data of this AutoLoadBalanceStatsLogRetrieveChunkDetails.
        :type: str
        """
        self._auto_load_balance_stats_log_data = auto_load_balance_stats_log_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

