# coding: utf-8

"""
BatteryPackICCFailure.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class BatteryPackICCFailure(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        BatteryPackICCFailure - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'controller_a_ref': 'str',  # (required parameter)
            'controller_b_ref': 'str',  # (required parameter)
            'support_crua_ref': 'str',  # (required parameter)
            'support_crub_ref': 'str',  # (required parameter)
            'battery_pack_ref': 'str'
        }

        self.attribute_map = {
            'controller_a_ref': 'controllerARef',  # (required parameter)
            'controller_b_ref': 'controllerBRef',  # (required parameter)
            'support_crua_ref': 'supportCRUARef',  # (required parameter)
            'support_crub_ref': 'supportCRUBRef',  # (required parameter)
            'battery_pack_ref': 'batteryPackRef'
        }

        self._controller_a_ref = None
        self._controller_b_ref = None
        self._support_crua_ref = None
        self._support_crub_ref = None
        self._battery_pack_ref = None

    @property
    def controller_a_ref(self):
        """
        Gets the controller_a_ref of this BatteryPackICCFailure.
        This field is present when the voltage regulator has failed in the battery pack associated with controller A.

        :return: The controller_a_ref of this BatteryPackICCFailure.
        :rtype: str
        :required/optional: required
        """
        return self._controller_a_ref

    @controller_a_ref.setter
    def controller_a_ref(self, controller_a_ref):
        """
        Sets the controller_a_ref of this BatteryPackICCFailure.
        This field is present when the voltage regulator has failed in the battery pack associated with controller A.

        :param controller_a_ref: The controller_a_ref of this BatteryPackICCFailure.
        :type: str
        """
        self._controller_a_ref = controller_a_ref

    @property
    def controller_b_ref(self):
        """
        Gets the controller_b_ref of this BatteryPackICCFailure.
        This field is present when the voltage regulator has failed in the battery pack associated with controller B.

        :return: The controller_b_ref of this BatteryPackICCFailure.
        :rtype: str
        :required/optional: required
        """
        return self._controller_b_ref

    @controller_b_ref.setter
    def controller_b_ref(self, controller_b_ref):
        """
        Sets the controller_b_ref of this BatteryPackICCFailure.
        This field is present when the voltage regulator has failed in the battery pack associated with controller B.

        :param controller_b_ref: The controller_b_ref of this BatteryPackICCFailure.
        :type: str
        """
        self._controller_b_ref = controller_b_ref

    @property
    def support_crua_ref(self):
        """
        Gets the support_crua_ref of this BatteryPackICCFailure.
        This field is present when the charger has failed in the battery pack associated with support CRU A.

        :return: The support_crua_ref of this BatteryPackICCFailure.
        :rtype: str
        :required/optional: required
        """
        return self._support_crua_ref

    @support_crua_ref.setter
    def support_crua_ref(self, support_crua_ref):
        """
        Sets the support_crua_ref of this BatteryPackICCFailure.
        This field is present when the charger has failed in the battery pack associated with support CRU A.

        :param support_crua_ref: The support_crua_ref of this BatteryPackICCFailure.
        :type: str
        """
        self._support_crua_ref = support_crua_ref

    @property
    def support_crub_ref(self):
        """
        Gets the support_crub_ref of this BatteryPackICCFailure.
        This field is present when the charger has failed in the battery pack associated with support CRU B.

        :return: The support_crub_ref of this BatteryPackICCFailure.
        :rtype: str
        :required/optional: required
        """
        return self._support_crub_ref

    @support_crub_ref.setter
    def support_crub_ref(self, support_crub_ref):
        """
        Sets the support_crub_ref of this BatteryPackICCFailure.
        This field is present when the charger has failed in the battery pack associated with support CRU B.

        :param support_crub_ref: The support_crub_ref of this BatteryPackICCFailure.
        :type: str
        """
        self._support_crub_ref = support_crub_ref

    @property
    def battery_pack_ref(self):
        """
        Gets the battery_pack_ref of this BatteryPackICCFailure.
        This field is present for all battery pack failures except for a voltage regulator or charger failure. This field contains a reference to the battery pack that has failed.

        :return: The battery_pack_ref of this BatteryPackICCFailure.
        :rtype: str
        :required/optional: required
        """
        return self._battery_pack_ref

    @battery_pack_ref.setter
    def battery_pack_ref(self, battery_pack_ref):
        """
        Sets the battery_pack_ref of this BatteryPackICCFailure.
        This field is present for all battery pack failures except for a voltage regulator or charger failure. This field contains a reference to the battery pack that has failed.

        :param battery_pack_ref: The battery_pack_ref of this BatteryPackICCFailure.
        :type: str
        """
        self._battery_pack_ref = battery_pack_ref

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

