# coding: utf-8

"""
ChannelDiagWrRdVfyParams.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ChannelDiagWrRdVfyParams(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChannelDiagWrRdVfyParams - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'iterations_per_device': 'int',  # (required parameter)
            'maximum_errors_allowed': 'int',  # (required parameter)
            'data_pattern_option': 'ChannelDiagDataPatternTypeData'
        }

        self.attribute_map = {
            'iterations_per_device': 'iterationsPerDevice',  # (required parameter)
            'maximum_errors_allowed': 'maximumErrorsAllowed',  # (required parameter)
            'data_pattern_option': 'dataPatternOption'
        }

        self._iterations_per_device = None
        self._maximum_errors_allowed = None
        self._data_pattern_option = None

    @property
    def iterations_per_device(self):
        """
        Gets the iterations_per_device of this ChannelDiagWrRdVfyParams.
        The number of test iterations to perform on a selected device.

        :return: The iterations_per_device of this ChannelDiagWrRdVfyParams.
        :rtype: int
        :required/optional: required
        """
        return self._iterations_per_device

    @iterations_per_device.setter
    def iterations_per_device(self, iterations_per_device):
        """
        Sets the iterations_per_device of this ChannelDiagWrRdVfyParams.
        The number of test iterations to perform on a selected device.

        :param iterations_per_device: The iterations_per_device of this ChannelDiagWrRdVfyParams.
        :type: int
        """
        self._iterations_per_device = iterations_per_device

    @property
    def maximum_errors_allowed(self):
        """
        Gets the maximum_errors_allowed of this ChannelDiagWrRdVfyParams.
        The maximum number of errors that can be tolerated before canceling the test and proceeding on to the next selected device.

        :return: The maximum_errors_allowed of this ChannelDiagWrRdVfyParams.
        :rtype: int
        :required/optional: required
        """
        return self._maximum_errors_allowed

    @maximum_errors_allowed.setter
    def maximum_errors_allowed(self, maximum_errors_allowed):
        """
        Sets the maximum_errors_allowed of this ChannelDiagWrRdVfyParams.
        The maximum number of errors that can be tolerated before canceling the test and proceeding on to the next selected device.

        :param maximum_errors_allowed: The maximum_errors_allowed of this ChannelDiagWrRdVfyParams.
        :type: int
        """
        self._maximum_errors_allowed = maximum_errors_allowed

    @property
    def data_pattern_option(self):
        """
        Gets the data_pattern_option of this ChannelDiagWrRdVfyParams.
        The selected data pattern option.

        :return: The data_pattern_option of this ChannelDiagWrRdVfyParams.
        :rtype: ChannelDiagDataPatternTypeData
        :required/optional: required
        """
        return self._data_pattern_option

    @data_pattern_option.setter
    def data_pattern_option(self, data_pattern_option):
        """
        Sets the data_pattern_option of this ChannelDiagWrRdVfyParams.
        The selected data pattern option.

        :param data_pattern_option: The data_pattern_option of this ChannelDiagWrRdVfyParams.
        :type: ChannelDiagDataPatternTypeData
        """
        self._data_pattern_option = data_pattern_option

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

