# coding: utf-8

"""
ChannelPorts.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ChannelPorts(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChannelPorts - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'speed_det_error': 'bool',  # (required parameter)
            'manually_bypassed': 'bool',  # (required parameter)
            'port_number': 'str'
        }

        self.attribute_map = {
            'speed_det_error': 'speedDetError',  # (required parameter)
            'manually_bypassed': 'manuallyBypassed',  # (required parameter)
            'port_number': 'portNumber'
        }

        self._speed_det_error = None
        self._manually_bypassed = None
        self._port_number = None

    @property
    def speed_det_error(self):
        """
        Gets the speed_det_error of this ChannelPorts.
        This is set to true only if speed detection has failed.

        :return: The speed_det_error of this ChannelPorts.
        :rtype: bool
        :required/optional: required
        """
        return self._speed_det_error

    @speed_det_error.setter
    def speed_det_error(self, speed_det_error):
        """
        Sets the speed_det_error of this ChannelPorts.
        This is set to true only if speed detection has failed.

        :param speed_det_error: The speed_det_error of this ChannelPorts.
        :type: bool
        """
        self._speed_det_error = speed_det_error

    @property
    def manually_bypassed(self):
        """
        Gets the manually_bypassed of this ChannelPorts.
        This is set to true if the port is bypassed.

        :return: The manually_bypassed of this ChannelPorts.
        :rtype: bool
        :required/optional: required
        """
        return self._manually_bypassed

    @manually_bypassed.setter
    def manually_bypassed(self, manually_bypassed):
        """
        Sets the manually_bypassed of this ChannelPorts.
        This is set to true if the port is bypassed.

        :param manually_bypassed: The manually_bypassed of this ChannelPorts.
        :type: bool
        """
        self._manually_bypassed = manually_bypassed

    @property
    def port_number(self):
        """
        Gets the port_number of this ChannelPorts.
        This is the ChannelPort port number, 1 based.

        :return: The port_number of this ChannelPorts.
        :rtype: str
        :required/optional: required
        """
        return self._port_number

    @port_number.setter
    def port_number(self, port_number):
        """
        Sets the port_number of this ChannelPorts.
        This is the ChannelPort port number, 1 based.

        :param port_number: The port_number of this ChannelPorts.
        :type: str
        """
        allowed_values = ["portUnknown", "port1", "port2", "port3", "port4", "__UNDEFINED"]
        if port_number not in allowed_values:
            raise ValueError(
                "Invalid value for `port_number`, must be one of {0}"
                .format(allowed_values)
            )
        self._port_number = port_number

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

