# coding: utf-8

"""
ControllerSFP.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ControllerSFP(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ControllerSFP - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'controller_sfp_type': 'str',  # (required parameter)
            'parent_controller': 'str',  # (required parameter)
            'channel': 'int',  # (required parameter)
            'reserved1': 'str',  
            'reserved2': 'str'
        }

        self.attribute_map = {
            'controller_sfp_type': 'controllerSFPType',  # (required parameter)
            'parent_controller': 'parentController',  # (required parameter)
            'channel': 'channel',  # (required parameter)
            'reserved1': 'reserved1',  
            'reserved2': 'reserved2'
        }

        self._controller_sfp_type = None
        self._parent_controller = None
        self._channel = None
        self._reserved1 = None
        self._reserved2 = None

    @property
    def controller_sfp_type(self):
        """
        Gets the controller_sfp_type of this ControllerSFP.
        The interface (host/drive) to which the SFP belongs.

        :return: The controller_sfp_type of this ControllerSFP.
        :rtype: str
        :required/optional: required
        """
        return self._controller_sfp_type

    @controller_sfp_type.setter
    def controller_sfp_type(self, controller_sfp_type):
        """
        Sets the controller_sfp_type of this ControllerSFP.
        The interface (host/drive) to which the SFP belongs.

        :param controller_sfp_type: The controller_sfp_type of this ControllerSFP.
        :type: str
        """
        allowed_values = ["hostside", "driveside", "__UNDEFINED"]
        if controller_sfp_type not in allowed_values:
            raise ValueError(
                "Invalid value for `controller_sfp_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._controller_sfp_type = controller_sfp_type

    @property
    def parent_controller(self):
        """
        Gets the parent_controller of this ControllerSFP.
        The controller to which the SFP belongs.

        :return: The parent_controller of this ControllerSFP.
        :rtype: str
        :required/optional: required
        """
        return self._parent_controller

    @parent_controller.setter
    def parent_controller(self, parent_controller):
        """
        Sets the parent_controller of this ControllerSFP.
        The controller to which the SFP belongs.

        :param parent_controller: The parent_controller of this ControllerSFP.
        :type: str
        """
        self._parent_controller = parent_controller

    @property
    def channel(self):
        """
        Gets the channel of this ControllerSFP.
        The channel the SFP is associated with.

        :return: The channel of this ControllerSFP.
        :rtype: int
        :required/optional: required
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """
        Sets the channel of this ControllerSFP.
        The channel the SFP is associated with.

        :param channel: The channel of this ControllerSFP.
        :type: int
        """
        self._channel = channel

    @property
    def reserved1(self):
        """
        Gets the reserved1 of this ControllerSFP.


        :return: The reserved1 of this ControllerSFP.
        :rtype: str
        :required/optional: optional
        """
        return self._reserved1

    @reserved1.setter
    def reserved1(self, reserved1):
        """
        Sets the reserved1 of this ControllerSFP.


        :param reserved1: The reserved1 of this ControllerSFP.
        :type: str
        """
        self._reserved1 = reserved1

    @property
    def reserved2(self):
        """
        Gets the reserved2 of this ControllerSFP.


        :return: The reserved2 of this ControllerSFP.
        :rtype: str
        :required/optional: optional
        """
        return self._reserved2

    @reserved2.setter
    def reserved2(self, reserved2):
        """
        Sets the reserved2 of this ControllerSFP.


        :param reserved2: The reserved2 of this ControllerSFP.
        :type: str
        """
        self._reserved2 = reserved2

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

