# coding: utf-8

"""
CpuUtilizationStats.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CpuUtilizationStats(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CpuUtilizationStats - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'max_cpu_utilization': 'int',  # (required parameter)
            'sum_cpu_utilization': 'int',  # (required parameter)
            'ssq_cpu_utilization': 'int'
        }

        self.attribute_map = {
            'max_cpu_utilization': 'maxCpuUtilization',  # (required parameter)
            'sum_cpu_utilization': 'sumCpuUtilization',  # (required parameter)
            'ssq_cpu_utilization': 'ssqCpuUtilization'
        }

        self._max_cpu_utilization = None
        self._sum_cpu_utilization = None
        self._ssq_cpu_utilization = None

    @property
    def max_cpu_utilization(self):
        """
        Gets the max_cpu_utilization of this CpuUtilizationStats.
        Max utilization stats value from CPU.

        :return: The max_cpu_utilization of this CpuUtilizationStats.
        :rtype: int
        :required/optional: required
        """
        return self._max_cpu_utilization

    @max_cpu_utilization.setter
    def max_cpu_utilization(self, max_cpu_utilization):
        """
        Sets the max_cpu_utilization of this CpuUtilizationStats.
        Max utilization stats value from CPU.

        :param max_cpu_utilization: The max_cpu_utilization of this CpuUtilizationStats.
        :type: int
        """
        self._max_cpu_utilization = max_cpu_utilization

    @property
    def sum_cpu_utilization(self):
        """
        Gets the sum_cpu_utilization of this CpuUtilizationStats.
        Sum of utilization stats values from CPU.

        :return: The sum_cpu_utilization of this CpuUtilizationStats.
        :rtype: int
        :required/optional: required
        """
        return self._sum_cpu_utilization

    @sum_cpu_utilization.setter
    def sum_cpu_utilization(self, sum_cpu_utilization):
        """
        Sets the sum_cpu_utilization of this CpuUtilizationStats.
        Sum of utilization stats values from CPU.

        :param sum_cpu_utilization: The sum_cpu_utilization of this CpuUtilizationStats.
        :type: int
        """
        self._sum_cpu_utilization = sum_cpu_utilization

    @property
    def ssq_cpu_utilization(self):
        """
        Gets the ssq_cpu_utilization of this CpuUtilizationStats.
        Sum of squares of utilization stats values from CPU.

        :return: The ssq_cpu_utilization of this CpuUtilizationStats.
        :rtype: int
        :required/optional: required
        """
        return self._ssq_cpu_utilization

    @ssq_cpu_utilization.setter
    def ssq_cpu_utilization(self, ssq_cpu_utilization):
        """
        Sets the ssq_cpu_utilization of this CpuUtilizationStats.
        Sum of squares of utilization stats values from CPU.

        :param ssq_cpu_utilization: The ssq_cpu_utilization of this CpuUtilizationStats.
        :type: int
        """
        self._ssq_cpu_utilization = ssq_cpu_utilization

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

