# coding: utf-8

"""
CumulativeStatisticsDefaultAttributes.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CumulativeStatisticsDefaultAttributes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CumulativeStatisticsDefaultAttributes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'low_high_sampling_supported': 'bool',  # (required parameter)
            'low_resolution_period': 'int',  # (required parameter)
            'high_resolution_period': 'int'
        }

        self.attribute_map = {
            'low_high_sampling_supported': 'lowHighSamplingSupported',  # (required parameter)
            'low_resolution_period': 'lowResolutionPeriod',  # (required parameter)
            'high_resolution_period': 'highResolutionPeriod'
        }

        self._low_high_sampling_supported = None
        self._low_resolution_period = None
        self._high_resolution_period = None

    @property
    def low_high_sampling_supported(self):
        """
        Gets the low_high_sampling_supported of this CumulativeStatisticsDefaultAttributes.
        If true, the CFW supports the low and high resolution sampling.

        :return: The low_high_sampling_supported of this CumulativeStatisticsDefaultAttributes.
        :rtype: bool
        :required/optional: required
        """
        return self._low_high_sampling_supported

    @low_high_sampling_supported.setter
    def low_high_sampling_supported(self, low_high_sampling_supported):
        """
        Sets the low_high_sampling_supported of this CumulativeStatisticsDefaultAttributes.
        If true, the CFW supports the low and high resolution sampling.

        :param low_high_sampling_supported: The low_high_sampling_supported of this CumulativeStatisticsDefaultAttributes.
        :type: bool
        """
        self._low_high_sampling_supported = low_high_sampling_supported

    @property
    def low_resolution_period(self):
        """
        Gets the low_resolution_period of this CumulativeStatisticsDefaultAttributes.
        Duration, in seconds, for low resolution statistics samples to be saved.

        :return: The low_resolution_period of this CumulativeStatisticsDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._low_resolution_period

    @low_resolution_period.setter
    def low_resolution_period(self, low_resolution_period):
        """
        Sets the low_resolution_period of this CumulativeStatisticsDefaultAttributes.
        Duration, in seconds, for low resolution statistics samples to be saved.

        :param low_resolution_period: The low_resolution_period of this CumulativeStatisticsDefaultAttributes.
        :type: int
        """
        self._low_resolution_period = low_resolution_period

    @property
    def high_resolution_period(self):
        """
        Gets the high_resolution_period of this CumulativeStatisticsDefaultAttributes.
        Duration, in seconds, for high resolution statistics samples to be saved.

        :return: The high_resolution_period of this CumulativeStatisticsDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._high_resolution_period

    @high_resolution_period.setter
    def high_resolution_period(self, high_resolution_period):
        """
        Sets the high_resolution_period of this CumulativeStatisticsDefaultAttributes.
        Duration, in seconds, for high resolution statistics samples to be saved.

        :param high_resolution_period: The high_resolution_period of this CumulativeStatisticsDefaultAttributes.
        :type: int
        """
        self._high_resolution_period = high_resolution_period

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

