# coding: utf-8

"""
CumulativeStatisticsListDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CumulativeStatisticsListDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CumulativeStatisticsListDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'group_type': 'str',  # (required parameter)
            'object_ref': 'list[ObjectReference]',  # (required parameter)
            'data_location': 'str',  # (required parameter)
            'statistics_resolution': 'str'
        }

        self.attribute_map = {
            'group_type': 'groupType',  # (required parameter)
            'object_ref': 'objectRef',  # (required parameter)
            'data_location': 'dataLocation',  # (required parameter)
            'statistics_resolution': 'statisticsResolution'
        }

        self._group_type = None
        self._object_ref = None
        self._data_location = None
        self._statistics_resolution = None

    @property
    def group_type(self):
        """
        Gets the group_type of this CumulativeStatisticsListDescriptor.
        The type of counter group to be returned.

        :return: The group_type of this CumulativeStatisticsListDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._group_type

    @group_type.setter
    def group_type(self, group_type):
        """
        Sets the group_type of this CumulativeStatisticsListDescriptor.
        The type of counter group to be returned.

        :param group_type: The group_type of this CumulativeStatisticsListDescriptor.
        :type: str
        """
        allowed_values = ["drive", "implementation", "io", "volume", "controller", "iointerface", "__UNDEFINED"]
        if group_type not in allowed_values:
            raise ValueError(
                "Invalid value for `group_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._group_type = group_type

    @property
    def object_ref(self):
        """
        Gets the object_ref of this CumulativeStatisticsListDescriptor.
        A list of references to the storage array objects (e.g., volumes, drives, etc.) for which counters are to be returned.

        :return: The object_ref of this CumulativeStatisticsListDescriptor.
        :rtype: list[ObjectReference]
        :required/optional: required
        """
        return self._object_ref

    @object_ref.setter
    def object_ref(self, object_ref):
        """
        Sets the object_ref of this CumulativeStatisticsListDescriptor.
        A list of references to the storage array objects (e.g., volumes, drives, etc.) for which counters are to be returned.

        :param object_ref: The object_ref of this CumulativeStatisticsListDescriptor.
        :type: list[ObjectReference]
        """
        self._object_ref = object_ref

    @property
    def data_location(self):
        """
        Gets the data_location of this CumulativeStatisticsListDescriptor.
        Location of counter group data to be returned.

        :return: The data_location of this CumulativeStatisticsListDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._data_location

    @data_location.setter
    def data_location(self, data_location):
        """
        Sets the data_location of this CumulativeStatisticsListDescriptor.
        Location of counter group data to be returned.

        :param data_location: The data_location of this CumulativeStatisticsListDescriptor.
        :type: str
        """
        allowed_values = ["unknown", "saved", "active", "all", "__UNDEFINED"]
        if data_location not in allowed_values:
            raise ValueError(
                "Invalid value for `data_location`, must be one of {0}"
                .format(allowed_values)
            )
        self._data_location = data_location

    @property
    def statistics_resolution(self):
        """
        Gets the statistics_resolution of this CumulativeStatisticsListDescriptor.
        Identifies if low or high resolution.

        :return: The statistics_resolution of this CumulativeStatisticsListDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._statistics_resolution

    @statistics_resolution.setter
    def statistics_resolution(self, statistics_resolution):
        """
        Sets the statistics_resolution of this CumulativeStatisticsListDescriptor.
        Identifies if low or high resolution.

        :param statistics_resolution: The statistics_resolution of this CumulativeStatisticsListDescriptor.
        :type: str
        """
        allowed_values = ["low", "high", "__UNDEFINED"]
        if statistics_resolution not in allowed_values:
            raise ValueError(
                "Invalid value for `statistics_resolution`, must be one of {0}"
                .format(allowed_values)
            )
        self._statistics_resolution = statistics_resolution

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

