# coding: utf-8

"""
DbmBlkRestoreChunkDetails.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DbmBlkRestoreChunkDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DbmBlkRestoreChunkDetails - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'chunk_crc': 'int',  # (required parameter)
            'block_size': 'int',  # (required parameter)
            'sstor_lba': 'list[int]',  # (required parameter)
            'block_data': 'str'
        }

        self.attribute_map = {
            'chunk_crc': 'chunkCRC',  # (required parameter)
            'block_size': 'blockSize',  # (required parameter)
            'sstor_lba': 'sstorLBA',  # (required parameter)
            'block_data': 'blockData'
        }

        self._chunk_crc = None
        self._block_size = None
        self._sstor_lba = None
        self._block_data = None

    @property
    def chunk_crc(self):
        """
        Gets the chunk_crc of this DbmBlkRestoreChunkDetails.
        CRC data.

        :return: The chunk_crc of this DbmBlkRestoreChunkDetails.
        :rtype: int
        :required/optional: required
        """
        return self._chunk_crc

    @chunk_crc.setter
    def chunk_crc(self, chunk_crc):
        """
        Sets the chunk_crc of this DbmBlkRestoreChunkDetails.
        CRC data.

        :param chunk_crc: The chunk_crc of this DbmBlkRestoreChunkDetails.
        :type: int
        """
        self._chunk_crc = chunk_crc

    @property
    def block_size(self):
        """
        Gets the block_size of this DbmBlkRestoreChunkDetails.
        The size of each dbm block (sector).

        :return: The block_size of this DbmBlkRestoreChunkDetails.
        :rtype: int
        :required/optional: required
        """
        return self._block_size

    @block_size.setter
    def block_size(self, block_size):
        """
        Sets the block_size of this DbmBlkRestoreChunkDetails.
        The size of each dbm block (sector).

        :param block_size: The block_size of this DbmBlkRestoreChunkDetails.
        :type: int
        """
        self._block_size = block_size

    @property
    def sstor_lba(self):
        """
        Gets the sstor_lba of this DbmBlkRestoreChunkDetails.
        An array identifying the block addresses of the blocks whose data resides in the blockData array

        :return: The sstor_lba of this DbmBlkRestoreChunkDetails.
        :rtype: list[int]
        :required/optional: required
        """
        return self._sstor_lba

    @sstor_lba.setter
    def sstor_lba(self, sstor_lba):
        """
        Sets the sstor_lba of this DbmBlkRestoreChunkDetails.
        An array identifying the block addresses of the blocks whose data resides in the blockData array

        :param sstor_lba: The sstor_lba of this DbmBlkRestoreChunkDetails.
        :type: list[int]
        """
        self._sstor_lba = sstor_lba

    @property
    def block_data(self):
        """
        Gets the block_data of this DbmBlkRestoreChunkDetails.
        An array of block data.

        :return: The block_data of this DbmBlkRestoreChunkDetails.
        :rtype: str
        :required/optional: required
        """
        return self._block_data

    @block_data.setter
    def block_data(self, block_data):
        """
        Sets the block_data of this DbmBlkRestoreChunkDetails.
        An array of block data.

        :param block_data: The block_data of this DbmBlkRestoreChunkDetails.
        :type: str
        """
        self._block_data = block_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

