# coding: utf-8

"""
DiskPoolData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DiskPoolData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DiskPoolData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'reconstruction_reserved_drive_count': 'int',  # (required parameter)
            'reconstruction_reserved_amt': 'int',  # (required parameter)
            'reconstruction_reserved_drive_count_current': 'int',  # (required parameter)
            'pool_utilization_warning_threshold': 'int',  # (required parameter)
            'pool_utilization_critical_threshold': 'int',  # (required parameter)
            'pool_utilization_state': 'str',  # (required parameter)
            'unusable_capacity': 'int',  # (required parameter)
            'degraded_reconstruct_priority': 'str',  # (required parameter)
            'critical_reconstruct_priority': 'str',  # (required parameter)
            'background_operation_priority': 'str',  # (required parameter)
            'alloc_granularity': 'int'
        }

        self.attribute_map = {
            'reconstruction_reserved_drive_count': 'reconstructionReservedDriveCount',  # (required parameter)
            'reconstruction_reserved_amt': 'reconstructionReservedAmt',  # (required parameter)
            'reconstruction_reserved_drive_count_current': 'reconstructionReservedDriveCountCurrent',  # (required parameter)
            'pool_utilization_warning_threshold': 'poolUtilizationWarningThreshold',  # (required parameter)
            'pool_utilization_critical_threshold': 'poolUtilizationCriticalThreshold',  # (required parameter)
            'pool_utilization_state': 'poolUtilizationState',  # (required parameter)
            'unusable_capacity': 'unusableCapacity',  # (required parameter)
            'degraded_reconstruct_priority': 'degradedReconstructPriority',  # (required parameter)
            'critical_reconstruct_priority': 'criticalReconstructPriority',  # (required parameter)
            'background_operation_priority': 'backgroundOperationPriority',  # (required parameter)
            'alloc_granularity': 'allocGranularity'
        }

        self._reconstruction_reserved_drive_count = None
        self._reconstruction_reserved_amt = None
        self._reconstruction_reserved_drive_count_current = None
        self._pool_utilization_warning_threshold = None
        self._pool_utilization_critical_threshold = None
        self._pool_utilization_state = None
        self._unusable_capacity = None
        self._degraded_reconstruct_priority = None
        self._critical_reconstruct_priority = None
        self._background_operation_priority = None
        self._alloc_granularity = None

    @property
    def reconstruction_reserved_drive_count(self):
        """
        Gets the reconstruction_reserved_drive_count of this DiskPoolData.
        The number of drives reserved for reconstruction of failed drives.

        :return: The reconstruction_reserved_drive_count of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._reconstruction_reserved_drive_count

    @reconstruction_reserved_drive_count.setter
    def reconstruction_reserved_drive_count(self, reconstruction_reserved_drive_count):
        """
        Sets the reconstruction_reserved_drive_count of this DiskPoolData.
        The number of drives reserved for reconstruction of failed drives.

        :param reconstruction_reserved_drive_count: The reconstruction_reserved_drive_count of this DiskPoolData.
        :type: int
        """
        self._reconstruction_reserved_drive_count = reconstruction_reserved_drive_count

    @property
    def reconstruction_reserved_amt(self):
        """
        Gets the reconstruction_reserved_amt of this DiskPoolData.
        The pool capacity reserved to hold rebuild data (in bytes). This value is calculated from the reconstructionReservedDriveCount.

        :return: The reconstruction_reserved_amt of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._reconstruction_reserved_amt

    @reconstruction_reserved_amt.setter
    def reconstruction_reserved_amt(self, reconstruction_reserved_amt):
        """
        Sets the reconstruction_reserved_amt of this DiskPoolData.
        The pool capacity reserved to hold rebuild data (in bytes). This value is calculated from the reconstructionReservedDriveCount.

        :param reconstruction_reserved_amt: The reconstruction_reserved_amt of this DiskPoolData.
        :type: int
        """
        self._reconstruction_reserved_amt = reconstruction_reserved_amt

    @property
    def reconstruction_reserved_drive_count_current(self):
        """
        Gets the reconstruction_reserved_drive_count_current of this DiskPoolData.
        The reserved capacity that is currently available to hold rebuilt data (dynamic). If all of the reserved capacity is available, then this value will equal the reconstructionReservedDriveCount.

        :return: The reconstruction_reserved_drive_count_current of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._reconstruction_reserved_drive_count_current

    @reconstruction_reserved_drive_count_current.setter
    def reconstruction_reserved_drive_count_current(self, reconstruction_reserved_drive_count_current):
        """
        Sets the reconstruction_reserved_drive_count_current of this DiskPoolData.
        The reserved capacity that is currently available to hold rebuilt data (dynamic). If all of the reserved capacity is available, then this value will equal the reconstructionReservedDriveCount.

        :param reconstruction_reserved_drive_count_current: The reconstruction_reserved_drive_count_current of this DiskPoolData.
        :type: int
        """
        self._reconstruction_reserved_drive_count_current = reconstruction_reserved_drive_count_current

    @property
    def pool_utilization_warning_threshold(self):
        """
        Gets the pool_utilization_warning_threshold of this DiskPoolData.
        The pool utilization warning threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity.

        :return: The pool_utilization_warning_threshold of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._pool_utilization_warning_threshold

    @pool_utilization_warning_threshold.setter
    def pool_utilization_warning_threshold(self, pool_utilization_warning_threshold):
        """
        Sets the pool_utilization_warning_threshold of this DiskPoolData.
        The pool utilization warning threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity.

        :param pool_utilization_warning_threshold: The pool_utilization_warning_threshold of this DiskPoolData.
        :type: int
        """
        self._pool_utilization_warning_threshold = pool_utilization_warning_threshold

    @property
    def pool_utilization_critical_threshold(self):
        """
        Gets the pool_utilization_critical_threshold of this DiskPoolData.
        The pool utilization critical threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity.

        :return: The pool_utilization_critical_threshold of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._pool_utilization_critical_threshold

    @pool_utilization_critical_threshold.setter
    def pool_utilization_critical_threshold(self, pool_utilization_critical_threshold):
        """
        Sets the pool_utilization_critical_threshold of this DiskPoolData.
        The pool utilization critical threshold as a percentage of the total user configurable capacity. A MEL event is generated when the configured capacity exceeds the specified level of the configurable capacity.

        :param pool_utilization_critical_threshold: The pool_utilization_critical_threshold of this DiskPoolData.
        :type: int
        """
        self._pool_utilization_critical_threshold = pool_utilization_critical_threshold

    @property
    def pool_utilization_state(self):
        """
        Gets the pool_utilization_state of this DiskPoolData.
        The Disk pool state set based on state of the threshold.

        :return: The pool_utilization_state of this DiskPoolData.
        :rtype: str
        :required/optional: required
        """
        return self._pool_utilization_state

    @pool_utilization_state.setter
    def pool_utilization_state(self, pool_utilization_state):
        """
        Sets the pool_utilization_state of this DiskPoolData.
        The Disk pool state set based on state of the threshold.

        :param pool_utilization_state: The pool_utilization_state of this DiskPoolData.
        :type: str
        """
        allowed_values = ["utilizationInvalid", "utilizationOptimal", "utilizationWarning", "utilizationCritical", "capacityDepleted", "__UNDEFINED"]
        if pool_utilization_state not in allowed_values:
            raise ValueError(
                "Invalid value for `pool_utilization_state`, must be one of {0}"
                .format(allowed_values)
            )
        self._pool_utilization_state = pool_utilization_state

    @property
    def unusable_capacity(self):
        """
        Gets the unusable_capacity of this DiskPoolData.
        This value identifies how much capacity (in bytes) is being wasted due to a mix of drive sizes. This value will be zero as long as the pool consists of like drive sizes.

        :return: The unusable_capacity of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._unusable_capacity

    @unusable_capacity.setter
    def unusable_capacity(self, unusable_capacity):
        """
        Sets the unusable_capacity of this DiskPoolData.
        This value identifies how much capacity (in bytes) is being wasted due to a mix of drive sizes. This value will be zero as long as the pool consists of like drive sizes.

        :param unusable_capacity: The unusable_capacity of this DiskPoolData.
        :type: int
        """
        self._unusable_capacity = unusable_capacity

    @property
    def degraded_reconstruct_priority(self):
        """
        Gets the degraded_reconstruct_priority of this DiskPoolData.
        One failed drive degraded reconstruction priority.

        :return: The degraded_reconstruct_priority of this DiskPoolData.
        :rtype: str
        :required/optional: required
        """
        return self._degraded_reconstruct_priority

    @degraded_reconstruct_priority.setter
    def degraded_reconstruct_priority(self, degraded_reconstruct_priority):
        """
        Sets the degraded_reconstruct_priority of this DiskPoolData.
        One failed drive degraded reconstruction priority.

        :param degraded_reconstruct_priority: The degraded_reconstruct_priority of this DiskPoolData.
        :type: str
        """
        allowed_values = ["invalid", "lowest", "low", "medium", "high", "highest", "useDefault", "__UNDEFINED"]
        if degraded_reconstruct_priority not in allowed_values:
            raise ValueError(
                "Invalid value for `degraded_reconstruct_priority`, must be one of {0}"
                .format(allowed_values)
            )
        self._degraded_reconstruct_priority = degraded_reconstruct_priority

    @property
    def critical_reconstruct_priority(self):
        """
        Gets the critical_reconstruct_priority of this DiskPoolData.
        Two failed drive reconstruction critical priority.

        :return: The critical_reconstruct_priority of this DiskPoolData.
        :rtype: str
        :required/optional: required
        """
        return self._critical_reconstruct_priority

    @critical_reconstruct_priority.setter
    def critical_reconstruct_priority(self, critical_reconstruct_priority):
        """
        Sets the critical_reconstruct_priority of this DiskPoolData.
        Two failed drive reconstruction critical priority.

        :param critical_reconstruct_priority: The critical_reconstruct_priority of this DiskPoolData.
        :type: str
        """
        allowed_values = ["invalid", "lowest", "low", "medium", "high", "highest", "useDefault", "__UNDEFINED"]
        if critical_reconstruct_priority not in allowed_values:
            raise ValueError(
                "Invalid value for `critical_reconstruct_priority`, must be one of {0}"
                .format(allowed_values)
            )
        self._critical_reconstruct_priority = critical_reconstruct_priority

    @property
    def background_operation_priority(self):
        """
        Gets the background_operation_priority of this DiskPoolData.
        Priority of other background operations (DVE,DCE,DCR, and IAF).

        :return: The background_operation_priority of this DiskPoolData.
        :rtype: str
        :required/optional: required
        """
        return self._background_operation_priority

    @background_operation_priority.setter
    def background_operation_priority(self, background_operation_priority):
        """
        Sets the background_operation_priority of this DiskPoolData.
        Priority of other background operations (DVE,DCE,DCR, and IAF).

        :param background_operation_priority: The background_operation_priority of this DiskPoolData.
        :type: str
        """
        allowed_values = ["invalid", "lowest", "low", "medium", "high", "highest", "useDefault", "__UNDEFINED"]
        if background_operation_priority not in allowed_values:
            raise ValueError(
                "Invalid value for `background_operation_priority`, must be one of {0}"
                .format(allowed_values)
            )
        self._background_operation_priority = background_operation_priority

    @property
    def alloc_granularity(self):
        """
        Gets the alloc_granularity of this DiskPoolData.
        The allocation granularity (in bytes) for volumes in a disk pool.

        :return: The alloc_granularity of this DiskPoolData.
        :rtype: int
        :required/optional: required
        """
        return self._alloc_granularity

    @alloc_granularity.setter
    def alloc_granularity(self, alloc_granularity):
        """
        Sets the alloc_granularity of this DiskPoolData.
        The allocation granularity (in bytes) for volumes in a disk pool.

        :param alloc_granularity: The alloc_granularity of this DiskPoolData.
        :type: int
        """
        self._alloc_granularity = alloc_granularity

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

