# coding: utf-8

"""
DiskPoolVolumeCandidateData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DiskPoolVolumeCandidateData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DiskPoolVolumeCandidateData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'reconstruction_reserved_drive_count': 'int',  # (required parameter)
            'reconstruction_reserved_amt': 'int',  # (required parameter)
            'unusable_capacity': 'int'
        }

        self.attribute_map = {
            'reconstruction_reserved_drive_count': 'reconstructionReservedDriveCount',  # (required parameter)
            'reconstruction_reserved_amt': 'reconstructionReservedAmt',  # (required parameter)
            'unusable_capacity': 'unusableCapacity'
        }

        self._reconstruction_reserved_drive_count = None
        self._reconstruction_reserved_amt = None
        self._unusable_capacity = None

    @property
    def reconstruction_reserved_drive_count(self):
        """
        Gets the reconstruction_reserved_drive_count of this DiskPoolVolumeCandidateData.
        The number of drives reserved for reconstruction of failed drives.

        :return: The reconstruction_reserved_drive_count of this DiskPoolVolumeCandidateData.
        :rtype: int
        :required/optional: required
        """
        return self._reconstruction_reserved_drive_count

    @reconstruction_reserved_drive_count.setter
    def reconstruction_reserved_drive_count(self, reconstruction_reserved_drive_count):
        """
        Sets the reconstruction_reserved_drive_count of this DiskPoolVolumeCandidateData.
        The number of drives reserved for reconstruction of failed drives.

        :param reconstruction_reserved_drive_count: The reconstruction_reserved_drive_count of this DiskPoolVolumeCandidateData.
        :type: int
        """
        self._reconstruction_reserved_drive_count = reconstruction_reserved_drive_count

    @property
    def reconstruction_reserved_amt(self):
        """
        Gets the reconstruction_reserved_amt of this DiskPoolVolumeCandidateData.
        The pool capacity reserved to hold rebuild data (in bytes). This value is calculated from the reconstructionReservedDriveCount.

        :return: The reconstruction_reserved_amt of this DiskPoolVolumeCandidateData.
        :rtype: int
        :required/optional: required
        """
        return self._reconstruction_reserved_amt

    @reconstruction_reserved_amt.setter
    def reconstruction_reserved_amt(self, reconstruction_reserved_amt):
        """
        Sets the reconstruction_reserved_amt of this DiskPoolVolumeCandidateData.
        The pool capacity reserved to hold rebuild data (in bytes). This value is calculated from the reconstructionReservedDriveCount.

        :param reconstruction_reserved_amt: The reconstruction_reserved_amt of this DiskPoolVolumeCandidateData.
        :type: int
        """
        self._reconstruction_reserved_amt = reconstruction_reserved_amt

    @property
    def unusable_capacity(self):
        """
        Gets the unusable_capacity of this DiskPoolVolumeCandidateData.
        This value identifies how much capacity (in bytes) is being wasted due to a mix of drive sizes. This value will be zero as long as the pool consists of like drive sizes.

        :return: The unusable_capacity of this DiskPoolVolumeCandidateData.
        :rtype: int
        :required/optional: required
        """
        return self._unusable_capacity

    @unusable_capacity.setter
    def unusable_capacity(self, unusable_capacity):
        """
        Sets the unusable_capacity of this DiskPoolVolumeCandidateData.
        This value identifies how much capacity (in bytes) is being wasted due to a mix of drive sizes. This value will be zero as long as the pool consists of like drive sizes.

        :param unusable_capacity: The unusable_capacity of this DiskPoolVolumeCandidateData.
        :type: int
        """
        self._unusable_capacity = unusable_capacity

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

