# coding: utf-8

"""
DriveChannel.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DriveChannel(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DriveChannel - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'channel': 'int',  # (required parameter)
            'state': 'str',  # (required parameter)
            'reason': 'str',  # (required parameter)
            'degrading_controller': 'str',  # (required parameter)
            'stats_controller_a': 'DriveChannelStatistics',  # (required parameter)
            'stats_controller_b': 'DriveChannelStatistics'
        }

        self.attribute_map = {
            'channel': 'channel',  # (required parameter)
            'state': 'state',  # (required parameter)
            'reason': 'reason',  # (required parameter)
            'degrading_controller': 'degradingController',  # (required parameter)
            'stats_controller_a': 'statsControllerA',  # (required parameter)
            'stats_controller_b': 'statsControllerB'
        }

        self._channel = None
        self._state = None
        self._reason = None
        self._degrading_controller = None
        self._stats_controller_a = None
        self._stats_controller_b = None

    @property
    def channel(self):
        """
        Gets the channel of this DriveChannel.
        The channel number.

        :return: The channel of this DriveChannel.
        :rtype: int
        :required/optional: required
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """
        Sets the channel of this DriveChannel.
        The channel number.

        :param channel: The channel of this DriveChannel.
        :type: int
        """
        self._channel = channel

    @property
    def state(self):
        """
        Gets the state of this DriveChannel.
        The operational state of the channel.

        :return: The state of this DriveChannel.
        :rtype: str
        :required/optional: required
        """
        return self._state

    @state.setter
    def state(self, state):
        """
        Sets the state of this DriveChannel.
        The operational state of the channel.

        :param state: The state of this DriveChannel.
        :type: str
        """
        allowed_values = ["optimal", "degraded", "hwFailed", "__UNDEFINED"]
        if state not in allowed_values:
            raise ValueError(
                "Invalid value for `state`, must be one of {0}"
                .format(allowed_values)
            )
        self._state = state

    @property
    def reason(self):
        """
        Gets the reason of this DriveChannel.
        The reason the channel was degraded.

        :return: The reason of this DriveChannel.
        :rtype: str
        :required/optional: required
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """
        Sets the reason of this DriveChannel.
        The reason the channel was degraded.

        :param reason: The reason of this DriveChannel.
        :type: str
        """
        allowed_values = ["none", "thresholdExceeded", "adminRequest", "socNotOperational", "socEepromFailure", "clearHwFailure", "controllerAction", "__UNDEFINED"]
        if reason not in allowed_values:
            raise ValueError(
                "Invalid value for `reason`, must be one of {0}"
                .format(allowed_values)
            )
        self._reason = reason

    @property
    def degrading_controller(self):
        """
        Gets the degrading_controller of this DriveChannel.
        If auto degraded, the degraded controller.

        :return: The degrading_controller of this DriveChannel.
        :rtype: str
        :required/optional: required
        """
        return self._degrading_controller

    @degrading_controller.setter
    def degrading_controller(self, degrading_controller):
        """
        Sets the degrading_controller of this DriveChannel.
        If auto degraded, the degraded controller.

        :param degrading_controller: The degrading_controller of this DriveChannel.
        :type: str
        """
        self._degrading_controller = degrading_controller

    @property
    def stats_controller_a(self):
        """
        Gets the stats_controller_a of this DriveChannel.
        The statistics for Controller A.

        :return: The stats_controller_a of this DriveChannel.
        :rtype: DriveChannelStatistics
        :required/optional: required
        """
        return self._stats_controller_a

    @stats_controller_a.setter
    def stats_controller_a(self, stats_controller_a):
        """
        Sets the stats_controller_a of this DriveChannel.
        The statistics for Controller A.

        :param stats_controller_a: The stats_controller_a of this DriveChannel.
        :type: DriveChannelStatistics
        """
        self._stats_controller_a = stats_controller_a

    @property
    def stats_controller_b(self):
        """
        Gets the stats_controller_b of this DriveChannel.
        The statistics for Controller B.

        :return: The stats_controller_b of this DriveChannel.
        :rtype: DriveChannelStatistics
        :required/optional: required
        """
        return self._stats_controller_b

    @stats_controller_b.setter
    def stats_controller_b(self, stats_controller_b):
        """
        Sets the stats_controller_b of this DriveChannel.
        The statistics for Controller B.

        :param stats_controller_b: The stats_controller_b of this DriveChannel.
        :type: DriveChannelStatistics
        """
        self._stats_controller_b = stats_controller_b

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

