# coding: utf-8

"""
DriveChannelErrorCounts.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DriveChannelErrorCounts(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DriveChannelErrorCounts - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'non_channel_errors': 'int',  # (required parameter)
            'timeout_errors': 'int',  # (required parameter)
            'controller_detected_errors': 'int',  # (required parameter)
            'drive_detected_errors': 'int',  # (required parameter)
            'link_down_errors': 'int'
        }

        self.attribute_map = {
            'non_channel_errors': 'nonChannelErrors',  # (required parameter)
            'timeout_errors': 'timeoutErrors',  # (required parameter)
            'controller_detected_errors': 'controllerDetectedErrors',  # (required parameter)
            'drive_detected_errors': 'driveDetectedErrors',  # (required parameter)
            'link_down_errors': 'linkDownErrors'
        }

        self._non_channel_errors = None
        self._timeout_errors = None
        self._controller_detected_errors = None
        self._drive_detected_errors = None
        self._link_down_errors = None

    @property
    def non_channel_errors(self):
        """
        Gets the non_channel_errors of this DriveChannelErrorCounts.
        The number of non channel errors.

        :return: The non_channel_errors of this DriveChannelErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._non_channel_errors

    @non_channel_errors.setter
    def non_channel_errors(self, non_channel_errors):
        """
        Sets the non_channel_errors of this DriveChannelErrorCounts.
        The number of non channel errors.

        :param non_channel_errors: The non_channel_errors of this DriveChannelErrorCounts.
        :type: int
        """
        self._non_channel_errors = non_channel_errors

    @property
    def timeout_errors(self):
        """
        Gets the timeout_errors of this DriveChannelErrorCounts.
        The number of timeout errors.

        :return: The timeout_errors of this DriveChannelErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._timeout_errors

    @timeout_errors.setter
    def timeout_errors(self, timeout_errors):
        """
        Sets the timeout_errors of this DriveChannelErrorCounts.
        The number of timeout errors.

        :param timeout_errors: The timeout_errors of this DriveChannelErrorCounts.
        :type: int
        """
        self._timeout_errors = timeout_errors

    @property
    def controller_detected_errors(self):
        """
        Gets the controller_detected_errors of this DriveChannelErrorCounts.
        The number of controller detected errors.

        :return: The controller_detected_errors of this DriveChannelErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._controller_detected_errors

    @controller_detected_errors.setter
    def controller_detected_errors(self, controller_detected_errors):
        """
        Sets the controller_detected_errors of this DriveChannelErrorCounts.
        The number of controller detected errors.

        :param controller_detected_errors: The controller_detected_errors of this DriveChannelErrorCounts.
        :type: int
        """
        self._controller_detected_errors = controller_detected_errors

    @property
    def drive_detected_errors(self):
        """
        Gets the drive_detected_errors of this DriveChannelErrorCounts.
        The number of drive detected errors.

        :return: The drive_detected_errors of this DriveChannelErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._drive_detected_errors

    @drive_detected_errors.setter
    def drive_detected_errors(self, drive_detected_errors):
        """
        Sets the drive_detected_errors of this DriveChannelErrorCounts.
        The number of drive detected errors.

        :param drive_detected_errors: The drive_detected_errors of this DriveChannelErrorCounts.
        :type: int
        """
        self._drive_detected_errors = drive_detected_errors

    @property
    def link_down_errors(self):
        """
        Gets the link_down_errors of this DriveChannelErrorCounts.
        The number of link down errors.

        :return: The link_down_errors of this DriveChannelErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._link_down_errors

    @link_down_errors.setter
    def link_down_errors(self, link_down_errors):
        """
        Sets the link_down_errors of this DriveChannelErrorCounts.
        The number of link down errors.

        :param link_down_errors: The link_down_errors of this DriveChannelErrorCounts.
        :type: int
        """
        self._link_down_errors = link_down_errors

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

