# coding: utf-8

"""
DriveTypeData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DriveTypeData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DriveTypeData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'drive_type': 'str',  # (required parameter)
            'fibre': 'list[FibreDriveAddress]',  
            'sas': 'SasDriveAddress',  
            'scsi': 'SCSIDriveAddress'
        }

        self.attribute_map = {
            'drive_type': 'driveType',  # (required parameter)
            'fibre': 'fibre',  
            'sas': 'sas',  
            'scsi': 'scsi'
        }

        self._drive_type = None
        self._fibre = None
        self._sas = None
        self._scsi = None

    @property
    def drive_type(self):
        """
        Gets the drive_type of this DriveTypeData.
        This enumeration type is used to distinguish between the different I/O protocols used by the controller to communicate with drives. This is not necessarily the same as the physical drive interface type (PhysicalDriveType).

        :return: The drive_type of this DriveTypeData.
        :rtype: str
        :required/optional: required
        """
        return self._drive_type

    @drive_type.setter
    def drive_type(self, drive_type):
        """
        Sets the drive_type of this DriveTypeData.
        This enumeration type is used to distinguish between the different I/O protocols used by the controller to communicate with drives. This is not necessarily the same as the physical drive interface type (PhysicalDriveType).

        :param drive_type: The drive_type of this DriveTypeData.
        :type: str
        """
        allowed_values = ["scsi", "fibre", "unknown", "sas", "sata", "__UNDEFINED"]
        if drive_type not in allowed_values:
            raise ValueError(
                "Invalid value for `drive_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._drive_type = drive_type

    @property
    def fibre(self):
        """
        Gets the fibre of this DriveTypeData.
        This field is present only if the driveType value is DRIVE_TYPE_FIBRE. It contains the address information for a Fibre Channel drive. Such drives are typically multi-ported, so there will be one element in this variable-length array for each I/O port on the drive. The first element in the array is the drive address on the preferred channel, and the second element is the drive address on the redundant channel.

        :return: The fibre of this DriveTypeData.
        :rtype: list[FibreDriveAddress]
        :required/optional: optional
        """
        return self._fibre

    @fibre.setter
    def fibre(self, fibre):
        """
        Sets the fibre of this DriveTypeData.
        This field is present only if the driveType value is DRIVE_TYPE_FIBRE. It contains the address information for a Fibre Channel drive. Such drives are typically multi-ported, so there will be one element in this variable-length array for each I/O port on the drive. The first element in the array is the drive address on the preferred channel, and the second element is the drive address on the redundant channel.

        :param fibre: The fibre of this DriveTypeData.
        :type: list[FibreDriveAddress]
        """
        self._fibre = fibre

    @property
    def sas(self):
        """
        Gets the sas of this DriveTypeData.
        This field is present only if the driveType value is DRIVE_TYPE_SAS. It contains the address information for a serial-attached SCSI drive.

        :return: The sas of this DriveTypeData.
        :rtype: SasDriveAddress
        :required/optional: optional
        """
        return self._sas

    @sas.setter
    def sas(self, sas):
        """
        Sets the sas of this DriveTypeData.
        This field is present only if the driveType value is DRIVE_TYPE_SAS. It contains the address information for a serial-attached SCSI drive.

        :param sas: The sas of this DriveTypeData.
        :type: SasDriveAddress
        """
        self._sas = sas

    @property
    def scsi(self):
        """
        Gets the scsi of this DriveTypeData.
        This field is present only if the driveType value is DRIVE_TYPE_SCSI. It contains the address information for a SCSI drive.

        :return: The scsi of this DriveTypeData.
        :rtype: SCSIDriveAddress
        :required/optional: optional
        """
        return self._scsi

    @scsi.setter
    def scsi(self, scsi):
        """
        Sets the scsi of this DriveTypeData.
        This field is present only if the driveType value is DRIVE_TYPE_SCSI. It contains the address information for a SCSI drive.

        :param scsi: The scsi of this DriveTypeData.
        :type: SCSIDriveAddress
        """
        self._scsi = scsi

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

