# coding: utf-8

"""
EmbeddedSNMPAgentDefaultAttributes.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class EmbeddedSNMPAgentDefaultAttributes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EmbeddedSNMPAgentDefaultAttributes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'max_communities': 'int',  # (required parameter)
            'max_trap_destinations': 'int',  # (required parameter)
            'max_community_name_string_length': 'int',  # (required parameter)
            'max_system_variable_string_length': 'int',  # (required parameter)
            'default_system_variable_value': 'str'
        }

        self.attribute_map = {
            'max_communities': 'maxCommunities',  # (required parameter)
            'max_trap_destinations': 'maxTrapDestinations',  # (required parameter)
            'max_community_name_string_length': 'maxCommunityNameStringLength',  # (required parameter)
            'max_system_variable_string_length': 'maxSystemVariableStringLength',  # (required parameter)
            'default_system_variable_value': 'defaultSystemVariableValue'
        }

        self._max_communities = None
        self._max_trap_destinations = None
        self._max_community_name_string_length = None
        self._max_system_variable_string_length = None
        self._default_system_variable_value = None

    @property
    def max_communities(self):
        """
        Gets the max_communities of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum number of communities that can be added with the addSNMPCommunity procedure.

        :return: The max_communities of this EmbeddedSNMPAgentDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._max_communities

    @max_communities.setter
    def max_communities(self, max_communities):
        """
        Sets the max_communities of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum number of communities that can be added with the addSNMPCommunity procedure.

        :param max_communities: The max_communities of this EmbeddedSNMPAgentDefaultAttributes.
        :type: int
        """
        self._max_communities = max_communities

    @property
    def max_trap_destinations(self):
        """
        Gets the max_trap_destinations of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum number of trap destinations that can be added with the addSNMPTrapDestination procedure.

        :return: The max_trap_destinations of this EmbeddedSNMPAgentDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._max_trap_destinations

    @max_trap_destinations.setter
    def max_trap_destinations(self, max_trap_destinations):
        """
        Sets the max_trap_destinations of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum number of trap destinations that can be added with the addSNMPTrapDestination procedure.

        :param max_trap_destinations: The max_trap_destinations of this EmbeddedSNMPAgentDefaultAttributes.
        :type: int
        """
        self._max_trap_destinations = max_trap_destinations

    @property
    def max_community_name_string_length(self):
        """
        Gets the max_community_name_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum length of a community name.

        :return: The max_community_name_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._max_community_name_string_length

    @max_community_name_string_length.setter
    def max_community_name_string_length(self, max_community_name_string_length):
        """
        Sets the max_community_name_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum length of a community name.

        :param max_community_name_string_length: The max_community_name_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        :type: int
        """
        self._max_community_name_string_length = max_community_name_string_length

    @property
    def max_system_variable_string_length(self):
        """
        Gets the max_system_variable_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum length of the user-settable system variables.

        :return: The max_system_variable_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._max_system_variable_string_length

    @max_system_variable_string_length.setter
    def max_system_variable_string_length(self, max_system_variable_string_length):
        """
        Sets the max_system_variable_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        Maximum length of the user-settable system variables.

        :param max_system_variable_string_length: The max_system_variable_string_length of this EmbeddedSNMPAgentDefaultAttributes.
        :type: int
        """
        self._max_system_variable_string_length = max_system_variable_string_length

    @property
    def default_system_variable_value(self):
        """
        Gets the default_system_variable_value of this EmbeddedSNMPAgentDefaultAttributes.
        Default value for system variables that are settable via SYMbol.

        :return: The default_system_variable_value of this EmbeddedSNMPAgentDefaultAttributes.
        :rtype: str
        :required/optional: required
        """
        return self._default_system_variable_value

    @default_system_variable_value.setter
    def default_system_variable_value(self, default_system_variable_value):
        """
        Sets the default_system_variable_value of this EmbeddedSNMPAgentDefaultAttributes.
        Default value for system variables that are settable via SYMbol.

        :param default_system_variable_value: The default_system_variable_value of this EmbeddedSNMPAgentDefaultAttributes.
        :type: str
        """
        self._default_system_variable_value = default_system_variable_value

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

