# coding: utf-8

"""
FibreRemoteTargetConnections.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FibreRemoteTargetConnections(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FibreRemoteTargetConnections - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'remote_node_wwn': 'str',  # (required parameter)
            'associated_switch_ports': 'list[str]',  # (required parameter)
            'connected_remote_target_ports': 'list[FibrePortLogin]'
        }

        self.attribute_map = {
            'remote_node_wwn': 'remoteNodeWWN',  # (required parameter)
            'associated_switch_ports': 'associatedSwitchPorts',  # (required parameter)
            'connected_remote_target_ports': 'connectedRemoteTargetPorts'
        }

        self._remote_node_wwn = None
        self._associated_switch_ports = None
        self._connected_remote_target_ports = None

    @property
    def remote_node_wwn(self):
        """
        Gets the remote_node_wwn of this FibreRemoteTargetConnections.
        Remote node name.

        :return: The remote_node_wwn of this FibreRemoteTargetConnections.
        :rtype: str
        :required/optional: required
        """
        return self._remote_node_wwn

    @remote_node_wwn.setter
    def remote_node_wwn(self, remote_node_wwn):
        """
        Sets the remote_node_wwn of this FibreRemoteTargetConnections.
        Remote node name.

        :param remote_node_wwn: The remote_node_wwn of this FibreRemoteTargetConnections.
        :type: str
        """
        self._remote_node_wwn = remote_node_wwn

    @property
    def associated_switch_ports(self):
        """
        Gets the associated_switch_ports of this FibreRemoteTargetConnections.
        Associated (visible) switch ports.

        :return: The associated_switch_ports of this FibreRemoteTargetConnections.
        :rtype: list[str]
        :required/optional: required
        """
        return self._associated_switch_ports

    @associated_switch_ports.setter
    def associated_switch_ports(self, associated_switch_ports):
        """
        Sets the associated_switch_ports of this FibreRemoteTargetConnections.
        Associated (visible) switch ports.

        :param associated_switch_ports: The associated_switch_ports of this FibreRemoteTargetConnections.
        :type: list[str]
        """
        self._associated_switch_ports = associated_switch_ports

    @property
    def connected_remote_target_ports(self):
        """
        Gets the connected_remote_target_ports of this FibreRemoteTargetConnections.
        Connected remote target ports.

        :return: The connected_remote_target_ports of this FibreRemoteTargetConnections.
        :rtype: list[FibrePortLogin]
        :required/optional: required
        """
        return self._connected_remote_target_ports

    @connected_remote_target_ports.setter
    def connected_remote_target_ports(self, connected_remote_target_ports):
        """
        Sets the connected_remote_target_ports of this FibreRemoteTargetConnections.
        Connected remote target ports.

        :param connected_remote_target_ports: The connected_remote_target_ports of this FibreRemoteTargetConnections.
        :type: list[FibrePortLogin]
        """
        self._connected_remote_target_ports = connected_remote_target_ports

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

