# coding: utf-8

"""
FlashCache.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FlashCache(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FlashCache - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'wwn': 'str',  # (required parameter)
            'flash_cache_ref': 'str',  # (required parameter)
            'flash_cache_base': 'FlashCacheBase',  # (required parameter)
            'fc_drive_info': 'FlashCacheDriveInfo',  # (required parameter)
            'id': 'str'
        }

        self.attribute_map = {
            'wwn': 'wwn',  # (required parameter)
            'flash_cache_ref': 'flashCacheRef',  # (required parameter)
            'flash_cache_base': 'flashCacheBase',  # (required parameter)
            'fc_drive_info': 'fcDriveInfo',  # (required parameter)
            'id': 'id'
        }

        self._wwn = None
        self._flash_cache_ref = None
        self._flash_cache_base = None
        self._fc_drive_info = None
        self._id = None

    @property
    def wwn(self):
        """
        Gets the wwn of this FlashCache.
        The WWN of the high level flash cache volume.

        :return: The wwn of this FlashCache.
        :rtype: str
        :required/optional: required
        """
        return self._wwn

    @wwn.setter
    def wwn(self, wwn):
        """
        Sets the wwn of this FlashCache.
        The WWN of the high level flash cache volume.

        :param wwn: The wwn of this FlashCache.
        :type: str
        """
        self._wwn = wwn

    @property
    def flash_cache_ref(self):
        """
        Gets the flash_cache_ref of this FlashCache.
        A reference to the high level flash cache volume.

        :return: The flash_cache_ref of this FlashCache.
        :rtype: str
        :required/optional: required
        """
        return self._flash_cache_ref

    @flash_cache_ref.setter
    def flash_cache_ref(self, flash_cache_ref):
        """
        Sets the flash_cache_ref of this FlashCache.
        A reference to the high level flash cache volume.

        :param flash_cache_ref: The flash_cache_ref of this FlashCache.
        :type: str
        """
        self._flash_cache_ref = flash_cache_ref

    @property
    def flash_cache_base(self):
        """
        Gets the flash_cache_base of this FlashCache.
        Contains the base-level Flash Cache attributes pertaining to all types of Flash Caches.

        :return: The flash_cache_base of this FlashCache.
        :rtype: FlashCacheBase
        :required/optional: required
        """
        return self._flash_cache_base

    @flash_cache_base.setter
    def flash_cache_base(self, flash_cache_base):
        """
        Sets the flash_cache_base of this FlashCache.
        Contains the base-level Flash Cache attributes pertaining to all types of Flash Caches.

        :param flash_cache_base: The flash_cache_base of this FlashCache.
        :type: FlashCacheBase
        """
        self._flash_cache_base = flash_cache_base

    @property
    def fc_drive_info(self):
        """
        Gets the fc_drive_info of this FlashCache.
        Drive information for the flash cache.

        :return: The fc_drive_info of this FlashCache.
        :rtype: FlashCacheDriveInfo
        :required/optional: required
        """
        return self._fc_drive_info

    @fc_drive_info.setter
    def fc_drive_info(self, fc_drive_info):
        """
        Sets the fc_drive_info of this FlashCache.
        Drive information for the flash cache.

        :param fc_drive_info: The fc_drive_info of this FlashCache.
        :type: FlashCacheDriveInfo
        """
        self._fc_drive_info = fc_drive_info

    @property
    def id(self):
        """
        Gets the id of this FlashCache.


        :return: The id of this FlashCache.
        :rtype: str
        :required/optional: optional
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this FlashCache.


        :param id: The id of this FlashCache.
        :type: str
        """
        self._id = id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

