# coding: utf-8

"""
FlashCacheBase.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FlashCacheBase(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FlashCacheBase - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'label': 'str',  # (required parameter)
            'status': 'str',  # (required parameter)
            'config_type': 'str',  # (required parameter)
            'analytics_status': 'str',  # (required parameter)
            'analytics_cause': 'str',  # (required parameter)
            'status_cause': 'str'
        }

        self.attribute_map = {
            'label': 'label',  # (required parameter)
            'status': 'status',  # (required parameter)
            'config_type': 'configType',  # (required parameter)
            'analytics_status': 'analyticsStatus',  # (required parameter)
            'analytics_cause': 'analyticsCause',  # (required parameter)
            'status_cause': 'statusCause'
        }

        self._label = None
        self._status = None
        self._config_type = None
        self._analytics_status = None
        self._analytics_cause = None
        self._status_cause = None

    @property
    def label(self):
        """
        Gets the label of this FlashCacheBase.
        The user-assigned label of the flash cache.

        :return: The label of this FlashCacheBase.
        :rtype: str
        :required/optional: required
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this FlashCacheBase.
        The user-assigned label of the flash cache.

        :param label: The label of this FlashCacheBase.
        :type: str
        """
        self._label = label

    @property
    def status(self):
        """
        Gets the status of this FlashCacheBase.
        The status of the flash cache.

        :return: The status of this FlashCacheBase.
        :rtype: str
        :required/optional: required
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this FlashCacheBase.
        The status of the flash cache.

        :param status: The status of this FlashCacheBase.
        :type: str
        """
        allowed_values = ["unknown", "optimal", "degraded", "failed", "suspended", "__UNDEFINED"]
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status`, must be one of {0}"
                .format(allowed_values)
            )
        self._status = status

    @property
    def config_type(self):
        """
        Gets the config_type of this FlashCacheBase.
        The flash cache configuration type.

        :return: The config_type of this FlashCacheBase.
        :rtype: str
        :required/optional: required
        """
        return self._config_type

    @config_type.setter
    def config_type(self, config_type):
        """
        Sets the config_type of this FlashCacheBase.
        The flash cache configuration type.

        :param config_type: The config_type of this FlashCacheBase.
        :type: str
        """
        allowed_values = ["unknown", "filesystem", "database", "multimedia", "__UNDEFINED"]
        if config_type not in allowed_values:
            raise ValueError(
                "Invalid value for `config_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._config_type = config_type

    @property
    def analytics_status(self):
        """
        Gets the analytics_status of this FlashCacheBase.
        The flash cache analytics status.

        :return: The analytics_status of this FlashCacheBase.
        :rtype: str
        :required/optional: required
        """
        return self._analytics_status

    @analytics_status.setter
    def analytics_status(self, analytics_status):
        """
        Sets the analytics_status of this FlashCacheBase.
        The flash cache analytics status.

        :param analytics_status: The analytics_status of this FlashCacheBase.
        :type: str
        """
        allowed_values = ["unknown", "stopped", "started", "__UNDEFINED"]
        if analytics_status not in allowed_values:
            raise ValueError(
                "Invalid value for `analytics_status`, must be one of {0}"
                .format(allowed_values)
            )
        self._analytics_status = analytics_status

    @property
    def analytics_cause(self):
        """
        Gets the analytics_cause of this FlashCacheBase.
        The flash cache analytics status cause.

        :return: The analytics_cause of this FlashCacheBase.
        :rtype: str
        :required/optional: required
        """
        return self._analytics_cause

    @analytics_cause.setter
    def analytics_cause(self, analytics_cause):
        """
        Sets the analytics_cause of this FlashCacheBase.
        The flash cache analytics status cause.

        :param analytics_cause: The analytics_cause of this FlashCacheBase.
        :type: str
        """
        allowed_values = ["none", "userStopped", "userFcChanges", "internalCtlrRebooted", "internalCfgChanges", "__UNDEFINED"]
        if analytics_cause not in allowed_values:
            raise ValueError(
                "Invalid value for `analytics_cause`, must be one of {0}"
                .format(allowed_values)
            )
        self._analytics_cause = analytics_cause

    @property
    def status_cause(self):
        """
        Gets the status_cause of this FlashCacheBase.
        The flash cache status cause.

        :return: The status_cause of this FlashCacheBase.
        :rtype: str
        :required/optional: required
        """
        return self._status_cause

    @status_cause.setter
    def status_cause(self, status_cause):
        """
        Sets the status_cause of this FlashCacheBase.
        The flash cache status cause.

        :param status_cause: The status_cause of this FlashCacheBase.
        :type: str
        """
        allowed_values = ["none", "hotspareInuse", "drivesInaccessible", "cacheSizeMismatch", "missingDrives", "__UNDEFINED"]
        if status_cause not in allowed_values:
            raise ValueError(
                "Invalid value for `status_cause`, must be one of {0}"
                .format(allowed_values)
            )
        self._status_cause = status_cause

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

