# coding: utf-8

"""
FlashCacheMap.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FlashCacheMap(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FlashCacheMap - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'flash_cache': 'str',  # (required parameter)
            'cached_volume': 'str',  # (required parameter)
            'flash_cache_map_ref': 'str',  # (required parameter)
            'id': 'str'
        }

        self.attribute_map = {
            'flash_cache': 'flashCache',  # (required parameter)
            'cached_volume': 'cachedVolume',  # (required parameter)
            'flash_cache_map_ref': 'flashCacheMapRef',  # (required parameter)
            'id': 'id'
        }

        self._flash_cache = None
        self._cached_volume = None
        self._flash_cache_map_ref = None
        self._id = None

    @property
    def flash_cache(self):
        """
        Gets the flash_cache of this FlashCacheMap.
        A reference to the associated flash cache.

        :return: The flash_cache of this FlashCacheMap.
        :rtype: str
        :required/optional: required
        """
        return self._flash_cache

    @flash_cache.setter
    def flash_cache(self, flash_cache):
        """
        Sets the flash_cache of this FlashCacheMap.
        A reference to the associated flash cache.

        :param flash_cache: The flash_cache of this FlashCacheMap.
        :type: str
        """
        self._flash_cache = flash_cache

    @property
    def cached_volume(self):
        """
        Gets the cached_volume of this FlashCacheMap.
        A reference to the cached volume.

        :return: The cached_volume of this FlashCacheMap.
        :rtype: str
        :required/optional: required
        """
        return self._cached_volume

    @cached_volume.setter
    def cached_volume(self, cached_volume):
        """
        Sets the cached_volume of this FlashCacheMap.
        A reference to the cached volume.

        :param cached_volume: The cached_volume of this FlashCacheMap.
        :type: str
        """
        self._cached_volume = cached_volume

    @property
    def flash_cache_map_ref(self):
        """
        Gets the flash_cache_map_ref of this FlashCacheMap.
        A unique identifier for the map entry.

        :return: The flash_cache_map_ref of this FlashCacheMap.
        :rtype: str
        :required/optional: required
        """
        return self._flash_cache_map_ref

    @flash_cache_map_ref.setter
    def flash_cache_map_ref(self, flash_cache_map_ref):
        """
        Sets the flash_cache_map_ref of this FlashCacheMap.
        A unique identifier for the map entry.

        :param flash_cache_map_ref: The flash_cache_map_ref of this FlashCacheMap.
        :type: str
        """
        self._flash_cache_map_ref = flash_cache_map_ref

    @property
    def id(self):
        """
        Gets the id of this FlashCacheMap.


        :return: The id of this FlashCacheMap.
        :rtype: str
        :required/optional: optional
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this FlashCacheMap.


        :param id: The id of this FlashCacheMap.
        :type: str
        """
        self._id = id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

