# coding: utf-8

"""
FruDiagDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FruDiagDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FruDiagDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'fru_diag_test_type': 'str',  # (required parameter)
            'slot': 'int',  # (required parameter)
            'fru_diag_test_identifier': 'str'
        }

        self.attribute_map = {
            'fru_diag_test_type': 'fruDiagTestType',  # (required parameter)
            'slot': 'slot',  # (required parameter)
            'fru_diag_test_identifier': 'fruDiagTestIdentifier'
        }

        self._fru_diag_test_type = None
        self._slot = None
        self._fru_diag_test_identifier = None

    @property
    def fru_diag_test_type(self):
        """
        Gets the fru_diag_test_type of this FruDiagDescriptor.
        The diagnostic test type.

        :return: The fru_diag_test_type of this FruDiagDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._fru_diag_test_type

    @fru_diag_test_type.setter
    def fru_diag_test_type(self, fru_diag_test_type):
        """
        Sets the fru_diag_test_type of this FruDiagDescriptor.
        The diagnostic test type.

        :param fru_diag_test_type: The fru_diag_test_type of this FruDiagDescriptor.
        :type: str
        """
        allowed_values = ["none", "serviceModeBasic", "serviceModeExtended", "__UNDEFINED"]
        if fru_diag_test_type not in allowed_values:
            raise ValueError(
                "Invalid value for `fru_diag_test_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._fru_diag_test_type = fru_diag_test_type

    @property
    def slot(self):
        """
        Gets the slot of this FruDiagDescriptor.
        The slot number (1-based) of the device on which the test should be performed. If a slot number is not required by the diagnostic, this value will be ignored.

        :return: The slot of this FruDiagDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._slot

    @slot.setter
    def slot(self, slot):
        """
        Sets the slot of this FruDiagDescriptor.
        The slot number (1-based) of the device on which the test should be performed. If a slot number is not required by the diagnostic, this value will be ignored.

        :param slot: The slot of this FruDiagDescriptor.
        :type: int
        """
        self._slot = slot

    @property
    def fru_diag_test_identifier(self):
        """
        Gets the fru_diag_test_identifier of this FruDiagDescriptor.
        The diagnostic test to be performed.

        :return: The fru_diag_test_identifier of this FruDiagDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._fru_diag_test_identifier

    @fru_diag_test_identifier.setter
    def fru_diag_test_identifier(self, fru_diag_test_identifier):
        """
        Sets the fru_diag_test_identifier of this FruDiagDescriptor.
        The diagnostic test to be performed.

        :param fru_diag_test_identifier: The fru_diag_test_identifier of this FruDiagDescriptor.
        :type: str
        """
        allowed_values = ["none", "dimmByteEnable", "dimmEcc", "dimmMarchC", "dimmPatterns", "dimmPseudorandom", "dimmDmaCopy", "usbflashWriteProtect", "usbflashWriteCycle", "usbflashWritePatterns", "usbflashRandom", "hicReadWrite", "hicDataLines", "hicInterrupt", "hicLoopback", "hicT10pi", "hicDma", "hicContextMemory", "hicExtMemory", "ctlrRegisterAddress", "ctlrDataLines", "ctlrApcSram", "ctlrApcFifo", "ctlrDataCopy", "ctlrRaid5", "ctlrRaid6", "hicRamReadWrite", "__UNDEFINED"]
        if fru_diag_test_identifier not in allowed_values:
            raise ValueError(
                "Invalid value for `fru_diag_test_identifier`, must be one of {0}"
                .format(allowed_values)
            )
        self._fru_diag_test_identifier = fru_diag_test_identifier

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

