# coding: utf-8

"""
GetIscsiSessionsFilter.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class GetIscsiSessionsFilter(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GetIscsiSessionsFilter - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',  # (required parameter)
            'initiator_ref': 'str',  
            'target_ref': 'str'
        }

        self.attribute_map = {
            'type': 'type',  # (required parameter)
            'initiator_ref': 'initiatorRef',  
            'target_ref': 'targetRef'
        }

        self._type = None
        self._initiator_ref = None
        self._target_ref = None

    @property
    def type(self):
        """
        Gets the type of this GetIscsiSessionsFilter.
        This enumeration type identifies the different filter options for the getIscsiSessions procedure.

        :return: The type of this GetIscsiSessionsFilter.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this GetIscsiSessionsFilter.
        This enumeration type identifies the different filter options for the getIscsiSessions procedure.

        :param type: The type of this GetIscsiSessionsFilter.
        :type: str
        """
        allowed_values = ["all", "byTarget", "byInitiator", "__UNDEFINED"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def initiator_ref(self):
        """
        Gets the initiator_ref of this GetIscsiSessionsFilter.
        A reference to an initiator instance. This field is present only if type is GET_ISCSI_SESSIONS_BY_INITIATOR.

        :return: The initiator_ref of this GetIscsiSessionsFilter.
        :rtype: str
        :required/optional: optional
        """
        return self._initiator_ref

    @initiator_ref.setter
    def initiator_ref(self, initiator_ref):
        """
        Sets the initiator_ref of this GetIscsiSessionsFilter.
        A reference to an initiator instance. This field is present only if type is GET_ISCSI_SESSIONS_BY_INITIATOR.

        :param initiator_ref: The initiator_ref of this GetIscsiSessionsFilter.
        :type: str
        """
        self._initiator_ref = initiator_ref

    @property
    def target_ref(self):
        """
        Gets the target_ref of this GetIscsiSessionsFilter.
        A reference to a target instance. This field is present only if type is GET_ISCSI_SESSIONS_BY_TARGET.

        :return: The target_ref of this GetIscsiSessionsFilter.
        :rtype: str
        :required/optional: optional
        """
        return self._target_ref

    @target_ref.setter
    def target_ref(self, target_ref):
        """
        Sets the target_ref of this GetIscsiSessionsFilter.
        A reference to a target instance. This field is present only if type is GET_ISCSI_SESSIONS_BY_TARGET.

        :param target_ref: The target_ref of this GetIscsiSessionsFilter.
        :type: str
        """
        self._target_ref = target_ref

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

