# coding: utf-8

"""
Histogram.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Histogram(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Histogram - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'controller_ref': 'str',  # (required parameter)
            'below_range': 'HistogramSummary',  # (required parameter)
            'in_range': 'HistogramSummary',  # (required parameter)
            'above_range': 'HistogramSummary',  # (required parameter)
            'frequency_table': 'list[int]'
        }

        self.attribute_map = {
            'controller_ref': 'controllerRef',  # (required parameter)
            'below_range': 'belowRange',  # (required parameter)
            'in_range': 'inRange',  # (required parameter)
            'above_range': 'aboveRange',  # (required parameter)
            'frequency_table': 'frequencyTable'
        }

        self._controller_ref = None
        self._below_range = None
        self._in_range = None
        self._above_range = None
        self._frequency_table = None

    @property
    def controller_ref(self):
        """
        Gets the controller_ref of this Histogram.
        A reference to the controller that provided the statistics.

        :return: The controller_ref of this Histogram.
        :rtype: str
        :required/optional: required
        """
        return self._controller_ref

    @controller_ref.setter
    def controller_ref(self, controller_ref):
        """
        Sets the controller_ref of this Histogram.
        A reference to the controller that provided the statistics.

        :param controller_ref: The controller_ref of this Histogram.
        :type: str
        """
        self._controller_ref = controller_ref

    @property
    def below_range(self):
        """
        Gets the below_range of this Histogram.
        A summary of below-range, unrecorded values.

        :return: The below_range of this Histogram.
        :rtype: HistogramSummary
        :required/optional: required
        """
        return self._below_range

    @below_range.setter
    def below_range(self, below_range):
        """
        Sets the below_range of this Histogram.
        A summary of below-range, unrecorded values.

        :param below_range: The below_range of this Histogram.
        :type: HistogramSummary
        """
        self._below_range = below_range

    @property
    def in_range(self):
        """
        Gets the in_range of this Histogram.
        A summary of recorded values.

        :return: The in_range of this Histogram.
        :rtype: HistogramSummary
        :required/optional: required
        """
        return self._in_range

    @in_range.setter
    def in_range(self, in_range):
        """
        Sets the in_range of this Histogram.
        A summary of recorded values.

        :param in_range: The in_range of this Histogram.
        :type: HistogramSummary
        """
        self._in_range = in_range

    @property
    def above_range(self):
        """
        Gets the above_range of this Histogram.
        A summary of above-range, unrecorded values.

        :return: The above_range of this Histogram.
        :rtype: HistogramSummary
        :required/optional: required
        """
        return self._above_range

    @above_range.setter
    def above_range(self, above_range):
        """
        Sets the above_range of this Histogram.
        A summary of above-range, unrecorded values.

        :param above_range: The above_range of this Histogram.
        :type: HistogramSummary
        """
        self._above_range = above_range

    @property
    def frequency_table(self):
        """
        Gets the frequency_table of this Histogram.
        An array of counter values, one counter per histogram category.

        :return: The frequency_table of this Histogram.
        :rtype: list[int]
        :required/optional: required
        """
        return self._frequency_table

    @frequency_table.setter
    def frequency_table(self, frequency_table):
        """
        Sets the frequency_table of this Histogram.
        An array of counter values, one counter per histogram category.

        :param frequency_table: The frequency_table of this Histogram.
        :type: list[int]
        """
        self._frequency_table = frequency_table

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

