# coding: utf-8

"""
HostBoard2PortIbTypeData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HostBoard2PortIbTypeData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HostBoard2PortIbTypeData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tca_guid': 'str',  # (required parameter)
            'queue_pairs_supported': 'int',  # (required parameter)
            'completion_queues_supported': 'int',  # (required parameter)
            'shared_receive_queues_supported': 'int'
        }

        self.attribute_map = {
            'tca_guid': 'tcaGuid',  # (required parameter)
            'queue_pairs_supported': 'queuePairsSupported',  # (required parameter)
            'completion_queues_supported': 'completionQueuesSupported',  # (required parameter)
            'shared_receive_queues_supported': 'sharedReceiveQueuesSupported'
        }

        self._tca_guid = None
        self._queue_pairs_supported = None
        self._completion_queues_supported = None
        self._shared_receive_queues_supported = None

    @property
    def tca_guid(self):
        """
        Gets the tca_guid of this HostBoard2PortIbTypeData.
        The globally unique identifier (GUID) assigned to the host board.

        :return: The tca_guid of this HostBoard2PortIbTypeData.
        :rtype: str
        :required/optional: required
        """
        return self._tca_guid

    @tca_guid.setter
    def tca_guid(self, tca_guid):
        """
        Sets the tca_guid of this HostBoard2PortIbTypeData.
        The globally unique identifier (GUID) assigned to the host board.

        :param tca_guid: The tca_guid of this HostBoard2PortIbTypeData.
        :type: str
        """
        self._tca_guid = tca_guid

    @property
    def queue_pairs_supported(self):
        """
        Gets the queue_pairs_supported of this HostBoard2PortIbTypeData.
        The number of queue pairs supported by the host board.

        :return: The queue_pairs_supported of this HostBoard2PortIbTypeData.
        :rtype: int
        :required/optional: required
        """
        return self._queue_pairs_supported

    @queue_pairs_supported.setter
    def queue_pairs_supported(self, queue_pairs_supported):
        """
        Sets the queue_pairs_supported of this HostBoard2PortIbTypeData.
        The number of queue pairs supported by the host board.

        :param queue_pairs_supported: The queue_pairs_supported of this HostBoard2PortIbTypeData.
        :type: int
        """
        self._queue_pairs_supported = queue_pairs_supported

    @property
    def completion_queues_supported(self):
        """
        Gets the completion_queues_supported of this HostBoard2PortIbTypeData.
        The number of completion queues supported by the host board.

        :return: The completion_queues_supported of this HostBoard2PortIbTypeData.
        :rtype: int
        :required/optional: required
        """
        return self._completion_queues_supported

    @completion_queues_supported.setter
    def completion_queues_supported(self, completion_queues_supported):
        """
        Sets the completion_queues_supported of this HostBoard2PortIbTypeData.
        The number of completion queues supported by the host board.

        :param completion_queues_supported: The completion_queues_supported of this HostBoard2PortIbTypeData.
        :type: int
        """
        self._completion_queues_supported = completion_queues_supported

    @property
    def shared_receive_queues_supported(self):
        """
        Gets the shared_receive_queues_supported of this HostBoard2PortIbTypeData.
        The number of shared receive queues supported by the host board.

        :return: The shared_receive_queues_supported of this HostBoard2PortIbTypeData.
        :rtype: int
        :required/optional: required
        """
        return self._shared_receive_queues_supported

    @shared_receive_queues_supported.setter
    def shared_receive_queues_supported(self, shared_receive_queues_supported):
        """
        Sets the shared_receive_queues_supported of this HostBoard2PortIbTypeData.
        The number of shared receive queues supported by the host board.

        :param shared_receive_queues_supported: The shared_receive_queues_supported of this HostBoard2PortIbTypeData.
        :type: int
        """
        self._shared_receive_queues_supported = shared_receive_queues_supported

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

