# coding: utf-8

"""
IoInterface.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IoInterface(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IoInterface - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'interface_ref': 'str',  # (required parameter)
            'channel_type': 'str',  # (required parameter)
            'io_interface_type_data': 'IOInterfaceTypeData',  # (required parameter)
            'controller_ref': 'str'
        }

        self.attribute_map = {
            'interface_ref': 'interfaceRef',  # (required parameter)
            'channel_type': 'channelType',  # (required parameter)
            'io_interface_type_data': 'ioInterfaceTypeData',  # (required parameter)
            'controller_ref': 'controllerRef'
        }

        self._interface_ref = None
        self._channel_type = None
        self._io_interface_type_data = None
        self._controller_ref = None

    @property
    def interface_ref(self):
        """
        Gets the interface_ref of this IoInterface.
        The SYMbol array-wide unique name for the interface object.

        :return: The interface_ref of this IoInterface.
        :rtype: str
        :required/optional: required
        """
        return self._interface_ref

    @interface_ref.setter
    def interface_ref(self, interface_ref):
        """
        Sets the interface_ref of this IoInterface.
        The SYMbol array-wide unique name for the interface object.

        :param interface_ref: The interface_ref of this IoInterface.
        :type: str
        """
        self._interface_ref = interface_ref

    @property
    def channel_type(self):
        """
        Gets the channel_type of this IoInterface.
        The type of channel (e.g., host-side, drive-side) that the interface is associated with.

        :return: The channel_type of this IoInterface.
        :rtype: str
        :required/optional: required
        """
        return self._channel_type

    @channel_type.setter
    def channel_type(self, channel_type):
        """
        Sets the channel_type of this IoInterface.
        The type of channel (e.g., host-side, drive-side) that the interface is associated with.

        :param channel_type: The channel_type of this IoInterface.
        :type: str
        """
        allowed_values = ["hostside", "driveside", "management", "__UNDEFINED"]
        if channel_type not in allowed_values:
            raise ValueError(
                "Invalid value for `channel_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._channel_type = channel_type

    @property
    def io_interface_type_data(self):
        """
        Gets the io_interface_type_data of this IoInterface.
        A field whose contents vary depending on the I/O protocol type of the interface.

        :return: The io_interface_type_data of this IoInterface.
        :rtype: IOInterfaceTypeData
        :required/optional: required
        """
        return self._io_interface_type_data

    @io_interface_type_data.setter
    def io_interface_type_data(self, io_interface_type_data):
        """
        Sets the io_interface_type_data of this IoInterface.
        A field whose contents vary depending on the I/O protocol type of the interface.

        :param io_interface_type_data: The io_interface_type_data of this IoInterface.
        :type: IOInterfaceTypeData
        """
        self._io_interface_type_data = io_interface_type_data

    @property
    def controller_ref(self):
        """
        Gets the controller_ref of this IoInterface.
        Uniquely identifies a particular physical RAID controller within the storage array.

        :return: The controller_ref of this IoInterface.
        :rtype: str
        :required/optional: required
        """
        return self._controller_ref

    @controller_ref.setter
    def controller_ref(self, controller_ref):
        """
        Sets the controller_ref of this IoInterface.
        Uniquely identifies a particular physical RAID controller within the storage array.

        :param controller_ref: The controller_ref of this IoInterface.
        :type: str
        """
        self._controller_ref = controller_ref

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

