# coding: utf-8

"""
IscsiInterfaceStatistics.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IscsiInterfaceStatistics(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IscsiInterfaceStatistics - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'ethernet_port_stats': 'list[EthernetPortStatistics]',  # (required parameter)
            'tcp_stats': 'list[TcpStatisticalData]',  # (required parameter)
            'ip_stats': 'list[IpEndpointStatistics]',  # (required parameter)
            'enh_stats': 'list[EnhancedEthernetStatistics]'
        }

        self.attribute_map = {
            'ethernet_port_stats': 'ethernetPortStats',  # (required parameter)
            'tcp_stats': 'tcpStats',  # (required parameter)
            'ip_stats': 'ipStats',  # (required parameter)
            'enh_stats': 'enhStats'
        }

        self._ethernet_port_stats = None
        self._tcp_stats = None
        self._ip_stats = None
        self._enh_stats = None

    @property
    def ethernet_port_stats(self):
        """
        Gets the ethernet_port_stats of this IscsiInterfaceStatistics.
        Statistics related to the physical Ethernet port.

        :return: The ethernet_port_stats of this IscsiInterfaceStatistics.
        :rtype: list[EthernetPortStatistics]
        :required/optional: required
        """
        return self._ethernet_port_stats

    @ethernet_port_stats.setter
    def ethernet_port_stats(self, ethernet_port_stats):
        """
        Sets the ethernet_port_stats of this IscsiInterfaceStatistics.
        Statistics related to the physical Ethernet port.

        :param ethernet_port_stats: The ethernet_port_stats of this IscsiInterfaceStatistics.
        :type: list[EthernetPortStatistics]
        """
        self._ethernet_port_stats = ethernet_port_stats

    @property
    def tcp_stats(self):
        """
        Gets the tcp_stats of this IscsiInterfaceStatistics.
        Statistics related to the TCP protocol.

        :return: The tcp_stats of this IscsiInterfaceStatistics.
        :rtype: list[TcpStatisticalData]
        :required/optional: required
        """
        return self._tcp_stats

    @tcp_stats.setter
    def tcp_stats(self, tcp_stats):
        """
        Sets the tcp_stats of this IscsiInterfaceStatistics.
        Statistics related to the TCP protocol.

        :param tcp_stats: The tcp_stats of this IscsiInterfaceStatistics.
        :type: list[TcpStatisticalData]
        """
        self._tcp_stats = tcp_stats

    @property
    def ip_stats(self):
        """
        Gets the ip_stats of this IscsiInterfaceStatistics.
        Statistics related to the IP protocol.

        :return: The ip_stats of this IscsiInterfaceStatistics.
        :rtype: list[IpEndpointStatistics]
        :required/optional: required
        """
        return self._ip_stats

    @ip_stats.setter
    def ip_stats(self, ip_stats):
        """
        Sets the ip_stats of this IscsiInterfaceStatistics.
        Statistics related to the IP protocol.

        :param ip_stats: The ip_stats of this IscsiInterfaceStatistics.
        :type: list[IpEndpointStatistics]
        """
        self._ip_stats = ip_stats

    @property
    def enh_stats(self):
        """
        Gets the enh_stats of this IscsiInterfaceStatistics.
        This member is used to report statistical data related to Enhanced Ethernet features.

        :return: The enh_stats of this IscsiInterfaceStatistics.
        :rtype: list[EnhancedEthernetStatistics]
        :required/optional: required
        """
        return self._enh_stats

    @enh_stats.setter
    def enh_stats(self, enh_stats):
        """
        Sets the enh_stats of this IscsiInterfaceStatistics.
        This member is used to report statistical data related to Enhanced Ethernet features.

        :param enh_stats: The enh_stats of this IscsiInterfaceStatistics.
        :type: list[EnhancedEthernetStatistics]
        """
        self._enh_stats = enh_stats

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

