# coding: utf-8

"""
IscsiSession.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IscsiSession(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IscsiSession - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',  # (required parameter)
            'tsih': 'int',  # (required parameter)
            'endpoints': 'IscsiSessionEndpoints',  # (required parameter)
            'negotiated_settings': 'IscsiNegotiableSessionSettings',  # (required parameter)
            'connections': 'list[IscsiConnection]'
        }

        self.attribute_map = {
            'type': 'type',  # (required parameter)
            'tsih': 'tsih',  # (required parameter)
            'endpoints': 'endpoints',  # (required parameter)
            'negotiated_settings': 'negotiatedSettings',  # (required parameter)
            'connections': 'connections'
        }

        self._type = None
        self._tsih = None
        self._endpoints = None
        self._negotiated_settings = None
        self._connections = None

    @property
    def type(self):
        """
        Gets the type of this IscsiSession.
        The type of session, discovery or normal.

        :return: The type of this IscsiSession.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this IscsiSession.
        The type of session, discovery or normal.

        :param type: The type of this IscsiSession.
        :type: str
        """
        allowed_values = ["discovery", "normal", "__UNDEFINED"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def tsih(self):
        """
        Gets the tsih of this IscsiSession.
        A target-assigned handle of unspecified format that uniquely identifies the session.

        :return: The tsih of this IscsiSession.
        :rtype: int
        :required/optional: required
        """
        return self._tsih

    @tsih.setter
    def tsih(self, tsih):
        """
        Sets the tsih of this IscsiSession.
        A target-assigned handle of unspecified format that uniquely identifies the session.

        :param tsih: The tsih of this IscsiSession.
        :type: int
        """
        self._tsih = tsih

    @property
    def endpoints(self):
        """
        Gets the endpoints of this IscsiSession.
        The SCSI protocol endpoints of the session.

        :return: The endpoints of this IscsiSession.
        :rtype: IscsiSessionEndpoints
        :required/optional: required
        """
        return self._endpoints

    @endpoints.setter
    def endpoints(self, endpoints):
        """
        Sets the endpoints of this IscsiSession.
        The SCSI protocol endpoints of the session.

        :param endpoints: The endpoints of this IscsiSession.
        :type: IscsiSessionEndpoints
        """
        self._endpoints = endpoints

    @property
    def negotiated_settings(self):
        """
        Gets the negotiated_settings of this IscsiSession.
        A collection of session-level settings that are subject to initiator-target negotiation.

        :return: The negotiated_settings of this IscsiSession.
        :rtype: IscsiNegotiableSessionSettings
        :required/optional: required
        """
        return self._negotiated_settings

    @negotiated_settings.setter
    def negotiated_settings(self, negotiated_settings):
        """
        Sets the negotiated_settings of this IscsiSession.
        A collection of session-level settings that are subject to initiator-target negotiation.

        :param negotiated_settings: The negotiated_settings of this IscsiSession.
        :type: IscsiNegotiableSessionSettings
        """
        self._negotiated_settings = negotiated_settings

    @property
    def connections(self):
        """
        Gets the connections of this IscsiSession.
        The set of connections that are associated with this session.

        :return: The connections of this IscsiSession.
        :rtype: list[IscsiConnection]
        :required/optional: required
        """
        return self._connections

    @connections.setter
    def connections(self, connections):
        """
        Sets the connections of this IscsiSession.
        The set of connections that are associated with this session.

        :param connections: The connections of this IscsiSession.
        :type: list[IscsiConnection]
        """
        self._connections = connections

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

