# coding: utf-8

"""
Location.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Location(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Location - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tray_ref': 'str',  # (required parameter)
            'slot': 'int',  # (required parameter)
            'location_parent': 'ObjectReference',  # (required parameter)
            'location_position': 'int',  # (required parameter)
            'label': 'str'
        }

        self.attribute_map = {
            'tray_ref': 'trayRef',  # (required parameter)
            'slot': 'slot',  # (required parameter)
            'location_parent': 'locationParent',  # (required parameter)
            'location_position': 'locationPosition',  # (required parameter)
            'label': 'label'
        }

        self._tray_ref = None
        self._slot = None
        self._location_parent = None
        self._location_position = None
        self._label = None

    @property
    def tray_ref(self):
        """
        Gets the tray_ref of this Location.
        The TrayRef reference value of the tray object in which the component resides.

        :return: The tray_ref of this Location.
        :rtype: str
        :required/optional: required
        """
        return self._tray_ref

    @tray_ref.setter
    def tray_ref(self, tray_ref):
        """
        Sets the tray_ref of this Location.
        The TrayRef reference value of the tray object in which the component resides.

        :param tray_ref: The tray_ref of this Location.
        :type: str
        """
        self._tray_ref = tray_ref

    @property
    def slot(self):
        """
        Gets the slot of this Location.
        The slot identifier, or ordinal identifier, of the component within its physical tray.

        :return: The slot of this Location.
        :rtype: int
        :required/optional: required
        """
        return self._slot

    @slot.setter
    def slot(self, slot):
        """
        Sets the slot of this Location.
        The slot identifier, or ordinal identifier, of the component within its physical tray.

        :param slot: The slot of this Location.
        :type: int
        """
        self._slot = slot

    @property
    def location_parent(self):
        """
        Gets the location_parent of this Location.
        An object reference that identifies the parent physical component (e.g., Tray, CRU, etc.) of the object containing the Location attribute.

        :return: The location_parent of this Location.
        :rtype: ObjectReference
        :required/optional: required
        """
        return self._location_parent

    @location_parent.setter
    def location_parent(self, location_parent):
        """
        Sets the location_parent of this Location.
        An object reference that identifies the parent physical component (e.g., Tray, CRU, etc.) of the object containing the Location attribute.

        :param location_parent: The location_parent of this Location.
        :type: ObjectReference
        """
        self._location_parent = location_parent

    @property
    def location_position(self):
        """
        Gets the location_position of this Location.
        The parent-relative/like-component relative position of the object containing the Location attribute.

        :return: The location_position of this Location.
        :rtype: int
        :required/optional: required
        """
        return self._location_position

    @location_position.setter
    def location_position(self, location_position):
        """
        Sets the location_position of this Location.
        The parent-relative/like-component relative position of the object containing the Location attribute.

        :param location_position: The location_position of this Location.
        :type: int
        """
        self._location_position = location_position

    @property
    def label(self):
        """
        Gets the label of this Location.
        Label associated with the location (i.e., label printed on the canister or the enclosure).

        :return: The label of this Location.
        :rtype: str
        :required/optional: required
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this Location.
        Label associated with the location (i.e., label printed on the canister or the enclosure).

        :param label: The label of this Location.
        :type: str
        """
        self._label = label

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

