# coding: utf-8

"""
MirrorRoleChangeDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class MirrorRoleChangeDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MirrorRoleChangeDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'mirror_proxy': 'str',  # (required parameter)
            'forced': 'bool',  # (required parameter)
            'to_role': 'str'
        }

        self.attribute_map = {
            'mirror_proxy': 'mirrorProxy',  # (required parameter)
            'forced': 'forced',  # (required parameter)
            'to_role': 'toRole'
        }

        self._mirror_proxy = None
        self._forced = None
        self._to_role = None

    @property
    def mirror_proxy(self):
        """
        Gets the mirror_proxy of this MirrorRoleChangeDescriptor.
        The reference to the mirror proxy volume.

        :return: The mirror_proxy of this MirrorRoleChangeDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._mirror_proxy

    @mirror_proxy.setter
    def mirror_proxy(self, mirror_proxy):
        """
        Sets the mirror_proxy of this MirrorRoleChangeDescriptor.
        The reference to the mirror proxy volume.

        :param mirror_proxy: The mirror_proxy of this MirrorRoleChangeDescriptor.
        :type: str
        """
        self._mirror_proxy = mirror_proxy

    @property
    def forced(self):
        """
        Gets the forced of this MirrorRoleChangeDescriptor.
        If true, ignore if remote array role change fails.

        :return: The forced of this MirrorRoleChangeDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._forced

    @forced.setter
    def forced(self, forced):
        """
        Sets the forced of this MirrorRoleChangeDescriptor.
        If true, ignore if remote array role change fails.

        :param forced: The forced of this MirrorRoleChangeDescriptor.
        :type: bool
        """
        self._forced = forced

    @property
    def to_role(self):
        """
        Gets the to_role of this MirrorRoleChangeDescriptor.
        The role to change the local mirror proxy volume to: primary or secondary.

        :return: The to_role of this MirrorRoleChangeDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._to_role

    @to_role.setter
    def to_role(self, to_role):
        """
        Sets the to_role of this MirrorRoleChangeDescriptor.
        The role to change the local mirror proxy volume to: primary or secondary.

        :param to_role: The to_role of this MirrorRoleChangeDescriptor.
        :type: str
        """
        allowed_values = ["primary", "secondary", "invalid", "__UNDEFINED"]
        if to_role not in allowed_values:
            raise ValueError(
                "Invalid value for `to_role`, must be one of {0}"
                .format(allowed_values)
            )
        self._to_role = to_role

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

