# coding: utf-8

"""
NewLockKey.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class NewLockKey(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NewLockKey - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'lock_key_id': 'str',  # (required parameter)
            'wrapped_lock_key': 'str',  # (required parameter)
            'new_key_sequence': 'int'
        }

        self.attribute_map = {
            'lock_key_id': 'lockKeyID',  # (required parameter)
            'wrapped_lock_key': 'wrappedLockKey',  # (required parameter)
            'new_key_sequence': 'newKeySequence'
        }

        self._lock_key_id = None
        self._wrapped_lock_key = None
        self._new_key_sequence = None

    @property
    def lock_key_id(self):
        """
        Gets the lock_key_id of this NewLockKey.
        The lock key ID to set for this lock key.

        :return: The lock_key_id of this NewLockKey.
        :rtype: str
        :required/optional: required
        """
        return self._lock_key_id

    @lock_key_id.setter
    def lock_key_id(self, lock_key_id):
        """
        Sets the lock_key_id of this NewLockKey.
        The lock key ID to set for this lock key.

        :param lock_key_id: The lock_key_id of this NewLockKey.
        :type: str
        """
        self._lock_key_id = lock_key_id

    @property
    def wrapped_lock_key(self):
        """
        Gets the wrapped_lock_key of this NewLockKey.
        The wrapped lock key.

        :return: The wrapped_lock_key of this NewLockKey.
        :rtype: str
        :required/optional: required
        """
        return self._wrapped_lock_key

    @wrapped_lock_key.setter
    def wrapped_lock_key(self, wrapped_lock_key):
        """
        Sets the wrapped_lock_key of this NewLockKey.
        The wrapped lock key.

        :param wrapped_lock_key: The wrapped_lock_key of this NewLockKey.
        :type: str
        """
        self._wrapped_lock_key = wrapped_lock_key

    @property
    def new_key_sequence(self):
        """
        Gets the new_key_sequence of this NewLockKey.
        The sequence number for this key.

        :return: The new_key_sequence of this NewLockKey.
        :rtype: int
        :required/optional: required
        """
        return self._new_key_sequence

    @new_key_sequence.setter
    def new_key_sequence(self, new_key_sequence):
        """
        Sets the new_key_sequence of this NewLockKey.
        The sequence number for this key.

        :param new_key_sequence: The new_key_sequence of this NewLockKey.
        :type: int
        """
        self._new_key_sequence = new_key_sequence

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

