# coding: utf-8

"""
PendingHost.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class PendingHost(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PendingHost - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host_label': 'str',  # (required parameter)
            'host_type': 'str',  # (required parameter)
            'host_port_id': 'list[SCSIInitiatorPortId]'
        }

        self.attribute_map = {
            'host_label': 'hostLabel',  # (required parameter)
            'host_type': 'hostType',  # (required parameter)
            'host_port_id': 'hostPortId'
        }

        self._host_label = None
        self._host_type = None
        self._host_port_id = None

    @property
    def host_label(self):
        """
        Gets the host_label of this PendingHost.
        The official node name of the host to which the pending topology host port belongs.

        :return: The host_label of this PendingHost.
        :rtype: str
        :required/optional: required
        """
        return self._host_label

    @host_label.setter
    def host_label(self, host_label):
        """
        Sets the host_label of this PendingHost.
        The official node name of the host to which the pending topology host port belongs.

        :param host_label: The host_label of this PendingHost.
        :type: str
        """
        self._host_label = host_label

    @property
    def host_type(self):
        """
        Gets the host_type of this PendingHost.
        A string representing the host type of the pending topology host port. The contents of this field is the \"short form\" of the host type label used in the controller firmware.

        :return: The host_type of this PendingHost.
        :rtype: str
        :required/optional: required
        """
        return self._host_type

    @host_type.setter
    def host_type(self, host_type):
        """
        Sets the host_type of this PendingHost.
        A string representing the host type of the pending topology host port. The contents of this field is the \"short form\" of the host type label used in the controller firmware.

        :param host_type: The host_type of this PendingHost.
        :type: str
        """
        self._host_type = host_type

    @property
    def host_port_id(self):
        """
        Gets the host_port_id of this PendingHost.
        This field is a variable-length list of SCSIInitiatorPortId objects representing the ports associated with the host.

        :return: The host_port_id of this PendingHost.
        :rtype: list[SCSIInitiatorPortId]
        :required/optional: required
        """
        return self._host_port_id

    @host_port_id.setter
    def host_port_id(self, host_port_id):
        """
        Sets the host_port_id of this PendingHost.
        This field is a variable-length list of SCSIInitiatorPortId objects representing the ports associated with the host.

        :param host_port_id: The host_port_id of this PendingHost.
        :type: list[SCSIInitiatorPortId]
        """
        self._host_port_id = host_port_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

