# coding: utf-8

"""
PITViewCreationDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class PITViewCreationDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PITViewCreationDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'base_pit': 'str',  # (required parameter)
            'view_label': 'str',  # (required parameter)
            'repository_descriptor': 'PITViewRepositoryCreationDescriptor',  # (required parameter)
            'full_warn_threshold': 'int'
        }

        self.attribute_map = {
            'base_pit': 'basePIT',  # (required parameter)
            'view_label': 'viewLabel',  # (required parameter)
            'repository_descriptor': 'repositoryDescriptor',  # (required parameter)
            'full_warn_threshold': 'fullWarnThreshold'
        }

        self._base_pit = None
        self._view_label = None
        self._repository_descriptor = None
        self._full_warn_threshold = None

    @property
    def base_pit(self):
        """
        Gets the base_pit of this PITViewCreationDescriptor.
        A reference to the base PiT.

        :return: The base_pit of this PITViewCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._base_pit

    @base_pit.setter
    def base_pit(self, base_pit):
        """
        Sets the base_pit of this PITViewCreationDescriptor.
        A reference to the base PiT.

        :param base_pit: The base_pit of this PITViewCreationDescriptor.
        :type: str
        """
        self._base_pit = base_pit

    @property
    def view_label(self):
        """
        Gets the view_label of this PITViewCreationDescriptor.
        The name of the view.

        :return: The view_label of this PITViewCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._view_label

    @view_label.setter
    def view_label(self, view_label):
        """
        Sets the view_label of this PITViewCreationDescriptor.
        The name of the view.

        :param view_label: The view_label of this PITViewCreationDescriptor.
        :type: str
        """
        self._view_label = view_label

    @property
    def repository_descriptor(self):
        """
        Gets the repository_descriptor of this PITViewCreationDescriptor.
        The copy-on-write repository for this view.

        :return: The repository_descriptor of this PITViewCreationDescriptor.
        :rtype: PITViewRepositoryCreationDescriptor
        :required/optional: required
        """
        return self._repository_descriptor

    @repository_descriptor.setter
    def repository_descriptor(self, repository_descriptor):
        """
        Sets the repository_descriptor of this PITViewCreationDescriptor.
        The copy-on-write repository for this view.

        :param repository_descriptor: The repository_descriptor of this PITViewCreationDescriptor.
        :type: PITViewRepositoryCreationDescriptor
        """
        self._repository_descriptor = repository_descriptor

    @property
    def full_warn_threshold(self):
        """
        Gets the full_warn_threshold of this PITViewCreationDescriptor.
        The repository utilization warning threshold percentage.

        :return: The full_warn_threshold of this PITViewCreationDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._full_warn_threshold

    @full_warn_threshold.setter
    def full_warn_threshold(self, full_warn_threshold):
        """
        Sets the full_warn_threshold of this PITViewCreationDescriptor.
        The repository utilization warning threshold percentage.

        :param full_warn_threshold: The full_warn_threshold of this PITViewCreationDescriptor.
        :type: int
        """
        self._full_warn_threshold = full_warn_threshold

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

