# coding: utf-8

"""
PITViewRWConversionDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class PITViewRWConversionDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PITViewRWConversionDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'view_ref': 'str',  # (required parameter)
            'repository_candidate': 'ConcatVolumeCreationDescriptor',  # (required parameter)
            'full_warn_threshold': 'int'
        }

        self.attribute_map = {
            'view_ref': 'viewRef',  # (required parameter)
            'repository_candidate': 'repositoryCandidate',  # (required parameter)
            'full_warn_threshold': 'fullWarnThreshold'
        }

        self._view_ref = None
        self._repository_candidate = None
        self._full_warn_threshold = None

    @property
    def view_ref(self):
        """
        Gets the view_ref of this PITViewRWConversionDescriptor.
        A reference to the view to convert.

        :return: The view_ref of this PITViewRWConversionDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._view_ref

    @view_ref.setter
    def view_ref(self, view_ref):
        """
        Sets the view_ref of this PITViewRWConversionDescriptor.
        A reference to the view to convert.

        :param view_ref: The view_ref of this PITViewRWConversionDescriptor.
        :type: str
        """
        self._view_ref = view_ref

    @property
    def repository_candidate(self):
        """
        Gets the repository_candidate of this PITViewRWConversionDescriptor.
        A descriptor for creation of the repository (read-only view does not have a repository so one must be created in order to convert to read/write).

        :return: The repository_candidate of this PITViewRWConversionDescriptor.
        :rtype: ConcatVolumeCreationDescriptor
        :required/optional: required
        """
        return self._repository_candidate

    @repository_candidate.setter
    def repository_candidate(self, repository_candidate):
        """
        Sets the repository_candidate of this PITViewRWConversionDescriptor.
        A descriptor for creation of the repository (read-only view does not have a repository so one must be created in order to convert to read/write).

        :param repository_candidate: The repository_candidate of this PITViewRWConversionDescriptor.
        :type: ConcatVolumeCreationDescriptor
        """
        self._repository_candidate = repository_candidate

    @property
    def full_warn_threshold(self):
        """
        Gets the full_warn_threshold of this PITViewRWConversionDescriptor.
        The repository full warning threshold. Although this is specified on the view already, it does not make sense for a read-only view and so should be validated/set as part of the conversion to read/write to ensure the value set makes sense for the now read/write view.

        :return: The full_warn_threshold of this PITViewRWConversionDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._full_warn_threshold

    @full_warn_threshold.setter
    def full_warn_threshold(self, full_warn_threshold):
        """
        Sets the full_warn_threshold of this PITViewRWConversionDescriptor.
        The repository full warning threshold. Although this is specified on the view already, it does not make sense for a read-only view and so should be validated/set as part of the conversion to read/write to ensure the value set makes sense for the now read/write view.

        :param full_warn_threshold: The full_warn_threshold of this PITViewRWConversionDescriptor.
        :type: int
        """
        self._full_warn_threshold = full_warn_threshold

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

