# coding: utf-8

"""
Recurrence.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Recurrence(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Recurrence - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'recurrence_type': 'str',  # (required parameter)
            'recurrence_count': 'int',  
            'recurrence_end_date': 'int'
        }

        self.attribute_map = {
            'recurrence_type': 'recurrenceType',  # (required parameter)
            'recurrence_count': 'recurrenceCount',  
            'recurrence_end_date': 'recurrenceEndDate'
        }

        self._recurrence_type = None
        self._recurrence_count = None
        self._recurrence_end_date = None

    @property
    def recurrence_type(self):
        """
        Gets the recurrence_type of this Recurrence.
        This enumeration is used to specify the type of schedule recurrence.

        :return: The recurrence_type of this Recurrence.
        :rtype: str
        :required/optional: required
        """
        return self._recurrence_type

    @recurrence_type.setter
    def recurrence_type(self, recurrence_type):
        """
        Sets the recurrence_type of this Recurrence.
        This enumeration is used to specify the type of schedule recurrence.

        :param recurrence_type: The recurrence_type of this Recurrence.
        :type: str
        """
        allowed_values = ["unknown", "unlimited", "count", "endDate", "__UNDEFINED"]
        if recurrence_type not in allowed_values:
            raise ValueError(
                "Invalid value for `recurrence_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._recurrence_type = recurrence_type

    @property
    def recurrence_count(self):
        """
        Gets the recurrence_count of this Recurrence.
        This field is present only if recurrenceType is equal to RECURRENCE_COUNT.

        :return: The recurrence_count of this Recurrence.
        :rtype: int
        :required/optional: optional
        """
        return self._recurrence_count

    @recurrence_count.setter
    def recurrence_count(self, recurrence_count):
        """
        Sets the recurrence_count of this Recurrence.
        This field is present only if recurrenceType is equal to RECURRENCE_COUNT.

        :param recurrence_count: The recurrence_count of this Recurrence.
        :type: int
        """
        self._recurrence_count = recurrence_count

    @property
    def recurrence_end_date(self):
        """
        Gets the recurrence_end_date of this Recurrence.
        This field is present only if recurrenceType is equal to RECURRENCE_END_DATE.

        :return: The recurrence_end_date of this Recurrence.
        :rtype: int
        :required/optional: optional
        """
        return self._recurrence_end_date

    @recurrence_end_date.setter
    def recurrence_end_date(self, recurrence_end_date):
        """
        Sets the recurrence_end_date of this Recurrence.
        This field is present only if recurrenceType is equal to RECURRENCE_END_DATE.

        :param recurrence_end_date: The recurrence_end_date of this Recurrence.
        :type: int
        """
        self._recurrence_end_date = recurrence_end_date

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

