# coding: utf-8

"""
RegisteredPorts.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RegisteredPorts(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RegisteredPorts - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'port_a0': 'bool',  
            'port_a1': 'bool',  
            'port_b0': 'bool',  
            'port_b1': 'bool'
        }

        self.attribute_map = {
            'port_a0': 'portA0',  
            'port_a1': 'portA1',  
            'port_b0': 'portB0',  
            'port_b1': 'portB1'
        }

        self._port_a0 = None
        self._port_a1 = None
        self._port_b0 = None
        self._port_b1 = None

    @property
    def port_a0(self):
        """
        Gets the port_a0 of this RegisteredPorts.


        :return: The port_a0 of this RegisteredPorts.
        :rtype: bool
        :required/optional: optional
        """
        return self._port_a0

    @port_a0.setter
    def port_a0(self, port_a0):
        """
        Sets the port_a0 of this RegisteredPorts.


        :param port_a0: The port_a0 of this RegisteredPorts.
        :type: bool
        """
        self._port_a0 = port_a0

    @property
    def port_a1(self):
        """
        Gets the port_a1 of this RegisteredPorts.


        :return: The port_a1 of this RegisteredPorts.
        :rtype: bool
        :required/optional: optional
        """
        return self._port_a1

    @port_a1.setter
    def port_a1(self, port_a1):
        """
        Sets the port_a1 of this RegisteredPorts.


        :param port_a1: The port_a1 of this RegisteredPorts.
        :type: bool
        """
        self._port_a1 = port_a1

    @property
    def port_b0(self):
        """
        Gets the port_b0 of this RegisteredPorts.


        :return: The port_b0 of this RegisteredPorts.
        :rtype: bool
        :required/optional: optional
        """
        return self._port_b0

    @port_b0.setter
    def port_b0(self, port_b0):
        """
        Sets the port_b0 of this RegisteredPorts.


        :param port_b0: The port_b0 of this RegisteredPorts.
        :type: bool
        """
        self._port_b0 = port_b0

    @property
    def port_b1(self):
        """
        Gets the port_b1 of this RegisteredPorts.


        :return: The port_b1 of this RegisteredPorts.
        :rtype: bool
        :required/optional: optional
        """
        return self._port_b1

    @port_b1.setter
    def port_b1(self, port_b1):
        """
        Sets the port_b1 of this RegisteredPorts.


        :param port_b1: The port_b1 of this RegisteredPorts.
        :type: bool
        """
        self._port_b1 = port_b1

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

