# coding: utf-8

"""
RuntimeDiagTestResults.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RuntimeDiagTestResults(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RuntimeDiagTestResults - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'test_id': 'str',  # (required parameter)
            'channel': 'int',  # (required parameter)
            'test_status': 'str',  # (required parameter)
            'test_level': 'str'
        }

        self.attribute_map = {
            'test_id': 'testID',  # (required parameter)
            'channel': 'channel',  # (required parameter)
            'test_status': 'testStatus',  # (required parameter)
            'test_level': 'testLevel'
        }

        self._test_id = None
        self._channel = None
        self._test_status = None
        self._test_level = None

    @property
    def test_id(self):
        """
        Gets the test_id of this RuntimeDiagTestResults.
        Identifies the test the results are for.

        :return: The test_id of this RuntimeDiagTestResults.
        :rtype: str
        :required/optional: required
        """
        return self._test_id

    @test_id.setter
    def test_id(self, test_id):
        """
        Sets the test_id of this RuntimeDiagTestResults.
        Identifies the test the results are for.

        :param test_id: The test_id of this RuntimeDiagTestResults.
        :type: str
        """
        allowed_values = ["all", "read", "loopbackData", "write", "__UNDEFINED"]
        if test_id not in allowed_values:
            raise ValueError(
                "Invalid value for `test_id`, must be one of {0}"
                .format(allowed_values)
            )
        self._test_id = test_id

    @property
    def channel(self):
        """
        Gets the channel of this RuntimeDiagTestResults.
        Identifies the channel the test was run on.

        :return: The channel of this RuntimeDiagTestResults.
        :rtype: int
        :required/optional: required
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """
        Sets the channel of this RuntimeDiagTestResults.
        Identifies the channel the test was run on.

        :param channel: The channel of this RuntimeDiagTestResults.
        :type: int
        """
        self._channel = channel

    @property
    def test_status(self):
        """
        Gets the test_status of this RuntimeDiagTestResults.
        Identifies the status of the test.

        :return: The test_status of this RuntimeDiagTestResults.
        :rtype: str
        :required/optional: required
        """
        return self._test_status

    @test_status.setter
    def test_status(self, test_status):
        """
        Sets the test_status of this RuntimeDiagTestResults.
        Identifies the status of the test.

        :param test_status: The test_status of this RuntimeDiagTestResults.
        :type: str
        """
        allowed_values = ["none", "success", "failure", "__UNDEFINED"]
        if test_status not in allowed_values:
            raise ValueError(
                "Invalid value for `test_status`, must be one of {0}"
                .format(allowed_values)
            )
        self._test_status = test_status

    @property
    def test_level(self):
        """
        Gets the test_level of this RuntimeDiagTestResults.
        Identifies the level of the test run.

        :return: The test_level of this RuntimeDiagTestResults.
        :rtype: str
        :required/optional: required
        """
        return self._test_level

    @test_level.setter
    def test_level(self, test_level):
        """
        Sets the test_level of this RuntimeDiagTestResults.
        Identifies the level of the test run.

        :param test_level: The test_level of this RuntimeDiagTestResults.
        :type: str
        """
        allowed_values = ["internal", "external", "__UNDEFINED"]
        if test_level not in allowed_values:
            raise ValueError(
                "Invalid value for `test_level`, must be one of {0}"
                .format(allowed_values)
            )
        self._test_level = test_level

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

