# coding: utf-8

"""
SasPhyErrorCounts.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SasPhyErrorCounts(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SasPhyErrorCounts - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'invalid_dword_count': 'int',  # (required parameter)
            'running_disparity_error_count': 'int',  # (required parameter)
            'loss_of_dword_sync_count': 'int',  # (required parameter)
            'reset_problem_count': 'int'
        }

        self.attribute_map = {
            'invalid_dword_count': 'invalidDwordCount',  # (required parameter)
            'running_disparity_error_count': 'runningDisparityErrorCount',  # (required parameter)
            'loss_of_dword_sync_count': 'lossOfDwordSyncCount',  # (required parameter)
            'reset_problem_count': 'resetProblemCount'
        }

        self._invalid_dword_count = None
        self._running_disparity_error_count = None
        self._loss_of_dword_sync_count = None
        self._reset_problem_count = None

    @property
    def invalid_dword_count(self):
        """
        Gets the invalid_dword_count of this SasPhyErrorCounts.
        The number of invalid dwords that have been received outside of PHY reset sequences.

        :return: The invalid_dword_count of this SasPhyErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._invalid_dword_count

    @invalid_dword_count.setter
    def invalid_dword_count(self, invalid_dword_count):
        """
        Sets the invalid_dword_count of this SasPhyErrorCounts.
        The number of invalid dwords that have been received outside of PHY reset sequences.

        :param invalid_dword_count: The invalid_dword_count of this SasPhyErrorCounts.
        :type: int
        """
        self._invalid_dword_count = invalid_dword_count

    @property
    def running_disparity_error_count(self):
        """
        Gets the running_disparity_error_count of this SasPhyErrorCounts.
        The number of dwords containing running disparity errors that have been received outside of PHY reset sequences.

        :return: The running_disparity_error_count of this SasPhyErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._running_disparity_error_count

    @running_disparity_error_count.setter
    def running_disparity_error_count(self, running_disparity_error_count):
        """
        Sets the running_disparity_error_count of this SasPhyErrorCounts.
        The number of dwords containing running disparity errors that have been received outside of PHY reset sequences.

        :param running_disparity_error_count: The running_disparity_error_count of this SasPhyErrorCounts.
        :type: int
        """
        self._running_disparity_error_count = running_disparity_error_count

    @property
    def loss_of_dword_sync_count(self):
        """
        Gets the loss_of_dword_sync_count of this SasPhyErrorCounts.
        The number of times the PHY has restarted the link reset sequence because it lost dword synchronization.

        :return: The loss_of_dword_sync_count of this SasPhyErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._loss_of_dword_sync_count

    @loss_of_dword_sync_count.setter
    def loss_of_dword_sync_count(self, loss_of_dword_sync_count):
        """
        Sets the loss_of_dword_sync_count of this SasPhyErrorCounts.
        The number of times the PHY has restarted the link reset sequence because it lost dword synchronization.

        :param loss_of_dword_sync_count: The loss_of_dword_sync_count of this SasPhyErrorCounts.
        :type: int
        """
        self._loss_of_dword_sync_count = loss_of_dword_sync_count

    @property
    def reset_problem_count(self):
        """
        Gets the reset_problem_count of this SasPhyErrorCounts.
        The number of times the PHY did not receive dword synchronization during the final SAS speed negotiation window.

        :return: The reset_problem_count of this SasPhyErrorCounts.
        :rtype: int
        :required/optional: required
        """
        return self._reset_problem_count

    @reset_problem_count.setter
    def reset_problem_count(self, reset_problem_count):
        """
        Sets the reset_problem_count of this SasPhyErrorCounts.
        The number of times the PHY did not receive dword synchronization during the final SAS speed negotiation window.

        :param reset_problem_count: The reset_problem_count of this SasPhyErrorCounts.
        :type: int
        """
        self._reset_problem_count = reset_problem_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

