# coding: utf-8

"""
SasPortTypeData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SasPortTypeData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SasPortTypeData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'port_type': 'str',  # (required parameter)
            'port_identifier': 'str',  
            'routing_type': 'str'
        }

        self.attribute_map = {
            'port_type': 'portType',  # (required parameter)
            'port_identifier': 'portIdentifier',  
            'routing_type': 'routingType'
        }

        self._port_type = None
        self._port_identifier = None
        self._routing_type = None

    @property
    def port_type(self):
        """
        Gets the port_type of this SasPortTypeData.
        This enumeration specifies the different types of SAS ports.

        :return: The port_type of this SasPortTypeData.
        :rtype: str
        :required/optional: required
        """
        return self._port_type

    @port_type.setter
    def port_type(self, port_type):
        """
        Sets the port_type of this SasPortTypeData.
        This enumeration specifies the different types of SAS ports.

        :param port_type: The port_type of this SasPortTypeData.
        :type: str
        """
        allowed_values = ["endDevice", "expander", "__UNDEFINED"]
        if port_type not in allowed_values:
            raise ValueError(
                "Invalid value for `port_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._port_type = port_type

    @property
    def port_identifier(self):
        """
        Gets the port_identifier of this SasPortTypeData.
        This field is the SAS address that is the port identifier. It is present only if the portType value is equal to SAS_PORT_TYPE_END_DEVICE.

        :return: The port_identifier of this SasPortTypeData.
        :rtype: str
        :required/optional: optional
        """
        return self._port_identifier

    @port_identifier.setter
    def port_identifier(self, port_identifier):
        """
        Sets the port_identifier of this SasPortTypeData.
        This field is the SAS address that is the port identifier. It is present only if the portType value is equal to SAS_PORT_TYPE_END_DEVICE.

        :param port_identifier: The port_identifier of this SasPortTypeData.
        :type: str
        """
        self._port_identifier = port_identifier

    @property
    def routing_type(self):
        """
        Gets the routing_type of this SasPortTypeData.
        This field indicates the routing method used on this port. It is present only if the portType value is equal to SAS_PORT_TYPE_EXPANDER.

        :return: The routing_type of this SasPortTypeData.
        :rtype: str
        :required/optional: optional
        """
        return self._routing_type

    @routing_type.setter
    def routing_type(self, routing_type):
        """
        Sets the routing_type of this SasPortTypeData.
        This field indicates the routing method used on this port. It is present only if the portType value is equal to SAS_PORT_TYPE_EXPANDER.

        :param routing_type: The routing_type of this SasPortTypeData.
        :type: str
        """
        allowed_values = ["direct", "table", "subtractive", "__UNDEFINED"]
        if routing_type not in allowed_values:
            raise ValueError(
                "Invalid value for `routing_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._routing_type = routing_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

