# coding: utf-8

"""
ScheduleInstance.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ScheduleInstance(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ScheduleInstance - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'sched_ref': 'str',  # (required parameter)
            'schedule_status': 'str',  # (required parameter)
            'action': 'str',  # (required parameter)
            'target_object': 'str',  # (required parameter)
            'schedule': 'Schedule',  # (required parameter)
            'creation_time': 'int',  # (required parameter)
            'last_run_time': 'int',  # (required parameter)
            'next_run_time': 'int',  # (required parameter)
            'stop_time': 'int',  # (required parameter)
            'id': 'str'
        }

        self.attribute_map = {
            'sched_ref': 'schedRef',  # (required parameter)
            'schedule_status': 'scheduleStatus',  # (required parameter)
            'action': 'action',  # (required parameter)
            'target_object': 'targetObject',  # (required parameter)
            'schedule': 'schedule',  # (required parameter)
            'creation_time': 'creationTime',  # (required parameter)
            'last_run_time': 'lastRunTime',  # (required parameter)
            'next_run_time': 'nextRunTime',  # (required parameter)
            'stop_time': 'stopTime',  # (required parameter)
            'id': 'id'
        }

        self._sched_ref = None
        self._schedule_status = None
        self._action = None
        self._target_object = None
        self._schedule = None
        self._creation_time = None
        self._last_run_time = None
        self._next_run_time = None
        self._stop_time = None
        self._id = None

    @property
    def sched_ref(self):
        """
        Gets the sched_ref of this ScheduleInstance.
        A reference to the schedule object.

        :return: The sched_ref of this ScheduleInstance.
        :rtype: str
        :required/optional: required
        """
        return self._sched_ref

    @sched_ref.setter
    def sched_ref(self, sched_ref):
        """
        Sets the sched_ref of this ScheduleInstance.
        A reference to the schedule object.

        :param sched_ref: The sched_ref of this ScheduleInstance.
        :type: str
        """
        self._sched_ref = sched_ref

    @property
    def schedule_status(self):
        """
        Gets the schedule_status of this ScheduleInstance.
        The current status of the schedule.

        :return: The schedule_status of this ScheduleInstance.
        :rtype: str
        :required/optional: required
        """
        return self._schedule_status

    @schedule_status.setter
    def schedule_status(self, schedule_status):
        """
        Sets the schedule_status of this ScheduleInstance.
        The current status of the schedule.

        :param schedule_status: The schedule_status of this ScheduleInstance.
        :type: str
        """
        allowed_values = ["unknown", "active", "disabled", "completed", "__UNDEFINED"]
        if schedule_status not in allowed_values:
            raise ValueError(
                "Invalid value for `schedule_status`, must be one of {0}"
                .format(allowed_values)
            )
        self._schedule_status = schedule_status

    @property
    def action(self):
        """
        Gets the action of this ScheduleInstance.
        The type of action to be taken.

        :return: The action of this ScheduleInstance.
        :rtype: str
        :required/optional: required
        """
        return self._action

    @action.setter
    def action(self, action):
        """
        Sets the action of this ScheduleInstance.
        The type of action to be taken.

        :param action: The action of this ScheduleInstance.
        :type: str
        """
        allowed_values = ["unknown", "resnap", "newpit", "newcgpit", "__UNDEFINED"]
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action`, must be one of {0}"
                .format(allowed_values)
            )
        self._action = action

    @property
    def target_object(self):
        """
        Gets the target_object of this ScheduleInstance.
        The object associated with schedule.

        :return: The target_object of this ScheduleInstance.
        :rtype: str
        :required/optional: required
        """
        return self._target_object

    @target_object.setter
    def target_object(self, target_object):
        """
        Sets the target_object of this ScheduleInstance.
        The object associated with schedule.

        :param target_object: The target_object of this ScheduleInstance.
        :type: str
        """
        self._target_object = target_object

    @property
    def schedule(self):
        """
        Gets the schedule of this ScheduleInstance.
        The schedule information.

        :return: The schedule of this ScheduleInstance.
        :rtype: Schedule
        :required/optional: required
        """
        return self._schedule

    @schedule.setter
    def schedule(self, schedule):
        """
        Sets the schedule of this ScheduleInstance.
        The schedule information.

        :param schedule: The schedule of this ScheduleInstance.
        :type: Schedule
        """
        self._schedule = schedule

    @property
    def creation_time(self):
        """
        Gets the creation_time of this ScheduleInstance.
        The schedule creation time (local time) measured as seconds since January 1, 1970.

        :return: The creation_time of this ScheduleInstance.
        :rtype: int
        :required/optional: required
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """
        Sets the creation_time of this ScheduleInstance.
        The schedule creation time (local time) measured as seconds since January 1, 1970.

        :param creation_time: The creation_time of this ScheduleInstance.
        :type: int
        """
        self._creation_time = creation_time

    @property
    def last_run_time(self):
        """
        Gets the last_run_time of this ScheduleInstance.
        The last run time (local time) measured as seconds since January 1, 1970.

        :return: The last_run_time of this ScheduleInstance.
        :rtype: int
        :required/optional: required
        """
        return self._last_run_time

    @last_run_time.setter
    def last_run_time(self, last_run_time):
        """
        Sets the last_run_time of this ScheduleInstance.
        The last run time (local time) measured as seconds since January 1, 1970.

        :param last_run_time: The last_run_time of this ScheduleInstance.
        :type: int
        """
        self._last_run_time = last_run_time

    @property
    def next_run_time(self):
        """
        Gets the next_run_time of this ScheduleInstance.
        The next run time (local time) measured as seconds since January 1, 1970.

        :return: The next_run_time of this ScheduleInstance.
        :rtype: int
        :required/optional: required
        """
        return self._next_run_time

    @next_run_time.setter
    def next_run_time(self, next_run_time):
        """
        Sets the next_run_time of this ScheduleInstance.
        The next run time (local time) measured as seconds since January 1, 1970.

        :param next_run_time: The next_run_time of this ScheduleInstance.
        :type: int
        """
        self._next_run_time = next_run_time

    @property
    def stop_time(self):
        """
        Gets the stop_time of this ScheduleInstance.
        The local time after which schedule is no longer active, measured as seconds since January 1, 1970.

        :return: The stop_time of this ScheduleInstance.
        :rtype: int
        :required/optional: required
        """
        return self._stop_time

    @stop_time.setter
    def stop_time(self, stop_time):
        """
        Sets the stop_time of this ScheduleInstance.
        The local time after which schedule is no longer active, measured as seconds since January 1, 1970.

        :param stop_time: The stop_time of this ScheduleInstance.
        :type: int
        """
        self._stop_time = stop_time

    @property
    def id(self):
        """
        Gets the id of this ScheduleInstance.


        :return: The id of this ScheduleInstance.
        :rtype: str
        :required/optional: optional
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ScheduleInstance.


        :param id: The id of this ScheduleInstance.
        :type: str
        """
        self._id = id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

