# coding: utf-8

"""
SNMPAgentBundle.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SNMPAgentBundle(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SNMPAgentBundle - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'community': 'list[SNMPCommunity]',  # (required parameter)
            'trap_destination': 'list[SNMPTrapDestination]',  # (required parameter)
            'system_variables': 'SNMPSystemVariables'
        }

        self.attribute_map = {
            'community': 'community',  # (required parameter)
            'trap_destination': 'trapDestination',  # (required parameter)
            'system_variables': 'systemVariables'
        }

        self._community = None
        self._trap_destination = None
        self._system_variables = None

    @property
    def community(self):
        """
        Gets the community of this SNMPAgentBundle.
        All configured SNMP communities

        :return: The community of this SNMPAgentBundle.
        :rtype: list[SNMPCommunity]
        :required/optional: required
        """
        return self._community

    @community.setter
    def community(self, community):
        """
        Sets the community of this SNMPAgentBundle.
        All configured SNMP communities

        :param community: The community of this SNMPAgentBundle.
        :type: list[SNMPCommunity]
        """
        self._community = community

    @property
    def trap_destination(self):
        """
        Gets the trap_destination of this SNMPAgentBundle.
        SNMP Trap Destinations. Traps will be delivered to these destinations when an alertable MEL event is generated.

        :return: The trap_destination of this SNMPAgentBundle.
        :rtype: list[SNMPTrapDestination]
        :required/optional: required
        """
        return self._trap_destination

    @trap_destination.setter
    def trap_destination(self, trap_destination):
        """
        Sets the trap_destination of this SNMPAgentBundle.
        SNMP Trap Destinations. Traps will be delivered to these destinations when an alertable MEL event is generated.

        :param trap_destination: The trap_destination of this SNMPAgentBundle.
        :type: list[SNMPTrapDestination]
        """
        self._trap_destination = trap_destination

    @property
    def system_variables(self):
        """
        Gets the system_variables of this SNMPAgentBundle.
        Current settings for SNMP \"system\" variables

        :return: The system_variables of this SNMPAgentBundle.
        :rtype: SNMPSystemVariables
        :required/optional: required
        """
        return self._system_variables

    @system_variables.setter
    def system_variables(self, system_variables):
        """
        Sets the system_variables of this SNMPAgentBundle.
        Current settings for SNMP \"system\" variables

        :param system_variables: The system_variables of this SNMPAgentBundle.
        :type: SNMPSystemVariables
        """
        self._system_variables = system_variables

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

