# coding: utf-8

"""
SNMPCommunityParamsUpdateDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SNMPCommunityParamsUpdateDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SNMPCommunityParamsUpdateDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'community_ref': 'str',  # (required parameter)
            'community_permissions': 'str',  # (required parameter)
            'community_name': 'str'
        }

        self.attribute_map = {
            'community_ref': 'communityRef',  # (required parameter)
            'community_permissions': 'communityPermissions',  # (required parameter)
            'community_name': 'communityName'
        }

        self._community_ref = None
        self._community_permissions = None
        self._community_name = None

    @property
    def community_ref(self):
        """
        Gets the community_ref of this SNMPCommunityParamsUpdateDescriptor.
        Community to update

        :return: The community_ref of this SNMPCommunityParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._community_ref

    @community_ref.setter
    def community_ref(self, community_ref):
        """
        Sets the community_ref of this SNMPCommunityParamsUpdateDescriptor.
        Community to update

        :param community_ref: The community_ref of this SNMPCommunityParamsUpdateDescriptor.
        :type: str
        """
        self._community_ref = community_ref

    @property
    def community_permissions(self):
        """
        Gets the community_permissions of this SNMPCommunityParamsUpdateDescriptor.
        New permissions to set

        :return: The community_permissions of this SNMPCommunityParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._community_permissions

    @community_permissions.setter
    def community_permissions(self, community_permissions):
        """
        Sets the community_permissions of this SNMPCommunityParamsUpdateDescriptor.
        New permissions to set

        :param community_permissions: The community_permissions of this SNMPCommunityParamsUpdateDescriptor.
        :type: str
        """
        allowed_values = ["unknown", "readOnly", "readWrite", "__UNDEFINED"]
        if community_permissions not in allowed_values:
            raise ValueError(
                "Invalid value for `community_permissions`, must be one of {0}"
                .format(allowed_values)
            )
        self._community_permissions = community_permissions

    @property
    def community_name(self):
        """
        Gets the community_name of this SNMPCommunityParamsUpdateDescriptor.
        New community name.

        :return: The community_name of this SNMPCommunityParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._community_name

    @community_name.setter
    def community_name(self, community_name):
        """
        Sets the community_name of this SNMPCommunityParamsUpdateDescriptor.
        New community name.

        :param community_name: The community_name of this SNMPCommunityParamsUpdateDescriptor.
        :type: str
        """
        self._community_name = community_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

