# coding: utf-8

"""
SNMPSystemVariableValue.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SNMPSystemVariableValue(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SNMPSystemVariableValue - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'variable': 'str',  # (required parameter)
            'new_sys_name': 'str',  
            'new_sys_contact': 'str',  
            'new_sys_location': 'str'
        }

        self.attribute_map = {
            'variable': 'variable',  # (required parameter)
            'new_sys_name': 'newSysName',  
            'new_sys_contact': 'newSysContact',  
            'new_sys_location': 'newSysLocation'
        }

        self._variable = None
        self._new_sys_name = None
        self._new_sys_contact = None
        self._new_sys_location = None

    @property
    def variable(self):
        """
        Gets the variable of this SNMPSystemVariableValue.
        This enumeration represents possible SNMP system variables that can be set via SYMbol.

        :return: The variable of this SNMPSystemVariableValue.
        :rtype: str
        :required/optional: required
        """
        return self._variable

    @variable.setter
    def variable(self, variable):
        """
        Sets the variable of this SNMPSystemVariableValue.
        This enumeration represents possible SNMP system variables that can be set via SYMbol.

        :param variable: The variable of this SNMPSystemVariableValue.
        :type: str
        """
        allowed_values = ["unknown", "sysname", "syscontact", "syslocation", "__UNDEFINED"]
        if variable not in allowed_values:
            raise ValueError(
                "Invalid value for `variable`, must be one of {0}"
                .format(allowed_values)
            )
        self._variable = variable

    @property
    def new_sys_name(self):
        """
        Gets the new_sys_name of this SNMPSystemVariableValue.
        This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSNAME.

        :return: The new_sys_name of this SNMPSystemVariableValue.
        :rtype: str
        :required/optional: optional
        """
        return self._new_sys_name

    @new_sys_name.setter
    def new_sys_name(self, new_sys_name):
        """
        Sets the new_sys_name of this SNMPSystemVariableValue.
        This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSNAME.

        :param new_sys_name: The new_sys_name of this SNMPSystemVariableValue.
        :type: str
        """
        self._new_sys_name = new_sys_name

    @property
    def new_sys_contact(self):
        """
        Gets the new_sys_contact of this SNMPSystemVariableValue.
        This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSCONTACT.

        :return: The new_sys_contact of this SNMPSystemVariableValue.
        :rtype: str
        :required/optional: optional
        """
        return self._new_sys_contact

    @new_sys_contact.setter
    def new_sys_contact(self, new_sys_contact):
        """
        Sets the new_sys_contact of this SNMPSystemVariableValue.
        This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSCONTACT.

        :param new_sys_contact: The new_sys_contact of this SNMPSystemVariableValue.
        :type: str
        """
        self._new_sys_contact = new_sys_contact

    @property
    def new_sys_location(self):
        """
        Gets the new_sys_location of this SNMPSystemVariableValue.
        This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSLOCATION.

        :return: The new_sys_location of this SNMPSystemVariableValue.
        :rtype: str
        :required/optional: optional
        """
        return self._new_sys_location

    @new_sys_location.setter
    def new_sys_location(self, new_sys_location):
        """
        Sets the new_sys_location of this SNMPSystemVariableValue.
        This field is returned if the value of variable is equal to SNMP_SYSTEM_VARIABLE_SYSLOCATION.

        :param new_sys_location: The new_sys_location of this SNMPSystemVariableValue.
        :type: str
        """
        self._new_sys_location = new_sys_location

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

