# coding: utf-8

"""
StorageArrayChangeableProperties.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class StorageArrayChangeableProperties(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        StorageArrayChangeableProperties - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'default_host_type_index': 'list[int]',  # (required parameter)
            'next_battery_learn_cycle': 'list[int]',  # (required parameter)
            'syslog_enabled': 'list[bool]',  # (required parameter)
            'syslog_server_ip_address': 'list[IpVxAddress]',  # (required parameter)
            'syslog_server_port_number': 'list[int]'
        }

        self.attribute_map = {
            'default_host_type_index': 'defaultHostTypeIndex',  # (required parameter)
            'next_battery_learn_cycle': 'nextBatteryLearnCycle',  # (required parameter)
            'syslog_enabled': 'syslogEnabled',  # (required parameter)
            'syslog_server_ip_address': 'syslogServerIpAddress',  # (required parameter)
            'syslog_server_port_number': 'syslogServerPortNumber'
        }

        self._default_host_type_index = None
        self._next_battery_learn_cycle = None
        self._syslog_enabled = None
        self._syslog_server_ip_address = None
        self._syslog_server_port_number = None

    @property
    def default_host_type_index(self):
        """
        Gets the default_host_type_index of this StorageArrayChangeableProperties.
        The new value to set for the storage array default host type index.

        :return: The default_host_type_index of this StorageArrayChangeableProperties.
        :rtype: list[int]
        :required/optional: required
        """
        return self._default_host_type_index

    @default_host_type_index.setter
    def default_host_type_index(self, default_host_type_index):
        """
        Sets the default_host_type_index of this StorageArrayChangeableProperties.
        The new value to set for the storage array default host type index.

        :param default_host_type_index: The default_host_type_index of this StorageArrayChangeableProperties.
        :type: list[int]
        """
        self._default_host_type_index = default_host_type_index

    @property
    def next_battery_learn_cycle(self):
        """
        Gets the next_battery_learn_cycle of this StorageArrayChangeableProperties.
        The new value to apply for the nextBatteryLearnCycle property in the StorageArray structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time.

        :return: The next_battery_learn_cycle of this StorageArrayChangeableProperties.
        :rtype: list[int]
        :required/optional: required
        """
        return self._next_battery_learn_cycle

    @next_battery_learn_cycle.setter
    def next_battery_learn_cycle(self, next_battery_learn_cycle):
        """
        Sets the next_battery_learn_cycle of this StorageArrayChangeableProperties.
        The new value to apply for the nextBatteryLearnCycle property in the StorageArray structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time.

        :param next_battery_learn_cycle: The next_battery_learn_cycle of this StorageArrayChangeableProperties.
        :type: list[int]
        """
        self._next_battery_learn_cycle = next_battery_learn_cycle

    @property
    def syslog_enabled(self):
        """
        Gets the syslog_enabled of this StorageArrayChangeableProperties.
        The new value for the storage array setting that controls whether or not syslog server notification of MEL events is enabled or not.

        :return: The syslog_enabled of this StorageArrayChangeableProperties.
        :rtype: list[bool]
        :required/optional: required
        """
        return self._syslog_enabled

    @syslog_enabled.setter
    def syslog_enabled(self, syslog_enabled):
        """
        Sets the syslog_enabled of this StorageArrayChangeableProperties.
        The new value for the storage array setting that controls whether or not syslog server notification of MEL events is enabled or not.

        :param syslog_enabled: The syslog_enabled of this StorageArrayChangeableProperties.
        :type: list[bool]
        """
        self._syslog_enabled = syslog_enabled

    @property
    def syslog_server_ip_address(self):
        """
        Gets the syslog_server_ip_address of this StorageArrayChangeableProperties.
        The new value to set for the IP address of the syslog server.

        :return: The syslog_server_ip_address of this StorageArrayChangeableProperties.
        :rtype: list[IpVxAddress]
        :required/optional: required
        """
        return self._syslog_server_ip_address

    @syslog_server_ip_address.setter
    def syslog_server_ip_address(self, syslog_server_ip_address):
        """
        Sets the syslog_server_ip_address of this StorageArrayChangeableProperties.
        The new value to set for the IP address of the syslog server.

        :param syslog_server_ip_address: The syslog_server_ip_address of this StorageArrayChangeableProperties.
        :type: list[IpVxAddress]
        """
        self._syslog_server_ip_address = syslog_server_ip_address

    @property
    def syslog_server_port_number(self):
        """
        Gets the syslog_server_port_number of this StorageArrayChangeableProperties.
        The new value to set for the UDP port number of the syslog server..

        :return: The syslog_server_port_number of this StorageArrayChangeableProperties.
        :rtype: list[int]
        :required/optional: required
        """
        return self._syslog_server_port_number

    @syslog_server_port_number.setter
    def syslog_server_port_number(self, syslog_server_port_number):
        """
        Sets the syslog_server_port_number of this StorageArrayChangeableProperties.
        The new value to set for the UDP port number of the syslog server..

        :param syslog_server_port_number: The syslog_server_port_number of this StorageArrayChangeableProperties.
        :type: list[int]
        """
        self._syslog_server_port_number = syslog_server_port_number

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

