# coding: utf-8

"""
Target.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Target(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Target - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'target_ref': 'str',  # (required parameter)
            'node_name': 'ScsiNodeName',  # (required parameter)
            'alias': 'ScsiAlias',  # (required parameter)
            'configured_auth_methods': 'AuthenticationBundle',  # (required parameter)
            'portals': 'list[TargetPortal]'
        }

        self.attribute_map = {
            'target_ref': 'targetRef',  # (required parameter)
            'node_name': 'nodeName',  # (required parameter)
            'alias': 'alias',  # (required parameter)
            'configured_auth_methods': 'configuredAuthMethods',  # (required parameter)
            'portals': 'portals'
        }

        self._target_ref = None
        self._node_name = None
        self._alias = None
        self._configured_auth_methods = None
        self._portals = None

    @property
    def target_ref(self):
        """
        Gets the target_ref of this Target.
        The reference that uniquely identifies an instance of this object.

        :return: The target_ref of this Target.
        :rtype: str
        :required/optional: required
        """
        return self._target_ref

    @target_ref.setter
    def target_ref(self, target_ref):
        """
        Sets the target_ref of this Target.
        The reference that uniquely identifies an instance of this object.

        :param target_ref: The target_ref of this Target.
        :type: str
        """
        self._target_ref = target_ref

    @property
    def node_name(self):
        """
        Gets the node_name of this Target.
        The unique node name associated with the target.

        :return: The node_name of this Target.
        :rtype: ScsiNodeName
        :required/optional: required
        """
        return self._node_name

    @node_name.setter
    def node_name(self, node_name):
        """
        Sets the node_name of this Target.
        The unique node name associated with the target.

        :param node_name: The node_name of this Target.
        :type: ScsiNodeName
        """
        self._node_name = node_name

    @property
    def alias(self):
        """
        Gets the alias of this Target.
        An additional name that can be assigned to a target, which is usually \"friendlier\" than the node name.

        :return: The alias of this Target.
        :rtype: ScsiAlias
        :required/optional: required
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """
        Sets the alias of this Target.
        An additional name that can be assigned to a target, which is usually \"friendlier\" than the node name.

        :param alias: The alias of this Target.
        :type: ScsiAlias
        """
        self._alias = alias

    @property
    def configured_auth_methods(self):
        """
        Gets the configured_auth_methods of this Target.
        The authentication methods that have been configured for the target. Associated secrets are not exposed. instead the type field of the EncryptedPassword is set to ENCRYPT_UNSPECIFIED.

        :return: The configured_auth_methods of this Target.
        :rtype: AuthenticationBundle
        :required/optional: required
        """
        return self._configured_auth_methods

    @configured_auth_methods.setter
    def configured_auth_methods(self, configured_auth_methods):
        """
        Sets the configured_auth_methods of this Target.
        The authentication methods that have been configured for the target. Associated secrets are not exposed. instead the type field of the EncryptedPassword is set to ENCRYPT_UNSPECIFIED.

        :param configured_auth_methods: The configured_auth_methods of this Target.
        :type: AuthenticationBundle
        """
        self._configured_auth_methods = configured_auth_methods

    @property
    def portals(self):
        """
        Gets the portals of this Target.
        The set of configured (i.e., either in-use or listening for connections) portals associated with this target.

        :return: The portals of this Target.
        :rtype: list[TargetPortal]
        :required/optional: required
        """
        return self._portals

    @portals.setter
    def portals(self, portals):
        """
        Sets the portals of this Target.
        The set of configured (i.e., either in-use or listening for connections) portals associated with this target.

        :param portals: The portals of this Target.
        :type: list[TargetPortal]
        """
        self._portals = portals

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

