# coding: utf-8

"""
ThinVolumeReinitializeParams.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ThinVolumeReinitializeParams(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ThinVolumeReinitializeParams - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'init_action': 'str',  # (required parameter)
            'new_provisioned_capacity': 'int',  
            'new_repository_candidate': 'ConcatVolumeCreationDescriptor'
        }

        self.attribute_map = {
            'init_action': 'initAction',  # (required parameter)
            'new_provisioned_capacity': 'newProvisionedCapacity',  
            'new_repository_candidate': 'newRepositoryCandidate'
        }

        self._init_action = None
        self._new_provisioned_capacity = None
        self._new_repository_candidate = None

    @property
    def init_action(self):
        """
        Gets the init_action of this ThinVolumeReinitializeParams.
        This enumeration defines the actions to take on a thin volume re-initialize request.

        :return: The init_action of this ThinVolumeReinitializeParams.
        :rtype: str
        :required/optional: required
        """
        return self._init_action

    @init_action.setter
    def init_action(self, init_action):
        """
        Sets the init_action of this ThinVolumeReinitializeParams.
        This enumeration defines the actions to take on a thin volume re-initialize request.

        :param init_action: The init_action of this ThinVolumeReinitializeParams.
        :type: str
        """
        allowed_values = ["unknown", "only", "andResize", "newRepository", "__UNDEFINED"]
        if init_action not in allowed_values:
            raise ValueError(
                "Invalid value for `init_action`, must be one of {0}"
                .format(allowed_values)
            )
        self._init_action = init_action

    @property
    def new_provisioned_capacity(self):
        """
        Gets the new_provisioned_capacity of this ThinVolumeReinitializeParams.
        This field is present only if the value of initAction is equal to THIN_VOL_REINIT_AND_RESIZE.

        :return: The new_provisioned_capacity of this ThinVolumeReinitializeParams.
        :rtype: int
        :required/optional: optional
        """
        return self._new_provisioned_capacity

    @new_provisioned_capacity.setter
    def new_provisioned_capacity(self, new_provisioned_capacity):
        """
        Sets the new_provisioned_capacity of this ThinVolumeReinitializeParams.
        This field is present only if the value of initAction is equal to THIN_VOL_REINIT_AND_RESIZE.

        :param new_provisioned_capacity: The new_provisioned_capacity of this ThinVolumeReinitializeParams.
        :type: int
        """
        self._new_provisioned_capacity = new_provisioned_capacity

    @property
    def new_repository_candidate(self):
        """
        Gets the new_repository_candidate of this ThinVolumeReinitializeParams.
        This field is present only if the value of initAction is equal to THIN_VOL_REINIT_NEW_REPOSITORY.

        :return: The new_repository_candidate of this ThinVolumeReinitializeParams.
        :rtype: ConcatVolumeCreationDescriptor
        :required/optional: optional
        """
        return self._new_repository_candidate

    @new_repository_candidate.setter
    def new_repository_candidate(self, new_repository_candidate):
        """
        Sets the new_repository_candidate of this ThinVolumeReinitializeParams.
        This field is present only if the value of initAction is equal to THIN_VOL_REINIT_NEW_REPOSITORY.

        :param new_repository_candidate: The new_repository_candidate of this ThinVolumeReinitializeParams.
        :type: ConcatVolumeCreationDescriptor
        """
        self._new_repository_candidate = new_repository_candidate

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

