# coding: utf-8

"""
TrayLostRedundancyFailure.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class TrayLostRedundancyFailure(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        TrayLostRedundancyFailure - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tray_lost_redundancy': 'str',  # (required parameter)
            'working_channel': 'int',  # (required parameter)
            'failed_esm': 'str'
        }

        self.attribute_map = {
            'tray_lost_redundancy': 'trayLostRedundancy',  # (required parameter)
            'working_channel': 'workingChannel',  # (required parameter)
            'failed_esm': 'failedEsm'
        }

        self._tray_lost_redundancy = None
        self._working_channel = None
        self._failed_esm = None

    @property
    def tray_lost_redundancy(self):
        """
        Gets the tray_lost_redundancy of this TrayLostRedundancyFailure.
        This object uniquely identifies the particular tray within the storage array that has lost redundancy.

        :return: The tray_lost_redundancy of this TrayLostRedundancyFailure.
        :rtype: str
        :required/optional: required
        """
        return self._tray_lost_redundancy

    @tray_lost_redundancy.setter
    def tray_lost_redundancy(self, tray_lost_redundancy):
        """
        Sets the tray_lost_redundancy of this TrayLostRedundancyFailure.
        This object uniquely identifies the particular tray within the storage array that has lost redundancy.

        :param tray_lost_redundancy: The tray_lost_redundancy of this TrayLostRedundancyFailure.
        :type: str
        """
        self._tray_lost_redundancy = tray_lost_redundancy

    @property
    def working_channel(self):
        """
        Gets the working_channel of this TrayLostRedundancyFailure.
        The channel to the tray that is still operational.

        :return: The working_channel of this TrayLostRedundancyFailure.
        :rtype: int
        :required/optional: required
        """
        return self._working_channel

    @working_channel.setter
    def working_channel(self, working_channel):
        """
        Sets the working_channel of this TrayLostRedundancyFailure.
        The channel to the tray that is still operational.

        :param working_channel: The working_channel of this TrayLostRedundancyFailure.
        :type: int
        """
        self._working_channel = working_channel

    @property
    def failed_esm(self):
        """
        Gets the failed_esm of this TrayLostRedundancyFailure.
        This object uniquely identifies the failed ESM within the storage array.

        :return: The failed_esm of this TrayLostRedundancyFailure.
        :rtype: str
        :required/optional: required
        """
        return self._failed_esm

    @failed_esm.setter
    def failed_esm(self, failed_esm):
        """
        Sets the failed_esm of this TrayLostRedundancyFailure.
        This object uniquely identifies the failed ESM within the storage array.

        :param failed_esm: The failed_esm of this TrayLostRedundancyFailure.
        :type: str
        """
        self._failed_esm = failed_esm

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

