# coding: utf-8

"""
UnreadableSectorTableEntry.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class UnreadableSectorTableEntry(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        UnreadableSectorTableEntry - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'volume_ref': 'str',  # (required parameter)
            'volume_lba': 'int',  # (required parameter)
            'tray_no': 'int',  # (required parameter)
            'slot_no': 'int',  # (required parameter)
            'drive_lba': 'int',  # (required parameter)
            'time_stamp': 'int',  # (required parameter)
            'record_type': 'str'
        }

        self.attribute_map = {
            'volume_ref': 'volumeRef',  # (required parameter)
            'volume_lba': 'volumeLBA',  # (required parameter)
            'tray_no': 'trayNo',  # (required parameter)
            'slot_no': 'slotNo',  # (required parameter)
            'drive_lba': 'driveLBA',  # (required parameter)
            'time_stamp': 'timeStamp',  # (required parameter)
            'record_type': 'recordType'
        }

        self._volume_ref = None
        self._volume_lba = None
        self._tray_no = None
        self._slot_no = None
        self._drive_lba = None
        self._time_stamp = None
        self._record_type = None

    @property
    def volume_ref(self):
        """
        Gets the volume_ref of this UnreadableSectorTableEntry.
        The reference for the volume.

        :return: The volume_ref of this UnreadableSectorTableEntry.
        :rtype: str
        :required/optional: required
        """
        return self._volume_ref

    @volume_ref.setter
    def volume_ref(self, volume_ref):
        """
        Sets the volume_ref of this UnreadableSectorTableEntry.
        The reference for the volume.

        :param volume_ref: The volume_ref of this UnreadableSectorTableEntry.
        :type: str
        """
        self._volume_ref = volume_ref

    @property
    def volume_lba(self):
        """
        Gets the volume_lba of this UnreadableSectorTableEntry.
        The volume LBA.

        :return: The volume_lba of this UnreadableSectorTableEntry.
        :rtype: int
        :required/optional: required
        """
        return self._volume_lba

    @volume_lba.setter
    def volume_lba(self, volume_lba):
        """
        Sets the volume_lba of this UnreadableSectorTableEntry.
        The volume LBA.

        :param volume_lba: The volume_lba of this UnreadableSectorTableEntry.
        :type: int
        """
        self._volume_lba = volume_lba

    @property
    def tray_no(self):
        """
        Gets the tray_no of this UnreadableSectorTableEntry.
        The tray number.

        :return: The tray_no of this UnreadableSectorTableEntry.
        :rtype: int
        :required/optional: required
        """
        return self._tray_no

    @tray_no.setter
    def tray_no(self, tray_no):
        """
        Sets the tray_no of this UnreadableSectorTableEntry.
        The tray number.

        :param tray_no: The tray_no of this UnreadableSectorTableEntry.
        :type: int
        """
        self._tray_no = tray_no

    @property
    def slot_no(self):
        """
        Gets the slot_no of this UnreadableSectorTableEntry.
        The slot number.

        :return: The slot_no of this UnreadableSectorTableEntry.
        :rtype: int
        :required/optional: required
        """
        return self._slot_no

    @slot_no.setter
    def slot_no(self, slot_no):
        """
        Sets the slot_no of this UnreadableSectorTableEntry.
        The slot number.

        :param slot_no: The slot_no of this UnreadableSectorTableEntry.
        :type: int
        """
        self._slot_no = slot_no

    @property
    def drive_lba(self):
        """
        Gets the drive_lba of this UnreadableSectorTableEntry.
        8 bytes - unsigned long long

        :return: The drive_lba of this UnreadableSectorTableEntry.
        :rtype: int
        :required/optional: required
        """
        return self._drive_lba

    @drive_lba.setter
    def drive_lba(self, drive_lba):
        """
        Sets the drive_lba of this UnreadableSectorTableEntry.
        8 bytes - unsigned long long

        :param drive_lba: The drive_lba of this UnreadableSectorTableEntry.
        :type: int
        """
        self._drive_lba = drive_lba

    @property
    def time_stamp(self):
        """
        Gets the time_stamp of this UnreadableSectorTableEntry.
        8 bytes

        :return: The time_stamp of this UnreadableSectorTableEntry.
        :rtype: int
        :required/optional: required
        """
        return self._time_stamp

    @time_stamp.setter
    def time_stamp(self, time_stamp):
        """
        Sets the time_stamp of this UnreadableSectorTableEntry.
        8 bytes

        :param time_stamp: The time_stamp of this UnreadableSectorTableEntry.
        :type: int
        """
        self._time_stamp = time_stamp

    @property
    def record_type(self):
        """
        Gets the record_type of this UnreadableSectorTableEntry.
        4 bytes - enumeration

        :return: The record_type of this UnreadableSectorTableEntry.
        :rtype: str
        :required/optional: required
        """
        return self._record_type

    @record_type.setter
    def record_type(self, record_type):
        """
        Sets the record_type of this UnreadableSectorTableEntry.
        4 bytes - enumeration

        :param record_type: The record_type of this UnreadableSectorTableEntry.
        :type: str
        """
        allowed_values = ["physical", "logical", "injected", "edcError", "inconsistent", "piError", "__UNDEFINED"]
        if record_type not in allowed_values:
            raise ValueError(
                "Invalid value for `record_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._record_type = record_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

