# coding: utf-8

"""
AsyncMirrorGroupConnectivityTestRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupConnectivityTestRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupConnectivityTestRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'requested_test_type': 'str',  
            'test_iterations': 'int',  
            'timeout': 'int'
        }

        self.attribute_map = {
            'requested_test_type': 'requestedTestType',  
            'test_iterations': 'testIterations',  
            'timeout': 'timeout'
        }

        self._requested_test_type = None
        self._test_iterations = None
        self._timeout = None

    @property
    def requested_test_type(self):
        """
        Gets the requested_test_type of this AsyncMirrorGroupConnectivityTestRequest.
        Type of test to perform.

        :return: The requested_test_type of this AsyncMirrorGroupConnectivityTestRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._requested_test_type

    @requested_test_type.setter
    def requested_test_type(self, requested_test_type):
        """
        Sets the requested_test_type of this AsyncMirrorGroupConnectivityTestRequest.
        Type of test to perform.

        :param requested_test_type: The requested_test_type of this AsyncMirrorGroupConnectivityTestRequest.
        :type: str
        """
        allowed_values = ["connectivityTestUnknown", "basicConnectivityTest", "linkLatencyTest", "linkBandwidthTest", "__UNDEFINED"]
        if requested_test_type not in allowed_values:
            raise ValueError(
                "Invalid value for `requested_test_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._requested_test_type = requested_test_type

    @property
    def test_iterations(self):
        """
        Gets the test_iterations of this AsyncMirrorGroupConnectivityTestRequest.
        Number of test iterations to run.

        :return: The test_iterations of this AsyncMirrorGroupConnectivityTestRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._test_iterations

    @test_iterations.setter
    def test_iterations(self, test_iterations):
        """
        Sets the test_iterations of this AsyncMirrorGroupConnectivityTestRequest.
        Number of test iterations to run.

        :param test_iterations: The test_iterations of this AsyncMirrorGroupConnectivityTestRequest.
        :type: int
        """
        self._test_iterations = test_iterations

    @property
    def timeout(self):
        """
        Gets the timeout of this AsyncMirrorGroupConnectivityTestRequest.
        Timeout in seconds. For no timeout, this value should be set to -1.

        :return: The timeout of this AsyncMirrorGroupConnectivityTestRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """
        Sets the timeout of this AsyncMirrorGroupConnectivityTestRequest.
        Timeout in seconds. For no timeout, this value should be set to -1.

        :param timeout: The timeout of this AsyncMirrorGroupConnectivityTestRequest.
        :type: int
        """
        self._timeout = timeout

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

