# coding: utf-8

"""
AsyncMirrorGroupMemberCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupMemberCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupMemberCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'primary_pool_id': 'str',  # (required parameter)
            'secondary_pool_id': 'str',  # (required parameter)
            'primary_volume_ref': 'str',  # (required parameter)
            'secondary_volume_ref': 'str',  # (required parameter)
            'primary_repository_candidate': 'ConcatVolumeCandidate',  
            'secondary_repository_candidate': 'ConcatVolumeCandidate',  
            'scan_media': 'bool',  
            'validate_repository_parity': 'bool',  
            'percent_capacity': 'float',  
            'secondary_percent_capacity': 'float'
        }

        self.attribute_map = {
            'primary_pool_id': 'primaryPoolId',  # (required parameter)
            'secondary_pool_id': 'secondaryPoolId',  # (required parameter)
            'primary_volume_ref': 'primaryVolumeRef',  # (required parameter)
            'secondary_volume_ref': 'secondaryVolumeRef',  # (required parameter)
            'primary_repository_candidate': 'primaryRepositoryCandidate',  
            'secondary_repository_candidate': 'secondaryRepositoryCandidate',  
            'scan_media': 'scanMedia',  
            'validate_repository_parity': 'validateRepositoryParity',  
            'percent_capacity': 'percentCapacity',  
            'secondary_percent_capacity': 'secondaryPercentCapacity'
        }

        self._primary_pool_id = None
        self._secondary_pool_id = None
        self._primary_volume_ref = None
        self._secondary_volume_ref = None
        self._primary_repository_candidate = None
        self._secondary_repository_candidate = None
        self._scan_media = None
        self._validate_repository_parity = None
        self._percent_capacity = None
        self._secondary_percent_capacity = None

    @property
    def primary_pool_id(self):
        """
        Gets the primary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        Storage pool on the source StorageSystem to create the mirrored pair repository volume on. This defaults to the pool that the primaryVolume belongs to.

        :return: The primary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._primary_pool_id

    @primary_pool_id.setter
    def primary_pool_id(self, primary_pool_id):
        """
        Sets the primary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        Storage pool on the source StorageSystem to create the mirrored pair repository volume on. This defaults to the pool that the primaryVolume belongs to.

        :param primary_pool_id: The primary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        :type: str
        """
        self._primary_pool_id = primary_pool_id

    @property
    def secondary_pool_id(self):
        """
        Gets the secondary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        Storage pool on the target StorageSystem to create the mirrored pair repository volume on. This defaults to the pool that the secondaryVolume belongs to.

        :return: The secondary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._secondary_pool_id

    @secondary_pool_id.setter
    def secondary_pool_id(self, secondary_pool_id):
        """
        Sets the secondary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        Storage pool on the target StorageSystem to create the mirrored pair repository volume on. This defaults to the pool that the secondaryVolume belongs to.

        :param secondary_pool_id: The secondary_pool_id of this AsyncMirrorGroupMemberCreateRequest.
        :type: str
        """
        self._secondary_pool_id = secondary_pool_id

    @property
    def primary_volume_ref(self):
        """
        Gets the primary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.


        :return: The primary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._primary_volume_ref

    @primary_volume_ref.setter
    def primary_volume_ref(self, primary_volume_ref):
        """
        Sets the primary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.


        :param primary_volume_ref: The primary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.
        :type: str
        """
        self._primary_volume_ref = primary_volume_ref

    @property
    def secondary_volume_ref(self):
        """
        Gets the secondary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.


        :return: The secondary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._secondary_volume_ref

    @secondary_volume_ref.setter
    def secondary_volume_ref(self, secondary_volume_ref):
        """
        Sets the secondary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.


        :param secondary_volume_ref: The secondary_volume_ref of this AsyncMirrorGroupMemberCreateRequest.
        :type: str
        """
        self._secondary_volume_ref = secondary_volume_ref

    @property
    def primary_repository_candidate(self):
        """
        Gets the primary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        Allows a repository candidate to be manually specified for use in the creation. By default, the best candidate will be selected.

        :return: The primary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: ConcatVolumeCandidate
        :required/optional: optional
        """
        return self._primary_repository_candidate

    @primary_repository_candidate.setter
    def primary_repository_candidate(self, primary_repository_candidate):
        """
        Sets the primary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        Allows a repository candidate to be manually specified for use in the creation. By default, the best candidate will be selected.

        :param primary_repository_candidate: The primary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        :type: ConcatVolumeCandidate
        """
        self._primary_repository_candidate = primary_repository_candidate

    @property
    def secondary_repository_candidate(self):
        """
        Gets the secondary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        Allows a repository candidate to be manually specified for use in the creation. By default, the best candidate will be selected.

        :return: The secondary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: ConcatVolumeCandidate
        :required/optional: optional
        """
        return self._secondary_repository_candidate

    @secondary_repository_candidate.setter
    def secondary_repository_candidate(self, secondary_repository_candidate):
        """
        Sets the secondary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        Allows a repository candidate to be manually specified for use in the creation. By default, the best candidate will be selected.

        :param secondary_repository_candidate: The secondary_repository_candidate of this AsyncMirrorGroupMemberCreateRequest.
        :type: ConcatVolumeCandidate
        """
        self._secondary_repository_candidate = secondary_repository_candidate

    @property
    def scan_media(self):
        """
        Gets the scan_media of this AsyncMirrorGroupMemberCreateRequest.


        :return: The scan_media of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._scan_media

    @scan_media.setter
    def scan_media(self, scan_media):
        """
        Sets the scan_media of this AsyncMirrorGroupMemberCreateRequest.


        :param scan_media: The scan_media of this AsyncMirrorGroupMemberCreateRequest.
        :type: bool
        """
        self._scan_media = scan_media

    @property
    def validate_repository_parity(self):
        """
        Gets the validate_repository_parity of this AsyncMirrorGroupMemberCreateRequest.


        :return: The validate_repository_parity of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._validate_repository_parity

    @validate_repository_parity.setter
    def validate_repository_parity(self, validate_repository_parity):
        """
        Sets the validate_repository_parity of this AsyncMirrorGroupMemberCreateRequest.


        :param validate_repository_parity: The validate_repository_parity of this AsyncMirrorGroupMemberCreateRequest.
        :type: bool
        """
        self._validate_repository_parity = validate_repository_parity

    @property
    def percent_capacity(self):
        """
        Gets the percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        Percentage of the capacity of the primary volume to use for the repository capacity.

        :return: The percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: float
        :required/optional: optional
        """
        return self._percent_capacity

    @percent_capacity.setter
    def percent_capacity(self, percent_capacity):
        """
        Sets the percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        Percentage of the capacity of the primary volume to use for the repository capacity.

        :param percent_capacity: The percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        :type: float
        """
        self._percent_capacity = percent_capacity

    @property
    def secondary_percent_capacity(self):
        """
        Gets the secondary_percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        Percentage of the capacity of the secondary volume to use for the repository capacity. Defaults to percentCapacity.

        :return: The secondary_percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        :rtype: float
        :required/optional: optional
        """
        return self._secondary_percent_capacity

    @secondary_percent_capacity.setter
    def secondary_percent_capacity(self, secondary_percent_capacity):
        """
        Sets the secondary_percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        Percentage of the capacity of the secondary volume to use for the repository capacity. Defaults to percentCapacity.

        :param secondary_percent_capacity: The secondary_percent_capacity of this AsyncMirrorGroupMemberCreateRequest.
        :type: float
        """
        self._secondary_percent_capacity = secondary_percent_capacity

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

