# coding: utf-8

"""
AverageAnalysedDriveStats.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AverageAnalysedDriveStats(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AverageAnalysedDriveStats - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',  # (required parameter)
            'latency_read': 'AverageAnalysedValue',  # (required parameter)
            'latency_write': 'AverageAnalysedValue',  # (required parameter)
            'iops_read': 'AverageAnalysedValue',  # (required parameter)
            'iops_write': 'AverageAnalysedValue',  # (required parameter)
            'throughput_read': 'AverageAnalysedValue',  # (required parameter)
            'throughput_write': 'AverageAnalysedValue'
        }

        self.attribute_map = {
            'id': 'id',  # (required parameter)
            'latency_read': 'latencyRead',  # (required parameter)
            'latency_write': 'latencyWrite',  # (required parameter)
            'iops_read': 'iopsRead',  # (required parameter)
            'iops_write': 'iopsWrite',  # (required parameter)
            'throughput_read': 'throughputRead',  # (required parameter)
            'throughput_write': 'throughputWrite'
        }

        self._id = None
        self._latency_read = None
        self._latency_write = None
        self._iops_read = None
        self._iops_write = None
        self._throughput_read = None
        self._throughput_write = None

    @property
    def id(self):
        """
        Gets the id of this AverageAnalysedDriveStats.


        :return: The id of this AverageAnalysedDriveStats.
        :rtype: str
        :required/optional: required
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this AverageAnalysedDriveStats.


        :param id: The id of this AverageAnalysedDriveStats.
        :type: str
        """
        self._id = id

    @property
    def latency_read(self):
        """
        Gets the latency_read of this AverageAnalysedDriveStats.


        :return: The latency_read of this AverageAnalysedDriveStats.
        :rtype: AverageAnalysedValue
        :required/optional: required
        """
        return self._latency_read

    @latency_read.setter
    def latency_read(self, latency_read):
        """
        Sets the latency_read of this AverageAnalysedDriveStats.


        :param latency_read: The latency_read of this AverageAnalysedDriveStats.
        :type: AverageAnalysedValue
        """
        self._latency_read = latency_read

    @property
    def latency_write(self):
        """
        Gets the latency_write of this AverageAnalysedDriveStats.


        :return: The latency_write of this AverageAnalysedDriveStats.
        :rtype: AverageAnalysedValue
        :required/optional: required
        """
        return self._latency_write

    @latency_write.setter
    def latency_write(self, latency_write):
        """
        Sets the latency_write of this AverageAnalysedDriveStats.


        :param latency_write: The latency_write of this AverageAnalysedDriveStats.
        :type: AverageAnalysedValue
        """
        self._latency_write = latency_write

    @property
    def iops_read(self):
        """
        Gets the iops_read of this AverageAnalysedDriveStats.


        :return: The iops_read of this AverageAnalysedDriveStats.
        :rtype: AverageAnalysedValue
        :required/optional: required
        """
        return self._iops_read

    @iops_read.setter
    def iops_read(self, iops_read):
        """
        Sets the iops_read of this AverageAnalysedDriveStats.


        :param iops_read: The iops_read of this AverageAnalysedDriveStats.
        :type: AverageAnalysedValue
        """
        self._iops_read = iops_read

    @property
    def iops_write(self):
        """
        Gets the iops_write of this AverageAnalysedDriveStats.


        :return: The iops_write of this AverageAnalysedDriveStats.
        :rtype: AverageAnalysedValue
        :required/optional: required
        """
        return self._iops_write

    @iops_write.setter
    def iops_write(self, iops_write):
        """
        Sets the iops_write of this AverageAnalysedDriveStats.


        :param iops_write: The iops_write of this AverageAnalysedDriveStats.
        :type: AverageAnalysedValue
        """
        self._iops_write = iops_write

    @property
    def throughput_read(self):
        """
        Gets the throughput_read of this AverageAnalysedDriveStats.


        :return: The throughput_read of this AverageAnalysedDriveStats.
        :rtype: AverageAnalysedValue
        :required/optional: required
        """
        return self._throughput_read

    @throughput_read.setter
    def throughput_read(self, throughput_read):
        """
        Sets the throughput_read of this AverageAnalysedDriveStats.


        :param throughput_read: The throughput_read of this AverageAnalysedDriveStats.
        :type: AverageAnalysedValue
        """
        self._throughput_read = throughput_read

    @property
    def throughput_write(self):
        """
        Gets the throughput_write of this AverageAnalysedDriveStats.


        :return: The throughput_write of this AverageAnalysedDriveStats.
        :rtype: AverageAnalysedValue
        :required/optional: required
        """
        return self._throughput_write

    @throughput_write.setter
    def throughput_write(self, throughput_write):
        """
        Sets the throughput_write of this AverageAnalysedDriveStats.


        :param throughput_write: The throughput_write of this AverageAnalysedDriveStats.
        :type: AverageAnalysedValue
        """
        self._throughput_write = throughput_write

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

