# coding: utf-8

"""
ConsistencyGroupCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ConsistencyGroupCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ConsistencyGroupCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',  # (required parameter)
            'full_warn_threshold_percent': 'int',  
            'auto_delete_threshold': 'int',  
            'repository_full_policy': 'str',  
            'rollback_priority': 'str'
        }

        self.attribute_map = {
            'name': 'name',  # (required parameter)
            'full_warn_threshold_percent': 'fullWarnThresholdPercent',  
            'auto_delete_threshold': 'autoDeleteThreshold',  
            'repository_full_policy': 'repositoryFullPolicy',  
            'rollback_priority': 'rollbackPriority'
        }

        self._name = None
        self._full_warn_threshold_percent = None
        self._auto_delete_threshold = None
        self._repository_full_policy = None
        self._rollback_priority = None

    @property
    def name(self):
        """
        Gets the name of this ConsistencyGroupCreateRequest.
        The user-label to assign to the new consistency group

        :return: The name of this ConsistencyGroupCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ConsistencyGroupCreateRequest.
        The user-label to assign to the new consistency group

        :param name: The name of this ConsistencyGroupCreateRequest.
        :type: str
        """
        self._name = name

    @property
    def full_warn_threshold_percent(self):
        """
        Gets the full_warn_threshold_percent of this ConsistencyGroupCreateRequest.
        The full warning threshold percent

        :return: The full_warn_threshold_percent of this ConsistencyGroupCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._full_warn_threshold_percent

    @full_warn_threshold_percent.setter
    def full_warn_threshold_percent(self, full_warn_threshold_percent):
        """
        Sets the full_warn_threshold_percent of this ConsistencyGroupCreateRequest.
        The full warning threshold percent

        :param full_warn_threshold_percent: The full_warn_threshold_percent of this ConsistencyGroupCreateRequest.
        :type: int
        """
        self._full_warn_threshold_percent = full_warn_threshold_percent

    @property
    def auto_delete_threshold(self):
        """
        Gets the auto_delete_threshold of this ConsistencyGroupCreateRequest.
        The auto-delete threshold. Automatically delete snapshots after this many.

        :return: The auto_delete_threshold of this ConsistencyGroupCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._auto_delete_threshold

    @auto_delete_threshold.setter
    def auto_delete_threshold(self, auto_delete_threshold):
        """
        Sets the auto_delete_threshold of this ConsistencyGroupCreateRequest.
        The auto-delete threshold. Automatically delete snapshots after this many.

        :param auto_delete_threshold: The auto_delete_threshold of this ConsistencyGroupCreateRequest.
        :type: int
        """
        self._auto_delete_threshold = auto_delete_threshold

    @property
    def repository_full_policy(self):
        """
        Gets the repository_full_policy of this ConsistencyGroupCreateRequest.
        The repository full policy.

        :return: The repository_full_policy of this ConsistencyGroupCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._repository_full_policy

    @repository_full_policy.setter
    def repository_full_policy(self, repository_full_policy):
        """
        Sets the repository_full_policy of this ConsistencyGroupCreateRequest.
        The repository full policy.

        :param repository_full_policy: The repository_full_policy of this ConsistencyGroupCreateRequest.
        :type: str
        """
        allowed_values = ["unknown", "failbasewrites", "purgepit", "__UNDEFINED"]
        if repository_full_policy not in allowed_values:
            raise ValueError(
                "Invalid value for `repository_full_policy`, must be one of {0}"
                .format(allowed_values)
            )
        self._repository_full_policy = repository_full_policy

    @property
    def rollback_priority(self):
        """
        Gets the rollback_priority of this ConsistencyGroupCreateRequest.
        Roll-back priority

        :return: The rollback_priority of this ConsistencyGroupCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._rollback_priority

    @rollback_priority.setter
    def rollback_priority(self, rollback_priority):
        """
        Sets the rollback_priority of this ConsistencyGroupCreateRequest.
        Roll-back priority

        :param rollback_priority: The rollback_priority of this ConsistencyGroupCreateRequest.
        :type: str
        """
        allowed_values = ["highest", "high", "medium", "low", "lowest", "__UNDEFINED"]
        if rollback_priority not in allowed_values:
            raise ValueError(
                "Invalid value for `rollback_priority`, must be one of {0}"
                .format(allowed_values)
            )
        self._rollback_priority = rollback_priority

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

