# coding: utf-8

"""
CVCandidateSelectionRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CVCandidateSelectionRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CVCandidateSelectionRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'use_free_repository_volumes': 'bool',  
            'candidate_request': 'ConcatVolumeCandidateRequest',  # (required parameter)
            'exclusions': 'list[ConcatVolumeCandidate]'
        }

        self.attribute_map = {
            'use_free_repository_volumes': 'useFreeRepositoryVolumes',  
            'candidate_request': 'candidateRequest',  # (required parameter)
            'exclusions': 'exclusions'
        }

        self._use_free_repository_volumes = None
        self._candidate_request = None
        self._exclusions = None

    @property
    def use_free_repository_volumes(self):
        """
        Gets the use_free_repository_volumes of this CVCandidateSelectionRequest.


        :return: The use_free_repository_volumes of this CVCandidateSelectionRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._use_free_repository_volumes

    @use_free_repository_volumes.setter
    def use_free_repository_volumes(self, use_free_repository_volumes):
        """
        Sets the use_free_repository_volumes of this CVCandidateSelectionRequest.


        :param use_free_repository_volumes: The use_free_repository_volumes of this CVCandidateSelectionRequest.
        :type: bool
        """
        self._use_free_repository_volumes = use_free_repository_volumes

    @property
    def candidate_request(self):
        """
        Gets the candidate_request of this CVCandidateSelectionRequest.


        :return: The candidate_request of this CVCandidateSelectionRequest.
        :rtype: ConcatVolumeCandidateRequest
        :required/optional: required
        """
        return self._candidate_request

    @candidate_request.setter
    def candidate_request(self, candidate_request):
        """
        Sets the candidate_request of this CVCandidateSelectionRequest.


        :param candidate_request: The candidate_request of this CVCandidateSelectionRequest.
        :type: ConcatVolumeCandidateRequest
        """
        self._candidate_request = candidate_request

    @property
    def exclusions(self):
        """
        Gets the exclusions of this CVCandidateSelectionRequest.


        :return: The exclusions of this CVCandidateSelectionRequest.
        :rtype: list[ConcatVolumeCandidate]
        :required/optional: optional
        """
        return self._exclusions

    @exclusions.setter
    def exclusions(self, exclusions):
        """
        Sets the exclusions of this CVCandidateSelectionRequest.


        :param exclusions: The exclusions of this CVCandidateSelectionRequest.
        :type: list[ConcatVolumeCandidate]
        """
        self._exclusions = exclusions

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

