# coding: utf-8

"""
DriveFirmwareCompatibilityResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DriveFirmwareCompatibilityResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DriveFirmwareCompatibilityResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'contoller_offline': 'bool',  # (required parameter)
            'controller_missing': 'bool',  # (required parameter)
            'controller_service_mode': 'bool',  # (required parameter)
            'simplex_mode': 'bool',  # (required parameter)
            'compatibilities': 'list[DriveFirmwareCompatiblitySet]'
        }

        self.attribute_map = {
            'contoller_offline': 'contollerOffline',  # (required parameter)
            'controller_missing': 'controllerMissing',  # (required parameter)
            'controller_service_mode': 'controllerServiceMode',  # (required parameter)
            'simplex_mode': 'simplexMode',  # (required parameter)
            'compatibilities': 'compatibilities'
        }

        self._contoller_offline = None
        self._controller_missing = None
        self._controller_service_mode = None
        self._simplex_mode = None
        self._compatibilities = None

    @property
    def contoller_offline(self):
        """
        Gets the contoller_offline of this DriveFirmwareCompatibilityResponse.
        Controller status

        :return: The contoller_offline of this DriveFirmwareCompatibilityResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._contoller_offline

    @contoller_offline.setter
    def contoller_offline(self, contoller_offline):
        """
        Sets the contoller_offline of this DriveFirmwareCompatibilityResponse.
        Controller status

        :param contoller_offline: The contoller_offline of this DriveFirmwareCompatibilityResponse.
        :type: bool
        """
        self._contoller_offline = contoller_offline

    @property
    def controller_missing(self):
        """
        Gets the controller_missing of this DriveFirmwareCompatibilityResponse.
        Controller missing

        :return: The controller_missing of this DriveFirmwareCompatibilityResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._controller_missing

    @controller_missing.setter
    def controller_missing(self, controller_missing):
        """
        Sets the controller_missing of this DriveFirmwareCompatibilityResponse.
        Controller missing

        :param controller_missing: The controller_missing of this DriveFirmwareCompatibilityResponse.
        :type: bool
        """
        self._controller_missing = controller_missing

    @property
    def controller_service_mode(self):
        """
        Gets the controller_service_mode of this DriveFirmwareCompatibilityResponse.
        Indicates if a Controller is in service mode

        :return: The controller_service_mode of this DriveFirmwareCompatibilityResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._controller_service_mode

    @controller_service_mode.setter
    def controller_service_mode(self, controller_service_mode):
        """
        Sets the controller_service_mode of this DriveFirmwareCompatibilityResponse.
        Indicates if a Controller is in service mode

        :param controller_service_mode: The controller_service_mode of this DriveFirmwareCompatibilityResponse.
        :type: bool
        """
        self._controller_service_mode = controller_service_mode

    @property
    def simplex_mode(self):
        """
        Gets the simplex_mode of this DriveFirmwareCompatibilityResponse.
        Indicates if in simplex mode

        :return: The simplex_mode of this DriveFirmwareCompatibilityResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._simplex_mode

    @simplex_mode.setter
    def simplex_mode(self, simplex_mode):
        """
        Sets the simplex_mode of this DriveFirmwareCompatibilityResponse.
        Indicates if in simplex mode

        :param simplex_mode: The simplex_mode of this DriveFirmwareCompatibilityResponse.
        :type: bool
        """
        self._simplex_mode = simplex_mode

    @property
    def compatibilities(self):
        """
        Gets the compatibilities of this DriveFirmwareCompatibilityResponse.
        The list of drive to firmware compatibility compatibilities

        :return: The compatibilities of this DriveFirmwareCompatibilityResponse.
        :rtype: list[DriveFirmwareCompatiblitySet]
        :required/optional: required
        """
        return self._compatibilities

    @compatibilities.setter
    def compatibilities(self, compatibilities):
        """
        Sets the compatibilities of this DriveFirmwareCompatibilityResponse.
        The list of drive to firmware compatibility compatibilities

        :param compatibilities: The compatibilities of this DriveFirmwareCompatibilityResponse.
        :type: list[DriveFirmwareCompatiblitySet]
        """
        self._compatibilities = compatibilities

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

