# coding: utf-8

"""
FirmwareCompatibilitySet.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FirmwareCompatibilitySet(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FirmwareCompatibilitySet - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'storage_device_id': 'str',  # (required parameter)
            'storage_device_wwn': 'str',  # (required parameter)
            'cfw_files': 'list[CFWPackageMetadata]',  # (required parameter)
            'nvsram_files': 'list[NvsramPackageMetadata]'
        }

        self.attribute_map = {
            'storage_device_id': 'storageDeviceId',  # (required parameter)
            'storage_device_wwn': 'storageDeviceWwn',  # (required parameter)
            'cfw_files': 'cfwFiles',  # (required parameter)
            'nvsram_files': 'nvsramFiles'
        }

        self._storage_device_id = None
        self._storage_device_wwn = None
        self._cfw_files = None
        self._nvsram_files = None

    @property
    def storage_device_id(self):
        """
        Gets the storage_device_id of this FirmwareCompatibilitySet.


        :return: The storage_device_id of this FirmwareCompatibilitySet.
        :rtype: str
        :required/optional: required
        """
        return self._storage_device_id

    @storage_device_id.setter
    def storage_device_id(self, storage_device_id):
        """
        Sets the storage_device_id of this FirmwareCompatibilitySet.


        :param storage_device_id: The storage_device_id of this FirmwareCompatibilitySet.
        :type: str
        """
        self._storage_device_id = storage_device_id

    @property
    def storage_device_wwn(self):
        """
        Gets the storage_device_wwn of this FirmwareCompatibilitySet.


        :return: The storage_device_wwn of this FirmwareCompatibilitySet.
        :rtype: str
        :required/optional: required
        """
        return self._storage_device_wwn

    @storage_device_wwn.setter
    def storage_device_wwn(self, storage_device_wwn):
        """
        Sets the storage_device_wwn of this FirmwareCompatibilitySet.


        :param storage_device_wwn: The storage_device_wwn of this FirmwareCompatibilitySet.
        :type: str
        """
        self._storage_device_wwn = storage_device_wwn

    @property
    def cfw_files(self):
        """
        Gets the cfw_files of this FirmwareCompatibilitySet.
        The list of compatible controller firmware files

        :return: The cfw_files of this FirmwareCompatibilitySet.
        :rtype: list[CFWPackageMetadata]
        :required/optional: required
        """
        return self._cfw_files

    @cfw_files.setter
    def cfw_files(self, cfw_files):
        """
        Sets the cfw_files of this FirmwareCompatibilitySet.
        The list of compatible controller firmware files

        :param cfw_files: The cfw_files of this FirmwareCompatibilitySet.
        :type: list[CFWPackageMetadata]
        """
        self._cfw_files = cfw_files

    @property
    def nvsram_files(self):
        """
        Gets the nvsram_files of this FirmwareCompatibilitySet.
        The list of compatible nvsram files

        :return: The nvsram_files of this FirmwareCompatibilitySet.
        :rtype: list[NvsramPackageMetadata]
        :required/optional: required
        """
        return self._nvsram_files

    @nvsram_files.setter
    def nvsram_files(self, nvsram_files):
        """
        Sets the nvsram_files of this FirmwareCompatibilitySet.
        The list of compatible nvsram files

        :param nvsram_files: The nvsram_files of this FirmwareCompatibilitySet.
        :type: list[NvsramPackageMetadata]
        """
        self._nvsram_files = nvsram_files

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

