# coding: utf-8

"""
FlashCacheCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FlashCacheCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FlashCacheCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'drive_refs': 'list[str]',  # (required parameter)
            'name': 'str',  
            'enable_existing_volumes': 'bool'
        }

        self.attribute_map = {
            'drive_refs': 'driveRefs',  # (required parameter)
            'name': 'name',  
            'enable_existing_volumes': 'enableExistingVolumes'
        }

        self._drive_refs = None
        self._name = None
        self._enable_existing_volumes = None

    @property
    def drive_refs(self):
        """
        Gets the drive_refs of this FlashCacheCreateRequest.
        A list of one or more drive refs belonging to SSD drives that will be utilized in the FlashCache

        :return: The drive_refs of this FlashCacheCreateRequest.
        :rtype: list[str]
        :required/optional: required
        """
        return self._drive_refs

    @drive_refs.setter
    def drive_refs(self, drive_refs):
        """
        Sets the drive_refs of this FlashCacheCreateRequest.
        A list of one or more drive refs belonging to SSD drives that will be utilized in the FlashCache

        :param drive_refs: The drive_refs of this FlashCacheCreateRequest.
        :type: list[str]
        """
        self._drive_refs = drive_refs

    @property
    def name(self):
        """
        Gets the name of this FlashCacheCreateRequest.
        The user label for the FlashCache

        :return: The name of this FlashCacheCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this FlashCacheCreateRequest.
        The user label for the FlashCache

        :param name: The name of this FlashCacheCreateRequest.
        :type: str
        """
        self._name = name

    @property
    def enable_existing_volumes(self):
        """
        Gets the enable_existing_volumes of this FlashCacheCreateRequest.
        If true, all existing volumes that are mapped will have flash cache enabled

        :return: The enable_existing_volumes of this FlashCacheCreateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._enable_existing_volumes

    @enable_existing_volumes.setter
    def enable_existing_volumes(self, enable_existing_volumes):
        """
        Sets the enable_existing_volumes of this FlashCacheCreateRequest.
        If true, all existing volumes that are mapped will have flash cache enabled

        :param enable_existing_volumes: The enable_existing_volumes of this FlashCacheCreateRequest.
        :type: bool
        """
        self._enable_existing_volumes = enable_existing_volumes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

