# coding: utf-8

"""
HostPortCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HostPortCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HostPortCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',  # (required parameter)
            'port': 'str',  # (required parameter)
            'label': 'str',  # (required parameter)
            'iscsi_chap_secret': 'str'
        }

        self.attribute_map = {
            'type': 'type',  # (required parameter)
            'port': 'port',  # (required parameter)
            'label': 'label',  # (required parameter)
            'iscsi_chap_secret': 'iscsiChapSecret'
        }

        self._type = None
        self._port = None
        self._label = None
        self._iscsi_chap_secret = None

    @property
    def type(self):
        """
        Gets the type of this HostPortCreateRequest.
        The type of host port to create.

        :return: The type of this HostPortCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this HostPortCreateRequest.
        The type of host port to create.

        :param type: The type of this HostPortCreateRequest.
        :type: str
        """
        allowed_values = ["notImplemented", "scsi", "fc", "sata", "sas", "iscsi", "ib", "fcoe", "__UNDEFINED"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def port(self):
        """
        Gets the port of this HostPortCreateRequest.
        The host port identifier such as the iSCSI IQN or fibre channel WWN

        :return: The port of this HostPortCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._port

    @port.setter
    def port(self, port):
        """
        Sets the port of this HostPortCreateRequest.
        The host port identifier such as the iSCSI IQN or fibre channel WWN

        :param port: The port of this HostPortCreateRequest.
        :type: str
        """
        self._port = port

    @property
    def label(self):
        """
        Gets the label of this HostPortCreateRequest.
        The user-label for the host port

        :return: The label of this HostPortCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this HostPortCreateRequest.
        The user-label for the host port

        :param label: The label of this HostPortCreateRequest.
        :type: str
        """
        self._label = label

    @property
    def iscsi_chap_secret(self):
        """
        Gets the iscsi_chap_secret of this HostPortCreateRequest.
        Required password if host-side CHAP is enabled

        :return: The iscsi_chap_secret of this HostPortCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._iscsi_chap_secret

    @iscsi_chap_secret.setter
    def iscsi_chap_secret(self, iscsi_chap_secret):
        """
        Sets the iscsi_chap_secret of this HostPortCreateRequest.
        Required password if host-side CHAP is enabled

        :param iscsi_chap_secret: The iscsi_chap_secret of this HostPortCreateRequest.
        :type: str
        """
        self._iscsi_chap_secret = iscsi_chap_secret

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

