# coding: utf-8

"""
HostPortUpdateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HostPortUpdateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HostPortUpdateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'port_ref': 'str',  # (required parameter)
            'host_ref': 'str',  
            'port': 'str',  
            'label': 'str',  
            'iscsi_chap_secret': 'str'
        }

        self.attribute_map = {
            'port_ref': 'portRef',  # (required parameter)
            'host_ref': 'hostRef',  
            'port': 'port',  
            'label': 'label',  
            'iscsi_chap_secret': 'iscsiChapSecret'
        }

        self._port_ref = None
        self._host_ref = None
        self._port = None
        self._label = None
        self._iscsi_chap_secret = None

    @property
    def port_ref(self):
        """
        Gets the port_ref of this HostPortUpdateRequest.
        The ref/id of the HostPort or Initiator

        :return: The port_ref of this HostPortUpdateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._port_ref

    @port_ref.setter
    def port_ref(self, port_ref):
        """
        Sets the port_ref of this HostPortUpdateRequest.
        The ref/id of the HostPort or Initiator

        :param port_ref: The port_ref of this HostPortUpdateRequest.
        :type: str
        """
        self._port_ref = port_ref

    @property
    def host_ref(self):
        """
        Gets the host_ref of this HostPortUpdateRequest.
        The new owning host.

        :return: The host_ref of this HostPortUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._host_ref

    @host_ref.setter
    def host_ref(self, host_ref):
        """
        Sets the host_ref of this HostPortUpdateRequest.
        The new owning host.

        :param host_ref: The host_ref of this HostPortUpdateRequest.
        :type: str
        """
        self._host_ref = host_ref

    @property
    def port(self):
        """
        Gets the port of this HostPortUpdateRequest.
        The host port identifier such as the iSCSI IQN or fibre channel WWN

        :return: The port of this HostPortUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._port

    @port.setter
    def port(self, port):
        """
        Sets the port of this HostPortUpdateRequest.
        The host port identifier such as the iSCSI IQN or fibre channel WWN

        :param port: The port of this HostPortUpdateRequest.
        :type: str
        """
        self._port = port

    @property
    def label(self):
        """
        Gets the label of this HostPortUpdateRequest.
        The user-label for the host port

        :return: The label of this HostPortUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this HostPortUpdateRequest.
        The user-label for the host port

        :param label: The label of this HostPortUpdateRequest.
        :type: str
        """
        self._label = label

    @property
    def iscsi_chap_secret(self):
        """
        Gets the iscsi_chap_secret of this HostPortUpdateRequest.
        Required password if host-side CHAP is enabled

        :return: The iscsi_chap_secret of this HostPortUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._iscsi_chap_secret

    @iscsi_chap_secret.setter
    def iscsi_chap_secret(self, iscsi_chap_secret):
        """
        Sets the iscsi_chap_secret of this HostPortUpdateRequest.
        Required password if host-side CHAP is enabled

        :param iscsi_chap_secret: The iscsi_chap_secret of this HostPortUpdateRequest.
        :type: str
        """
        self._iscsi_chap_secret = iscsi_chap_secret

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

