# coding: utf-8

"""
OperationProgress.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class OperationProgress(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        OperationProgress - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'volume_ref': 'str',  # (required parameter)
            'current_action': 'str',  # (required parameter)
            'progress_percentage': 'int',  # (required parameter)
            'estimated_time_to_completion': 'int'
        }

        self.attribute_map = {
            'volume_ref': 'volumeRef',  # (required parameter)
            'current_action': 'currentAction',  # (required parameter)
            'progress_percentage': 'progressPercentage',  # (required parameter)
            'estimated_time_to_completion': 'estimatedTimeToCompletion'
        }

        self._volume_ref = None
        self._current_action = None
        self._progress_percentage = None
        self._estimated_time_to_completion = None

    @property
    def volume_ref(self):
        """
        Gets the volume_ref of this OperationProgress.


        :return: The volume_ref of this OperationProgress.
        :rtype: str
        :required/optional: required
        """
        return self._volume_ref

    @volume_ref.setter
    def volume_ref(self, volume_ref):
        """
        Sets the volume_ref of this OperationProgress.


        :param volume_ref: The volume_ref of this OperationProgress.
        :type: str
        """
        self._volume_ref = volume_ref

    @property
    def current_action(self):
        """
        Gets the current_action of this OperationProgress.


        :return: The current_action of this OperationProgress.
        :rtype: str
        :required/optional: required
        """
        return self._current_action

    @current_action.setter
    def current_action(self, current_action):
        """
        Sets the current_action of this OperationProgress.


        :param current_action: The current_action of this OperationProgress.
        :type: str
        """
        allowed_values = ["none", "copyback", "initializing", "reconstructing", "remappingDce", "remappingDrm", "remappingDcedrm", "remappingDseg", "remappingDve", "remappingDcedve", "remappingInternal", "remappingDefrag", "formatting", "synchronizing", "parityScan", "volumeCopy", "snapshotRollback", "pitRollback", "asyncMirrorGroupInitialSync", "reconstructingCritical", "rebalancing", "copyThenFail", "copyThenFailPending", "copyThenReplace", "copyThenReplaceAndFail", "thinDefrag", "creating", "deleting", "__UNDEFINED"]
        if current_action not in allowed_values:
            raise ValueError(
                "Invalid value for `current_action`, must be one of {0}"
                .format(allowed_values)
            )
        self._current_action = current_action

    @property
    def progress_percentage(self):
        """
        Gets the progress_percentage of this OperationProgress.


        :return: The progress_percentage of this OperationProgress.
        :rtype: int
        :required/optional: required
        """
        return self._progress_percentage

    @progress_percentage.setter
    def progress_percentage(self, progress_percentage):
        """
        Sets the progress_percentage of this OperationProgress.


        :param progress_percentage: The progress_percentage of this OperationProgress.
        :type: int
        """
        self._progress_percentage = progress_percentage

    @property
    def estimated_time_to_completion(self):
        """
        Gets the estimated_time_to_completion of this OperationProgress.


        :return: The estimated_time_to_completion of this OperationProgress.
        :rtype: int
        :required/optional: required
        """
        return self._estimated_time_to_completion

    @estimated_time_to_completion.setter
    def estimated_time_to_completion(self, estimated_time_to_completion):
        """
        Sets the estimated_time_to_completion of this OperationProgress.


        :param estimated_time_to_completion: The estimated_time_to_completion of this OperationProgress.
        :type: int
        """
        self._estimated_time_to_completion = estimated_time_to_completion

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

