# coding: utf-8

"""
SupportDataRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SupportDataRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SupportDataRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',  # (required parameter)
            'filename': 'str',  # (required parameter)
            'trace_spec': 'TraceBufferSpec',  
            'drive_spec': 'DriveRefList',  
            'save_config_spec': 'SaveConfigSpec'
        }

        self.attribute_map = {
            'type': 'type',  # (required parameter)
            'filename': 'filename',  # (required parameter)
            'trace_spec': 'traceSpec',  
            'drive_spec': 'driveSpec',  
            'save_config_spec': 'saveConfigSpec'
        }

        self._type = None
        self._filename = None
        self._trace_spec = None
        self._drive_spec = None
        self._save_config_spec = None

    @property
    def type(self):
        """
        Gets the type of this SupportDataRequest.
        The name of the file to be retrieved.

        :return: The type of this SupportDataRequest.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this SupportDataRequest.
        The name of the file to be retrieved.

        :param type: The type of this SupportDataRequest.
        :type: str
        """
        allowed_values = ["driveData", "traceBuffers", "ioPathStatistics", "supportBundle", "coreDump", "storageArrayConfiguration", "deviceProfile", "firmwareInventory", "unreadableSectors", "iscsiSessionsConnections"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def filename(self):
        """
        Gets the filename of this SupportDataRequest.
        Specify the name of the file, which will be utilized if it doesn't already exist.

        :return: The filename of this SupportDataRequest.
        :rtype: str
        :required/optional: required
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """
        Sets the filename of this SupportDataRequest.
        Specify the name of the file, which will be utilized if it doesn't already exist.

        :param filename: The filename of this SupportDataRequest.
        :type: str
        """
        self._filename = filename

    @property
    def trace_spec(self):
        """
        Gets the trace_spec of this SupportDataRequest.
        Specifies the controllers to retrieve data from for type=traceBuffers

        :return: The trace_spec of this SupportDataRequest.
        :rtype: TraceBufferSpec
        :required/optional: optional
        """
        return self._trace_spec

    @trace_spec.setter
    def trace_spec(self, trace_spec):
        """
        Sets the trace_spec of this SupportDataRequest.
        Specifies the controllers to retrieve data from for type=traceBuffers

        :param trace_spec: The trace_spec of this SupportDataRequest.
        :type: TraceBufferSpec
        """
        self._trace_spec = trace_spec

    @property
    def drive_spec(self):
        """
        Gets the drive_spec of this SupportDataRequest.
        Specifies the drives to retrieve logs for for type=driveData

        :return: The drive_spec of this SupportDataRequest.
        :rtype: DriveRefList
        :required/optional: optional
        """
        return self._drive_spec

    @drive_spec.setter
    def drive_spec(self, drive_spec):
        """
        Sets the drive_spec of this SupportDataRequest.
        Specifies the drives to retrieve logs for for type=driveData

        :param drive_spec: The drive_spec of this SupportDataRequest.
        :type: DriveRefList
        """
        self._drive_spec = drive_spec

    @property
    def save_config_spec(self):
        """
        Gets the save_config_spec of this SupportDataRequest.
        Specifies the settings for type=storageArrayConfiguration

        :return: The save_config_spec of this SupportDataRequest.
        :rtype: SaveConfigSpec
        :required/optional: optional
        """
        return self._save_config_spec

    @save_config_spec.setter
    def save_config_spec(self, save_config_spec):
        """
        Sets the save_config_spec of this SupportDataRequest.
        Specifies the settings for type=storageArrayConfiguration

        :param save_config_spec: The save_config_spec of this SupportDataRequest.
        :type: SaveConfigSpec
        """
        self._save_config_spec = save_config_spec

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

