# coding: utf-8

"""
SupportDataResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SupportDataResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SupportDataResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'request_id': 'int',  
            'progress': 'Progress',  
            'size_in_bytes': 'int',  
            'type': 'str',  
            'filename': 'str'
        }

        self.attribute_map = {
            'request_id': 'requestId',  
            'progress': 'progress',  
            'size_in_bytes': 'sizeInBytes',  
            'type': 'type',  
            'filename': 'filename'
        }

        self._request_id = None
        self._progress = None
        self._size_in_bytes = None
        self._type = None
        self._filename = None

    @property
    def request_id(self):
        """
        Gets the request_id of this SupportDataResponse.
        A unique identifier for the request

        :return: The request_id of this SupportDataResponse.
        :rtype: int
        :required/optional: optional
        """
        return self._request_id

    @request_id.setter
    def request_id(self, request_id):
        """
        Sets the request_id of this SupportDataResponse.
        A unique identifier for the request

        :param request_id: The request_id of this SupportDataResponse.
        :type: int
        """
        self._request_id = request_id

    @property
    def progress(self):
        """
        Gets the progress of this SupportDataResponse.
        The progress of the operation.

        :return: The progress of this SupportDataResponse.
        :rtype: Progress
        :required/optional: optional
        """
        return self._progress

    @progress.setter
    def progress(self, progress):
        """
        Sets the progress of this SupportDataResponse.
        The progress of the operation.

        :param progress: The progress of this SupportDataResponse.
        :type: Progress
        """
        self._progress = progress

    @property
    def size_in_bytes(self):
        """
        Gets the size_in_bytes of this SupportDataResponse.
        The size of the support file

        :return: The size_in_bytes of this SupportDataResponse.
        :rtype: int
        :required/optional: optional
        """
        return self._size_in_bytes

    @size_in_bytes.setter
    def size_in_bytes(self, size_in_bytes):
        """
        Sets the size_in_bytes of this SupportDataResponse.
        The size of the support file

        :param size_in_bytes: The size_in_bytes of this SupportDataResponse.
        :type: int
        """
        self._size_in_bytes = size_in_bytes

    @property
    def type(self):
        """
        Gets the type of this SupportDataResponse.
        The type of support data being collected.

        :return: The type of this SupportDataResponse.
        :rtype: str
        :required/optional: optional
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this SupportDataResponse.
        The type of support data being collected.

        :param type: The type of this SupportDataResponse.
        :type: str
        """
        allowed_values = ["driveData", "traceBuffers", "ioPathStatistics", "supportBundle", "coreDump", "storageArrayConfiguration", "deviceProfile", "firmwareInventory", "unreadableSectors", "iscsiSessionsConnections"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def filename(self):
        """
        Gets the filename of this SupportDataResponse.
        The name of the file to be retrieved.

        :return: The filename of this SupportDataResponse.
        :rtype: str
        :required/optional: optional
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """
        Sets the filename of this SupportDataResponse.
        The name of the file to be retrieved.

        :param filename: The filename of this SupportDataResponse.
        :type: str
        """
        self._filename = filename

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

