# coding: utf-8

"""
UnreadableSectorEntryResult.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class UnreadableSectorEntryResult(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        UnreadableSectorEntryResult - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'drive_ref': 'str',  
            'record_type': 'str',  
            'slot_no': 'int',  
            'tray_no': 'int',  
            'volume_lba': 'int',  
            'drive_lba': 'int',  
            'volume_ref': 'str',  
            'time_stamp': 'int'
        }

        self.attribute_map = {
            'drive_ref': 'driveRef',  
            'record_type': 'recordType',  
            'slot_no': 'slotNo',  
            'tray_no': 'trayNo',  
            'volume_lba': 'volumeLBA',  
            'drive_lba': 'driveLBA',  
            'volume_ref': 'volumeRef',  
            'time_stamp': 'timeStamp'
        }

        self._drive_ref = None
        self._record_type = None
        self._slot_no = None
        self._tray_no = None
        self._volume_lba = None
        self._drive_lba = None
        self._volume_ref = None
        self._time_stamp = None

    @property
    def drive_ref(self):
        """
        Gets the drive_ref of this UnreadableSectorEntryResult.


        :return: The drive_ref of this UnreadableSectorEntryResult.
        :rtype: str
        :required/optional: optional
        """
        return self._drive_ref

    @drive_ref.setter
    def drive_ref(self, drive_ref):
        """
        Sets the drive_ref of this UnreadableSectorEntryResult.


        :param drive_ref: The drive_ref of this UnreadableSectorEntryResult.
        :type: str
        """
        self._drive_ref = drive_ref

    @property
    def record_type(self):
        """
        Gets the record_type of this UnreadableSectorEntryResult.


        :return: The record_type of this UnreadableSectorEntryResult.
        :rtype: str
        :required/optional: optional
        """
        return self._record_type

    @record_type.setter
    def record_type(self, record_type):
        """
        Sets the record_type of this UnreadableSectorEntryResult.


        :param record_type: The record_type of this UnreadableSectorEntryResult.
        :type: str
        """
        allowed_values = ["physical", "logical", "injected", "edcError", "inconsistent", "piError", "__UNDEFINED"]
        if record_type not in allowed_values:
            raise ValueError(
                "Invalid value for `record_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._record_type = record_type

    @property
    def slot_no(self):
        """
        Gets the slot_no of this UnreadableSectorEntryResult.


        :return: The slot_no of this UnreadableSectorEntryResult.
        :rtype: int
        :required/optional: optional
        """
        return self._slot_no

    @slot_no.setter
    def slot_no(self, slot_no):
        """
        Sets the slot_no of this UnreadableSectorEntryResult.


        :param slot_no: The slot_no of this UnreadableSectorEntryResult.
        :type: int
        """
        self._slot_no = slot_no

    @property
    def tray_no(self):
        """
        Gets the tray_no of this UnreadableSectorEntryResult.


        :return: The tray_no of this UnreadableSectorEntryResult.
        :rtype: int
        :required/optional: optional
        """
        return self._tray_no

    @tray_no.setter
    def tray_no(self, tray_no):
        """
        Sets the tray_no of this UnreadableSectorEntryResult.


        :param tray_no: The tray_no of this UnreadableSectorEntryResult.
        :type: int
        """
        self._tray_no = tray_no

    @property
    def volume_lba(self):
        """
        Gets the volume_lba of this UnreadableSectorEntryResult.


        :return: The volume_lba of this UnreadableSectorEntryResult.
        :rtype: int
        :required/optional: optional
        """
        return self._volume_lba

    @volume_lba.setter
    def volume_lba(self, volume_lba):
        """
        Sets the volume_lba of this UnreadableSectorEntryResult.


        :param volume_lba: The volume_lba of this UnreadableSectorEntryResult.
        :type: int
        """
        self._volume_lba = volume_lba

    @property
    def drive_lba(self):
        """
        Gets the drive_lba of this UnreadableSectorEntryResult.


        :return: The drive_lba of this UnreadableSectorEntryResult.
        :rtype: int
        :required/optional: optional
        """
        return self._drive_lba

    @drive_lba.setter
    def drive_lba(self, drive_lba):
        """
        Sets the drive_lba of this UnreadableSectorEntryResult.


        :param drive_lba: The drive_lba of this UnreadableSectorEntryResult.
        :type: int
        """
        self._drive_lba = drive_lba

    @property
    def volume_ref(self):
        """
        Gets the volume_ref of this UnreadableSectorEntryResult.


        :return: The volume_ref of this UnreadableSectorEntryResult.
        :rtype: str
        :required/optional: optional
        """
        return self._volume_ref

    @volume_ref.setter
    def volume_ref(self, volume_ref):
        """
        Sets the volume_ref of this UnreadableSectorEntryResult.


        :param volume_ref: The volume_ref of this UnreadableSectorEntryResult.
        :type: str
        """
        self._volume_ref = volume_ref

    @property
    def time_stamp(self):
        """
        Gets the time_stamp of this UnreadableSectorEntryResult.


        :return: The time_stamp of this UnreadableSectorEntryResult.
        :rtype: int
        :required/optional: optional
        """
        return self._time_stamp

    @time_stamp.setter
    def time_stamp(self, time_stamp):
        """
        Sets the time_stamp of this UnreadableSectorEntryResult.


        :param time_stamp: The time_stamp of this UnreadableSectorEntryResult.
        :type: int
        """
        self._time_stamp = time_stamp

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

