# coding: utf-8

"""
VolumeMappingCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class VolumeMappingCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        VolumeMappingCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'mappable_object_id': 'str',  # (required parameter)
            'target_id': 'str',  
            'lun': 'int'
        }

        self.attribute_map = {
            'mappable_object_id': 'mappableObjectId',  # (required parameter)
            'target_id': 'targetId',  
            'lun': 'lun'
        }

        self._mappable_object_id = None
        self._target_id = None
        self._lun = None

    @property
    def mappable_object_id(self):
        """
        Gets the mappable_object_id of this VolumeMappingCreateRequest.
        The mappable object such as a volume or snapshot volume.

        :return: The mappable_object_id of this VolumeMappingCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._mappable_object_id

    @mappable_object_id.setter
    def mappable_object_id(self, mappable_object_id):
        """
        Sets the mappable_object_id of this VolumeMappingCreateRequest.
        The mappable object such as a volume or snapshot volume.

        :param mappable_object_id: The mappable_object_id of this VolumeMappingCreateRequest.
        :type: str
        """
        self._mappable_object_id = mappable_object_id

    @property
    def target_id(self):
        """
        Gets the target_id of this VolumeMappingCreateRequest.
        The host group or a host for the volume mapping. If left null, the default host group will be used

        :return: The target_id of this VolumeMappingCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._target_id

    @target_id.setter
    def target_id(self, target_id):
        """
        Sets the target_id of this VolumeMappingCreateRequest.
        The host group or a host for the volume mapping. If left null, the default host group will be used

        :param target_id: The target_id of this VolumeMappingCreateRequest.
        :type: str
        """
        self._target_id = target_id

    @property
    def lun(self):
        """
        Gets the lun of this VolumeMappingCreateRequest.
        The LUN for the volume mapping.

        :return: The lun of this VolumeMappingCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._lun

    @lun.setter
    def lun(self, lun):
        """
        Sets the lun of this VolumeMappingCreateRequest.
        The LUN for the volume mapping.

        :param lun: The lun of this VolumeMappingCreateRequest.
        :type: int
        """
        self._lun = lun

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

